
Imports System.IO
Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Diagnostics


Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports BCb2b
Imports System.Data.SqlClient

'para pasar a pdf.
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.text.html
Imports iTextSharp.text.html.simpleparser
Imports iTextSharp.tool.xml
Imports System.Data.OracleClient
Imports System.Data.OleDb
Imports CTI.Utilities.Log

Partial Class _oferta_validar
    Inherits claseBase

    Private NOFE As String
    Private TIPOOFE As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private lineas As List(Of BCb2b.COferta_linOff)
    Private _trasaccion As IDbTransaction

    'PROPIEDADES
    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.NOFE
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOOFE
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property
    Private Property trasaccion As IDbTransaction
        Get
            Return _trasaccion
        End Get
        Set(value As IDbTransaction)
            _trasaccion = value
        End Set
    End Property
    'FIN PROPIEDADES

    'CARGAR DATOS
    Private Sub GestionarCalculosAsociados(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pConexion As String)
        Dim vCalc As New AMC_Proyectos_pkg.CCalculos()
        Dim vListadoCalculos As New ArrayList
        vListadoCalculos = pCabecera.prop_LISTADO_IDDISTRIBUCION
        If vListadoCalculos.Count = 0 Then 'Si los pierde lo obtenemos.
            vListadoCalculos = vCalc.DameCalculosDeOferta(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, pCabecera.prop_N_REVISION, "", pConexion)
        End If

        'Calculo asociado
        If vListadoCalculos.Count > 0 Then
            Dim vGgestcampaCod As String = ""
            lblCalculoAsoc.Text = ""
            For Each calculo As AMC_Proyectos_pkg.CCalculos In vListadoCalculos
                vGgestcampaCod = calculo.prop_idestudio.PadLeft(10, "0")
                Dim vObservacion As String = calculo.prop_observaciones
                lblCalculoAsoc.Text = lblCalculoAsoc.Text & vObservacion & ","
            Next
            lblCalculoAsoc.Text = lblCalculoAsoc.Text.Remove(lblCalculoAsoc.Text.LastIndexOf(","))
            lblCalculoAsoc.Text = vGgestcampaCod & " (" & lblCalculoAsoc.Text & ")"

            If vGgestcampaCod <> "" Then
                pCabecera.prop_LISTADO_IDDISTRIBUCION = vListadoCalculos
            Else
                lblcalcasoctitu.Visible = False
                lblCalculoAsoc.Visible = False
            End If

            lblatencion_confim_calc.Visible = True
            div_lblatencion_confim_calc.Visible = True
            lblatencion_confim_calc.Text = GetLocalResourceObject("lblAtenConfirCalc")
            If lblCalculoAsoc.Text <> "" Then
                lblatencion_confim_calc.Text = lblatencion_confim_calc.Text & " " & lblCalculoAsoc.Text
            End If
        Else
            lblcalcasoctitu.Visible = False
            lblCalculoAsoc.Visible = False
            lblatencion_confim_calc.Visible = False
            div_lblatencion_confim_calc.Visible = False
            lblatencion_confim_calc.Text = ""
        End If
    End Sub
    Private Sub CargarDatosCabecera(ByVal pCabecera As BCb2b.COferta_Cab, ByRef pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        pGgclipr = New BCb2b.ggclipr(pCabecera.prop_ggclipr_cod, pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_tip_Vc, pConexion)
        lblNombreCli.Text = pGgclipr.prop_NOMBRE
        lblRSocial.Text = pGgclipr.prop_RSOCIAL_COD
        Dim vRSocialOfe As New BCb2b.CRSOCIAL(pGgclipr.prop_RSOCIAL_COD, pConexion)
        lblRSocialNombre.Text = vRSocialOfe.PROP_NOMBRE
        comboModosEnvio.SelectedValue = pCabecera.prop_GGMENVIO_COD
        lblAgencia.Text = comboModosEnvio.SelectedItem.Text
        lblNOferta.Text = pCabecera.prop_N_OFE
        lblFOferta.Text = pCabecera.prop_F_OFE
        lblRefCli.Text = pCabecera.prop_su_ref_OFE
        lblSerie.Text = pCabecera.prop_ggofetip_Desc
        lblSerieCod.Text = pCabecera.prop_ggofetip_cod()
        lblatte.Text = pCabecera.prop_ATTE()
        lblEstado.Text = pCabecera.prop_ggestado_cod
        lblObservacion.Text = pCabecera.prop_OBSERVACION_dEFECTO
        lblRefCli.Text = pCabecera.prop_su_ref_OFE
        lblatte.Text = pCabecera.prop_ATTE
        lblObservacion.Text = pCabecera.prop_OBSERVACION_dEFECTO
        lblObservacion_pie.Text = pCabecera.prop_OBSERVACION_pie

        Dim Direnvio As New BCb2b.CDirecciones()
        Direnvio = pCabecera.prop_dir_envio()
        hfdirenvio.Value = Direnvio.PROP_COD
        lblDir.Text = Direnvio.PROP_DIR
        lblCP.Text = Direnvio.PROP_COD_POSTAL()
        lblProvi.Text = Direnvio.PROP_PROVI_NOM()
        lblPoblacion.Text = Direnvio.PROP_POBLAC_NOM()
        lblpais.Text = Direnvio.PROP_PAISES_nom()
        lblFax.Text = Direnvio.PROP_TELEFAX()
        lblTfono.Text = Direnvio.PROP_TELEFONOS()
        Dim uti As New BCb2b.Utilities()
        If uti.IsMobileBrowser() = True Then
            lblTfono.NavigateUrl = uti.DameMailtoTelefono(Direnvio.PROP_TELEFONOS())
            lblTfono.CssClass = ""
        Else
            lblTfono.NavigateUrl = ""
            lblTfono.CssClass = "HyperlinkSinStyles"
        End If
        lblObservacion.Text = pCabecera.prop_OBSERVACION_dEFECTO
    End Sub
    Private Sub CargarFormaPago(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        Dim vParam As New BCb2b.CParametros()
        Dim vFPagoCod As String = ""

        If vPerfiles.prop_TIPO_PERFIL = 0 Then 'ING o SVT
            'AMC_NE243. JCE. 07/06/16. FORMA DE PAGO INGENIERO. Pueden modificarla en la pantalla de crearoferta, por lo tanto seleccionamos la de la cabecera.
            vFPagoCod = pCabecera.prop_FORMA_DE_PAGO
        Else
            'LO HABITUAL
            If pGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or pGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
                vFPagoCod = vParam.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"), pConexion)
            Else
                vFPagoCod = pGgclipr.prop_forma_pago.PROP_COD
            End If
        End If

        Dim vFPago As New BCb2b.CFPago()
        vFPago.DameDatosFPago(vFPagoCod, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
        lblFormadepago.Text = vFPago.PROP_DESCRIP
    End Sub
    Private Sub CargarObservaciones(ByVal pEmpgrupoCod As String, ByVal pCabecera As BCb2b.COferta_Cab, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        'PREPARADO POR SI NO HAY AGENTE: INGENIEROS..
        Dim vGgcliprProv As String = ""
        Dim vGvagente As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            vGvagente = Session("agente")
            vGgcliprProv = vGvagente.prop_GGCLIPR_PROV
        Else
            vGvagente = New BCb2b.gvagente(pGgclipr.prop_GVAGENTE_COD, pEmpgrupoCod, 0)
            vGgcliprProv = vGvagente.prop_GGCLIPR_PROV
        End If

        Dim vGgcliprobs As New BCb2b.GGCLIPROBS(pCabecera.prop_EMPGRUPO_COD, ConfigurationManager.AppSettings("compra"), vGgcliprProv, ConfigurationManager.AppSettings("OBCA"), pConexion)
        txtObservacion_cabecera.Text = vGgcliprobs.PROP_COMENTARIO
        pCabecera.prop_OBSERVACION_cabecera = vGgcliprobs.PROP_COMENTARIO

        'observacion titulo
        Dim vParamEmp As New BCb2b.empparam(ConfigurationManager.AppSettings("GGOFECAB_GGOBSTIP_TITULO"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
        Dim vParamObs As String = vParamEmp.prop_VALOR
        Dim vGgOfeobsTitulo As New BCb2b.CObs_oferta(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOOFE, Me.NOFE, vParamObs, pConexion)
        lblTitulo.Text = vGgOfeobsTitulo.prop_OBSER
    End Sub
    Private Sub CargarListadoModosEnvio(ByVal pEmpgrupoCod As String, ByVal pConexion As String, ByVal pGgclipr As BCb2b.ggclipr, Optional ByVal idioma As String = "")
        Dim vGvagente As New BCb2b.gvagente()
        Try
            comboModosEnvio.Items.Clear()
            Dim vListaModosEnvio As New ArrayList
            Dim vArrayModosEnvio As Array

            'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)
            If Not Session("agente") Is Nothing Then
                vGvagente = Session("agente")
            Else
                vGvagente = New BCb2b.gvagente(pGgclipr.prop_GVAGENTE_COD, pEmpgrupoCod, 0)
            End If

            Dim valor As String = ""
            Dim obs As New BCb2b.GGCLIPROBS()
            valor = obs.DameObserAGEdeGGCLIPR(pEmpgrupoCod, vGvagente, pGgclipr.prop_COD, ConfigurationManager.AppSettings("OBME"), pConexion)

            Dim vTieneGgmenvioDef As Boolean = False
            If valor <> "" Then
                vArrayModosEnvio = Split(valor, ",")
                Dim i As Integer = 0
                For i = 0 To vArrayModosEnvio.Length - 1
                    Dim vGgmenvio As New BCb2b.CGGMenvio()
                    If idioma <> "" Then
                        vGgmenvio.DameDatosModoEnvio(vArrayModosEnvio(i), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                    Else
                        vGgmenvio = New BCb2b.CGGMenvio(vArrayModosEnvio(i))
                    End If
                    If vGgmenvio.PROP_cod = pGgclipr.prop_GGMENVIO_COD Then
                        vTieneGgmenvioDef = True
                    End If
                    vListaModosEnvio.Add(vGgmenvio)
                Next i
            Else
                '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
                Dim vGgmenvio As New BCb2b.CGGMenvio()
                If idioma <> "" Then
                    vGgmenvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                Else
                    vGgmenvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
                End If
                vListaModosEnvio.Add(vGgmenvio)
                '------FIN AMC_NE183-------
                If pGgclipr.prop_GGMENVIO_COD <> "" Then
                    Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                    MEnvioDefecto.DameDatosModoEnvio(pGgclipr.prop_GGMENVIO_COD, idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                    vListaModosEnvio.Add(MEnvioDefecto)
                    vTieneGgmenvioDef = True
                End If
            End If

            If vTieneGgmenvioDef = False Then
                Dim vModoEnvDef As New BCb2b.CGGMenvio(pGgclipr.prop_GGMENVIO_COD)
                vListaModosEnvio.Add(vModoEnvDef)
            End If

            comboModosEnvio.DataSource = vListaModosEnvio
            comboModosEnvio.DataTextField = "prop_descrip"
            comboModosEnvio.DataValueField = "prop_cod"
            comboModosEnvio.DataBind()
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.cargarListadoModosEnvio] cliente = {@cliente} agente = {@agente} ", pGgclipr, vGvagente)
        End Try

    End Sub
    'FIN CARGAR DATOS

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'HABILITAMOS LOS MENSAJES MODALES
        Dim vUti As New BCb2b.Utilities()
        vUti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))

        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Try
            'JCE. 16/09/2016. COMPROBAMOS QUE HAY CABECERA Y LINEAS, SINO REDIRIGIMOS.
            Dim vLineasOferta As New List(Of BCb2b.COferta_linOff)
            vLineasOferta = Session("lineasOferta")
            If Session("cabecera") Is Nothing Or vLineasOferta.Count = 0 Then
                Response.Redirect("OfertasConsulta.aspx")
            End If

            If Not Page.IsPostBack Then
                lblatencion_confim_calc.Visible = False
                div_lblatencion_confim_calc.Visible = False
                lblatencion_confim_calc.Text = ""

                Dim vOrigenPropGrupo, vOrigenPropEmpresa, vOrigenPropTipVc, vOrigenPropTipoOfeSel, vOrigenPropNOfeSel As String
                vOrigenPropGrupo = ""
                vOrigenPropEmpresa = ""
                vOrigenPropTipVc = ""
                vOrigenPropTipoOfeSel = ""
                vOrigenPropNOfeSel = ""

                Dim vOrigenLineas As New List(Of BCb2b.COferta_linOff)
                vOrigenLineas = Nothing

                If (Not Session("cliente") Is Nothing) Then
                    Me.lineas = Session("lineasOferta")

                    Dim vGgclipr As New BCb2b.ggclipr()
                    vGgclipr = Session("cliente")
                    Dim vLineasAux As New List(Of BCb2b.COferta_linOff)
                    Dim vCabecera As New BCb2b.COferta_Cab()
                    vCabecera = Session("cabecera")

                    Me.GRUPO = vEmpgrupoCod
                    Me.EMPRESA = vEmpCod
                    Me.TIPVC = vTipVc
                    Me.TIPOOFE = vCabecera.prop_ggofetip_cod
                    Me.NOFE = vCabecera.prop_N_OFE

                    Dim vNumLinea As Integer = 0
                    For Each vLinea As BCb2b.COferta_linOff In Me.lineas
                        If Not vLinea.prop_errorCosto And vLinea.prop_GAART_COD <> "" Then
                            'Controlo que no sea un error de costo y que la lnea no sea vacia por algn motivo.
                            vLinea.asignarNlin = vNumLinea
                            vLineasAux.Add(vLinea)
                            vNumLinea = vNumLinea + 1

                            'AQUI MIRO SI LA LINEA TIENE PREC ESPECIAL PARA PINTARLA DE OTRO COLOR.
                            'SI ES EL ARTICULO ESP NO SE INSERTARA COMO PRECIO ESPECIAL.
                            Try
                                If vLinea.prop_GAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And vLinea.prop_EQUI_UNPR = "" Then
                                    Dim vPrecioEspecial As New BCb2b.crearPrecioEspecial(vCabecera, vLinea)
                                    Dim vEsPrecNuevo As Boolean = vPrecioEspecial.dimeSiNuevoPrecEspecial(vEmpgrupoCod, vCabecera.prop_ggclipr_cod, vLinea.prop_GAART_COD, vLinea.prop_C_UNI1, vLinea.prop_I_NETOEMP)
                                    vLinea.prop_ES_PRECIO_ESP = vEsPrecNuevo
                                Else
                                    vLinea.prop_ES_PRECIO_ESP = False
                                End If
                            Catch ex As Exception
                                Log.Error(ex, "[OfertaValidar.dimeSiNuevoPrecEspecial] cab_ofe = {@cab_ofe} linea = {@linea} ", vCabecera, vLinea)
                            End Try
                        End If
                    Next

                    Me.lineas = vLineasAux
                    Session("lineasOferta") = Me.lineas

                    Dim vPrimeraLin As New BCb2b.COferta_linOff()
                    vPrimeraLin = Me.lineas(0)

                    RDP.DataSource = Session("lineasOferta")
                    If Not Page.IsPostBack Then
                        Try
                            'ERROR BINDEANDO SIN EL TRY
                            RDP.DataBind()
                        Catch ex As Exception
                        End Try
                    End If

                    CargarListadoModosEnvio(vEmpgrupoCod, vConexion, vGgclipr, Session("idioma_spyro"))
                    GestionarCalculosAsociados(vCabecera, vConexion)
                    CargarObservaciones(vEmpgrupoCod, vCabecera, vGgclipr, vConexion)
                    CargarFormaPago(vCabecera, vGgclipr, vConexion)
                    CargarDatosCabecera(vCabecera, vGgclipr, vConexion)
                Else
                    If (Not Session("agente") Is Nothing) Then
                        Response.Redirect("BusquedaClientes.aspx", False)
                    Else
                        Response.Redirect("~/Expirado.aspx", False)
                    End If
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Load]")
        End Try
    End Sub

    'FUNCIONES
    Private Function ValidarUsuario(ByVal pEmpgrupoCod As String, ByVal pUsuario As String, ByVal pPassword As String, ByRef pGvagente As BCb2b.gvagente, Optional ByVal pConexion As String = "") As Boolean
        Dim vEsValido As Boolean = False
        If Session("Usuario").prop_cod.ToString.ToUpper = txtLogin.Text.ToUpper Then
            Dim vPerfiles As New BCb2b.USUARIOS_B2B()
            vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            Dim vUsuario As New BCb2b.CUsrnom()
            Dim vUsuarioAux As New BCb2b.CUsuarios()
            If vPerfiles.prop_TIPO_PERFIL = 0 Then 'svt ind ing
                If Session("perfil_usuario") = "ING" Then
                    Dim RESULTADO As String = vUsuarioAux.es_ingeniero(pUsuario.ToUpper, pPassword.ToUpper, pConexion)
                    vEsValido = (RESULTADO <> "")
                ElseIf Session("perfil_usuario") = "IND" Then
                    Dim RESULTADO As String = vUsuarioAux.es_indoor(pUsuario.ToUpper, pPassword.ToUpper, pConexion)
                    vEsValido = (RESULTADO <> "")
                ElseIf Session("perfil_usuario") = "SVT" Then
                    vUsuario = New BCb2b.CUsrnom(Session("usuario").prop_cod)
                    pGvagente = New BCb2b.gvagente(vUsuario.PROP_COD, vUsuario.PROP_PASSWORD, pEmpgrupoCod, "S")
                    vEsValido = pGvagente.prop_validado And pGvagente.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            ElseIf vPerfiles.prop_TIPO_PERFIL = 1 Then 'dis y age
                If Session("perfil_usuario") = "DIS" Then
                    Dim RESULTADO As String = vUsuarioAux.es_agenteConDeposito(pUsuario.ToUpper, pPassword.ToUpper, Session("agente").prop_cod, pConexion)
                    vEsValido = (RESULTADO <> "")
                    pGvagente = Session("agente")
                Else
                    pGvagente = New BCb2b.gvagente(pUsuario.ToUpper, pPassword.ToUpper, pEmpgrupoCod, "N")
                    vEsValido = pGvagente.prop_validado And pGvagente.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            Else 'If vPerfiles.prop_TIPO_PERFIL = 2 Then 'cli
                vEsValido = False
                'Dim RESULTADO As String = vUsuarioAux.es_cliente(pUsuario.ToUpper, pPassword.ToUpper)
                'vEsValido = (RESULTADO <> "")
            End If
        End If

        Return vEsValido
    End Function
    Private Function ObtenerAgente(ByVal cliente As BCb2b.ggclipr) As Decimal
        Dim vGvagenteCod As Decimal = Nothing
        If Session("perfil_usuario") <> "CL" Then
            If Not Session("agente") Is Nothing Then
                vGvagenteCod = Session("agente").prop_cod()
            Else
                If cliente.prop_GVAGENTE_COD <> "" Then
                    vGvagenteCod = CDbl(cliente.prop_GVAGENTE_COD)
                End If
            End If
        End If
        Return vGvagenteCod
    End Function
    Private Sub GestionarFormaDePago(ByRef pCabecera As BCb2b.COferta_Cab, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        Dim vConexionole As IDbConnection = Conexion.ConexionBDSegunPerfil(Me)
        Dim vTransaccion As IDbTransaction
        vTransaccion = vConexionole.BeginTransaction

        'AMC_NE243. JCE. 07/06/16. Ingenieros pueden elegir fpago a convenir, clientes pc o pot con "A Convenir"
        Dim vRSoccondi As New BCb2b.CRSoccondi()
        'SI LA CABECERA VIENE SIN RSOCCONDI_COD PERO CON FORMA DE PAGO
        If pCabecera.prop_RSOCCONDI_COD = "" And pCabecera.prop_FORMA_DE_PAGO <> "" Then
            'BUSCAMOS EL RSOCCONDI_COD DE LA FORMA DE PAGO DEL CLIENTE
            vRSoccondi.RSOCCONDI_POR_FPAGO(pGgclipr.prop_RSOCIAL_COD, pCabecera.prop_FORMA_DE_PAGO, pConexion)
            If vRSoccondi.PROP_COD = "" Then
                'NO EXISTE RSOCCONDI CON LA FORMA DE PAGO SELECCIONADA, ASIQUE LA INSERTAMOS
                'BUSCAMOS UN NUEVO RSOCCONDI_COD QUE NO EXISTA: W, W1, W2 ...
                Dim vRSoccondiAConv As String = ConfigurationManager.AppSettings("COD_RSOCCONDI_A_COVENIR") 'W
                vRSoccondi.Nuevo(pGgclipr.prop_RSOCIAL_COD, vRSoccondiAConv, pConexion)
                Dim i As Integer = 1
                Do While vRSoccondi.PROP_COD <> "" Or i = 1
                    vRSoccondiAConv = ConfigurationManager.AppSettings("COD_RSOCCONDI_A_COVENIR") & i.ToString
                    vRSoccondi.Nuevo(pGgclipr.prop_RSOCIAL_COD, vRSoccondiAConv, pConexion)
                    i += 1
                Loop

                'INSERTAMOS
                vRSoccondi = New BCb2b.CRSoccondi(pGgclipr.prop_RSOCIAL_COD, pConexion)
                vRSoccondi.rsoccondi_insertar_transaction(vTransaccion, pCabecera.prop_FORMA_DE_PAGO, vRSoccondiAConv, "WEB")

                'COMPROBAMOS QUE HA INSERTADO BIEN OBTENIENDO EL RSOCCONDI_COD INSERTADO.
                vRSoccondi.RSOCCONDI_POR_FPAGO(pGgclipr.prop_RSOCIAL_COD, pCabecera.prop_FORMA_DE_PAGO, pConexion)
            End If
            pCabecera.prop_RSOCCONDI_COD = vRSoccondi.PROP_COD
        End If
        Session("cabecera") = pCabecera
    End Sub
    Private Sub CargarCabeceraOferta(ByVal pEmpCod As String, ByRef pCabecera As BCb2b.COferta_Cab, ByRef pGgclipr As BCb2b.ggclipr, ByVal pGvagenteCod As String, ByVal pConexion As String)
        'CAMBIO EL MODO DE ENVIO POR DEFECTO DEL CLIENTE PARA QUE A LA HORA DE INSERTAR COJA EL QUE A SELECCIONADO DEL COMBO DE MODOS DE ENVIO
        pGgclipr.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue

        If Session("cabecera") Is Nothing Then
            '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
            Dim vParam As New BCb2b.CParametros()
            Dim vValorParamFP As String = vParam.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"), pConexion)
            '-----------------------------------------------

            pCabecera = New BCb2b.COferta_Cab(pGgclipr, pEmpCod, lblSerieCod.Text, ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), pGvagenteCod, lblRefCli.Text, lblatte.Text, hfdirenvio.Value, "", vValorParamFP, lblNOferta.Text)
        Else
            pCabecera = Session("cabecera")
        End If

        lblNOferta.Text = pCabecera.prop_N_OFE
    End Sub
    Private Sub CrearCabeceraOferta(ByRef pCabecera As BCb2b.COferta_Cab, ByVal pLinea As BCb2b.COferta_linOff, ByVal pConexion As String)
        Dim vEsNueva As Boolean = (pCabecera.prop_N_OFE = "")
        If (vEsNueva) Then
            pCabecera.insertar_cabecera_oferta("N", pConexion)
        Else
            Dim vConexionOle As String = BCb2b.cconexion_ole.Conexion(pConexion)
            pCabecera.crearRevisionOferta(vConexionOle, pLinea.prop_N_OFE, lblRefCli.Text, lblatte.Text, lblRSocial.Text, hfdirenvio.Value, comboModosEnvio.SelectedValue)
        End If

        'AMC_NE243. JCE. 07/06/16. Modificar cabecera de la oferta con la forma de pago seleccionada.
        Dim vGgofecab As New BCb2b.GGOFECAB()
        vGgofecab.GGOFECAB_MODIFICA(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, pCabecera.prop_su_ref_OFE, pCabecera.prop_ATTE, pCabecera.prop_dir_envio.PROP_COD, "", "", "", pCabecera.prop_RSOCCONDI_COD, pCabecera.prop_GGMENVIO_COD, pConexion)
    End Sub
    Private Function InsertarLinea(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pLinea As BCb2b.COferta_linOff, ByVal pConexion As String) As Integer
        Dim vLineaOge As New BCb2b.COferta_lin()
        Try
            vLineaOge.insertar_linea_oferta(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, Nothing, pLinea.prop_GAART_COD, pLinea.prop_DESCRIP, pLinea.prop_C_UNI1, pLinea.prop_PR_PRECIO, Nothing, Nothing, pLinea.prop_GGCLIPR_COD, pLinea.prop_descuento_lin, pLinea.prop_C_UNIPR, pLinea.prop_GAUNITIP_PR, "", pConexion)
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.InsertarLineaOferta] cab = {@cab} lin = {@lin} ", pCabecera, pLinea)
            Throw
        End Try
        Return vLineaOge.prop_N_LIN
    End Function
    Private Sub ActualizarDescuentosLinea(ByVal cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff, ByVal pNLin As String, ByVal pConexion As String)
        'Actualizamos el descuento.
        Dim vLineaDto As New BCb2b.ggofedtol(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_serie, cabecera.prop_N_OFE, pNLin, "WEB", "S")
        vLineaDto.actualizar_dto_b2b(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_serie, cabecera.prop_N_OFE, pNLin, "WEB", linea.prop_descuento_B2B, pConexion)
    End Sub
    Private Sub ActualizarPlazoLinea(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pLinea As BCb2b.COferta_linOff, ByVal pNLin As String, ByVal pConexion As String)
        'Actualizamos el plazo
        Dim vPlazo As New ggxxxlobs(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, pNLin, ConfigurationManager.AppSettings("OBPZ"))
        vPlazo.GGXXXLOBS_INSERTAR(pLinea.prop_plazo, "O", pConexion)
    End Sub
    Private Sub InsertarTirasRollosLinea(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pLinea As BCb2b.COferta_linOff, ByVal pNLin As String, ByVal pConexion As String)
        'JCE. 05/09/2016. UNIFICADO CON PEDIDOS PARA QUE ESTN IGUAL. INSERTAMOS CLASIFICACIONES DE TIRAS Y ROLLOS.
        If (Not String.IsNullOrEmpty(pNLin)) Then
            InsertarTirasRollos(pLinea, pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, pNLin, "OFE", pConexion)
        End If
    End Sub
    Private Sub AsociarCalculos(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pConexion As String)
        Dim vListadoCalculos As New ArrayList
        vListadoCalculos = pCabecera.prop_LISTADO_IDDISTRIBUCION

        For Each vCalculo As AMC_Proyectos_pkg.CCalculos In vListadoCalculos
            Dim vIddistribucionCalculo As String = ""
            vIddistribucionCalculo = vCalculo.prop_iddistribucion

            'LLAMAMOS A AMC_ACTUALIZAR_ADISTRIBUCION PARA ASOCIAR EL CALCULO A LA OFERTA
            If vIddistribucionCalculo <> "" Then
                Dim vMensajeInfo, vMensajeError As String
                vMensajeInfo = ""
                vMensajeError = ""

                Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
                Dim vTransaccion As IDbTransaction
                vTransaccion = vConexionOle.BeginTransaction
                Try
                    Dim vNumRev As Integer = 0
                    If pCabecera.prop_N_OFE_REV.ToString <> "Null" And pCabecera.prop_N_OFE_REV.ToString <> "1" Then
                        vNumRev = pCabecera.prop_N_OFE_REV
                    Else
                        vNumRev = pCabecera.prop_N_REVISION
                    End If
                    AMC_ACTUALIZAR_ADISTRIBUCION_CS.AMC_ACTUALIZAR_ADISTRIBUCION_CS.AMC_ACTUALIZAR_ADISTRIBUCION(vTransaccion, vIddistribucionCalculo, pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, vNumRev, vMensajeInfo, vMensajeError)
                    vTransaccion.Commit()
                Catch ex As Exception
                    Log.Error(ex, "[OfertaValidar.AsociarOferta a Calculo] iddistribuci = {iddistribuci} cab = {@cab} ", vIddistribucionCalculo, pCabecera)
                    vTransaccion.Rollback()
                Finally
                    vTransaccion.Dispose()
                End Try
            End If
        Next
    End Sub
    Private Sub InsertarObservaciones(ByRef pCabecera As BCb2b.COferta_Cab, ByVal pConexion As String)
        Dim vObsPie As String = ""
        Dim vObsCab As String = ""
        Dim vParamObs As String = ""
        Dim vGgOfeObs As New BCb2b.CObs_oferta()
        Try
            'Inserto observacion parametrizada si no es vaca al crear la cabecera
            Dim vObsDef As String = lblObservacion.Text
            If Not (vObsDef = "") Then
                vGgOfeObs = New BCb2b.CObs_oferta(pCabecera, vObsDef, ConfigurationManager.AppSettings("Obs_defecto_ofertas"))
                vGgOfeObs.ggOFEobs_insertar(pConexion)

                pCabecera.prop_OBSERVACION_dEFECTO = vObsDef
            End If

            Dim vObsAUT As String = txtLogin.Text & " " & Now().ToString("dd/MM/yyyy HH:mm")
            vGgOfeObs = New BCb2b.CObs_oferta(pCabecera, vObsAUT, "AUT")
            vGgOfeObs.ggOFEobs_insertar(pConexion)

            'Inserto observacion pie oferta
            vObsPie = lblObservacion_pie.Text
            Dim vEmpParam As New BCb2b.empparam(ConfigurationManager.AppSettings("AMC_OFER_OBS_PIE"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            vParamObs = vEmpParam.prop_VALOR
            vGgOfeObs = New BCb2b.CObs_oferta(pCabecera, vObsPie, vParamObs)
            vGgOfeObs.ggOFEobs_insertar(pConexion)

            'Inserto observacion cabecera oferta. AMC_NE120
            vObsCab = txtObservacion_cabecera.Text
            vGgOfeObs = New BCb2b.CObs_oferta(pCabecera, vObsCab, ConfigurationManager.AppSettings("OBCA"))
            vGgOfeObs.ggOFEobs_insertar(pConexion)
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Insertar Observaciones] cab = {@cab} obs_pie = {obs_pie} obs_cab = {obs_cab} obs_param = {obs_param} ", pCabecera, vObsPie, vObsCab, vParamObs)
        End Try
    End Sub
    Private Sub ActualizarEstadoCabecera(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        'JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.
        Dim vEstadoAux As String = ConfigurationManager.AppSettings("ESTADO_ACTIVO")
        Dim vGgxxxcab As New BCb2b.GGXXXCAB(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pCabecera.prop_tip_Vc, pCabecera.prop_ggofetip_cod, pCabecera.prop_N_OFE, pGgclipr.prop_COD, OracleNumber.Null, vEstadoAux, pCabecera.prop_HIST_SN, Now.Date)
        vEstadoAux = vGgxxxcab.GGXXXCAB_CALCULA_ESTADO_GGXXXCAB(ConfigurationManager.AppSettings("Oferta"), pConexion)
        vGgxxxcab.GGXXXCAB_ACTUALIZA_ESTADO_CABECERA(vEstadoAux, ConfigurationManager.AppSettings("Oferta"), pConexion)
        'FIN JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.
    End Sub
    Private Function GenerarReportOferta(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pCabecera As BCb2b.COferta_Cab, ByVal pConexion As String) As String
        Dim vRutaOfe As String = ""
        Dim vNRev As String = ""
        Try
            Dim vRep As New BCb2b.CGeneraReport()
            vNRev = pCabecera.prop_N_OFE_REV
            If vNRev = "Null" Then
                vNRev = 1 'Si el campo es Null esque es nueva oferta y ponemos 1.
            End If

            Dim vMuestraTotalSn As String = "S"
            If Not Session("agente") Is Nothing Then
                Dim vGgcliclasi As New BCb2b.CGGCLICLASI(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), Session("agente").prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_PROV_TOTAL_OFER"), pConexion)
                If vGgcliclasi.PROP_GGCLASIF_COD <> "" Then
                    vMuestraTotalSn = vGgcliclasi.PROP_GGCLASIF_COD
                End If
            End If

            vRutaOfe = ConfigurationManager.AppSettings("pathlocal") & Now.Year & Now.Month & Now.Day & "_" & pCabecera.prop_ggclipr_cod & "_" & pCabecera.prop_ggofetip_cod & "_" & pCabecera.prop_N_OFE & "_" & vNRev & ".pdf"
            vRep.CB2B_GENERA_REPORT_OFERTA_REV(ConfigurationManager.AppSettings("ReportOfertas"), pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_emp_cod, pTipVc, pCabecera.prop_N_OFE, pCabecera.prop_ggofetip_cod, "S", ConfigurationManager.AppSettings("PlantillaRepOfe"), ConfigurationManager.AppSettings("Oferta"), vNRev, True, "S", vMuestraTotalSn)

        Catch ex As Exception
            'Error en la generacin del report 
            vRutaOfe = ""
            Log.Error(ex, "[OfertaValidar.GenerarReport] cab = {@cab} rev = {rev} ", pCabecera, vNRev)
        End Try

        Dim vFtp As New BCb2b.ftp()
        Dim vFichSubido As Boolean = vFtp.SUBIR_FICHERO_FTP_WAIT_X_SECS(ConfigurationManager.AppSettings("pathServFileDocs"), ConfigurationManager.AppSettings("Dir_Oferta"), ConfigurationManager.AppSettings("pathlocal"), vRutaOfe, ConfigurationManager.AppSettings("usuario_ftp"), ConfigurationManager.AppSettings("pass_ftp"), 10)
        If Not vFichSubido Then 'SI NO LO HA SUBIDO QUE NO INTENTE ADJUNTARLO PORQUE IGUAL DA FALLO.
            vRutaOfe = ""
        End If

        Return vRutaOfe
    End Function
    Private Sub EnviarEmail(ByVal pCabecera As BCb2b.COferta_Cab, ByVal pGgclipr As BCb2b.ggclipr, ByVal pGvagente As BCb2b.gvagente, ByVal pRutaOfe As String, ByVal pConexion As String)
        Dim vTitulo As String = ""
        Dim vCuerpo As String = ""
        Dim vMails As New CEnvio_Emails()
        Try
            'AQUI OBTENEMOS LOS MAIL DE LA CLASIFICACION CONFIRMS PARA MANDAR A QUIEN CORRESPONDA.
            vMails.DameDestinatarios(pCabecera.prop_EMPGRUPO_COD, pCabecera.prop_tip_Vc, ConfigurationManager.AppSettings("CLASI_NACION"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), pGgclipr.prop_COD, ConfigurationManager.AppSettings("TipoOfe"), pConexion)
            'AS OBTENGO LOS MAILS--> obtenerMailing.PROP_DESTINATARIOS

            If pCabecera.prop_N_OFE_REV.ToString <> "Null" Then
                If pCabecera.prop_N_OFE_REV > 1 Then
                    vTitulo = GetLocalResourceObject("lblRevision.Text").ToString() & " " & pCabecera.prop_N_OFE_REV & " " & GetLocalResourceObject("lblDe.Text").ToString()
                End If
            End If

            vTitulo = vTitulo & " " & GetLocalResourceObject("lblOfew.Text").ToString() & " " & Me.TIPOOFE & "/" & Me.NOFE & " " & GetLocalResourceObject("lbldesdeCli.Text").ToString() & " " & pGgclipr.prop_NOMBRE & " (" & pGgclipr.prop_COD & ")" & " " & GetLocalResourceObject("lblYel.Text").ToString() & " " & GetLocalResourceObject("lblAgente.Text").ToString() & " " & pGvagente.prop_NOMBRE.ToUpper & " (" & pGvagente.prop_COD & ")"
            vCuerpo = vTitulo

            Dim vMailing As New EnviarMail()
            Dim vEnviado As String = vMailing.SendMail_NET("", ConfigurationManager.AppSettings("EmailFrom"), vMails.PROP_DESTINATARIOS, vTitulo, vCuerpo, pRutaOfe)

        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Error Enviando Email] destino = {destino} titu = {titu} body = {body} ruta = {ruta} ", vMails.PROP_DESTINATARIOS, vTitulo, vCuerpo, pRutaOfe)
        End Try
    End Sub
    Private Sub CrearOferta(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pConexion As String)
        'FALTA TRANSACCIONAR.
        Dim vGvagente As New BCb2b.gvagente()
        Dim vEsValido As Boolean = ValidarUsuario(pEmpgrupoCod, txtLogin.Text, tboxClave.Text, vGvagente, pConexion)
        If vEsValido Then
            Try
                lblerrorLogin.Visible = False

                Dim vGgclipr As New BCb2b.ggclipr()
                vGgclipr = Session("cliente")
                Dim vGvagenteCod As Decimal = ObtenerAgente(vGgclipr)
                Dim vCabecera As New BCb2b.COferta_Cab()
                CargarCabeceraOferta(pEmpCod, vCabecera, vGgclipr, vGvagenteCod, pConexion)
                GestionarFormaDePago(vCabecera, vGgclipr, pConexion)

                Dim vNLinea As Integer = 0
                For Each vLinea As BCb2b.COferta_linOff In Session("lineasOferta")
                    If (vNLinea = 0) Then
                        CrearCabeceraOferta(vCabecera, vLinea, pConexion)
                    End If
                    Dim vNLin As String = InsertarLinea(vCabecera, vLinea, pConexion)
                    ActualizarDescuentosLinea(vCabecera, vLinea, vNLin, pConexion)
                    ActualizarPlazoLinea(vCabecera, vLinea, vNLin, pConexion)
                    InsertarTirasRollosLinea(vCabecera, vLinea, vNLin, pConexion)
                    vNLinea = vNLinea + 1
                Next

                AsociarCalculos(vCabecera, pConexion)
                InsertarObservaciones(vCabecera, pConexion)
                ActualizarEstadoCabecera(vCabecera, vGgclipr, pConexion)
                Dim RutaOfe As String = GenerarReportOferta(pEmpgrupoCod, pTipVc, vCabecera, pConexion)
                EnviarEmail(vCabecera, vGgclipr, vGvagente, RutaOfe, pConexion)

                Me.TIPOOFE = vCabecera.prop_serie
                Me.NOFE = vCabecera.prop_N_OFE
                Me.GRUPO = vCabecera.prop_EMPGRUPO_COD
                Me.EMPRESA = vCabecera.prop_emp_cod
                Me.TIPVC = vCabecera.prop_tip_Vc
                Server.Transfer("OfertaDetalle.aspx")
            Catch ex As Exception
                Log.Error(ex, "[OfertaValidar.CreandoOferta]")
                Modal.Show(Me, GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "MsgErrorGen"), "ALERT", 300, "", "CLIENT")
            End Try
        Else
            lblerrorLogin.Visible = True
        End If
    End Sub
    Private Sub InsertarTirasRollos(ByVal pLinea As COferta_linOff, ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgxxxtipCod As String, ByVal pNDocum As String, ByVal pNLin As String, ByVal pTipoOfePedAlb As String, ByVal pConexion As String)
        Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
        Dim vTransaccion As IDbTransaction
        vTransaccion = vConexionOle.BeginTransaction

        Try
            'INSERTAMOS CLASIS DE TIRAS Y ROLLOS
            'ANCHO,LARGO,N_TIRAS,TIRAS,N_ROLLOS,ROLLOS,M2,EQUI_UNPR
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_ANCHO"), "", pLinea.prop_ANCHO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_LARGO"), "", pLinea.prop_LARGO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_M2"), "", pLinea.prop_M2, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_EQUI_UNPR"), "", pLinea.prop_EQUI_UNPR, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_DESPERDICIO"), "", pLinea.prop_DESPERDICIO, "", True)

            'COMPROBAMOS PARAMETROS PARA INSERTAR CLASI UNMANUAL EN CASO DE QUE EL ARTICULO SEA TE TIRAS ROLLOS, NO ESTE EN
            'GACODBAR Y SEA DE UNIDAD UN
            Dim vGacodbar As New BCb2b.gacodbar()
            Dim vTieneRollos As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(pEmpgrupoCod, pLinea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("ROLL"), pConexion)
            Dim vTieneTiras As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(pEmpgrupoCod, pLinea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("TIRA"), pConexion)
            Dim vGaart As New BCb2b.gaart(pEmpgrupoCod, pLinea.prop_GAART_COD, pConexion)

            If Not vTieneRollos And Not vTieneTiras And vGaart.prop_GAUNITIP_UNI1 = "UN" Then
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_ROLLOS"), "", pLinea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_TIRAS"), "", pLinea.prop_TIRAS, "", False)
            Else
                'SI NO ES UN ARTICULO DE TIPO B (LOS RAROS, EJ: 26103) METEMOS N.TIRAS.
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_N_ROLLOS"), "", pLinea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_N_TIRAS"), "", pLinea.prop_TIRAS, "", False)
            End If

            vTransaccion.Commit()
        Catch ex As Exception
            vTransaccion.Rollback()
            Log.Error(ex, "[OfertaValidar.INSERTAR_TIRAS_ROLLOS] empgrup = {empgrup} emp = {emp} tip = {tip} tip_ofe = {tipofe} nofe = {nofe} numlin = {numlin} tipdocOfe = {tipdocOfe} lin = {@lin} ", pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, pLinea)
        Finally
            vTransaccion.Dispose()
        End Try
    End Sub
    'FIN FUNCIONES

    'CLICK BOTONES
    Protected Sub btnModificar_Click(sender As Object, e As EventArgs) Handles btnModificar.Click
        Response.Redirect("CrearOferta.aspx", True)
    End Sub
    Protected Sub btnValidar_Click(sender As Object, e As EventArgs) Handles btnValidar.Click
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        CrearOferta(vEmpgrupoCod, vEmpCod, vTipVc, vConexion)
    End Sub
    'FIN CLICK BOTONES

    'GESTION DE LINEAS
    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        RDP.DataBind()
    End Sub
    Protected Sub RDP_ItemDataBound(sender As Object, e As RepeaterItemEventArgs) Handles RDP.ItemDataBound
        'ESTO PINTA LOS PRECIOS ESPECIALES EN ROJO
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim vLineaOfe As BCb2b.COferta_linOff = e.Item.DataItem
            Dim lblUnidad As Label = e.Item.FindControl("lblUnidad")
            Dim lblcant As Label = e.Item.FindControl("lblcant")

            lblUnidad.Text = vLineaOfe.prop_GAUNITIP_UNI1
            If vLineaOfe.prop_GAUNITIP_PR <> "" And vLineaOfe.prop_C_UNIPR <> "" Then
                lblcant.Text = vLineaOfe.prop_C_UNIPR
                lblUnidad.Text = vLineaOfe.prop_GAUNITIP_PR
            End If

            lblcant.Text = CDbl(lblcant.Text).ToString ' para quitar los 4 decimales de la pag anterior.

            Dim vClasiTira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
            Dim vGaartclasi As New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), vLineaOfe.prop_GAART_COD, vClasiTira)
            Dim vEsTiraRollo As String = "N"
            vEsTiraRollo = vGaartclasi.prop_GACLASIF_COD
            If vEsTiraRollo = "" Then
                vEsTiraRollo = "N"
            End If

            'SI ES TIRA O ROLLO NO ES PRECIO ESPECIAL
            If vLineaOfe.prop_ES_PRECIO_ESP = True And vEsTiraRollo = "N" And CDbl(vLineaOfe.prop_I_NETOEMP) > 0 Then
                Dim lbl_prec_esp As Label = e.Item.FindControl("lblprec_esp")
                lbl_prec_esp.ForeColor = Color.Red
            End If
        End If
    End Sub
    'FIN GESTION DE LINEAS
End Class
