Imports System.IO
Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Diagnostics
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports BCb2b
Imports System.Data.SqlClient
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.text.html
Imports iTextSharp.text.html.simpleparser
Imports iTextSharp.tool.xml
Imports System.Data.OleDb
Imports System.Data.OracleClient
Imports CTI.Utilities.Log
Partial Class _Pedido_validar
    Inherits claseBase

    Private NPED As String
    Private TIPOPED As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private _trasaccion As IDbTransaction

    'PROPIEDADES
    Public ReadOnly Property PROP_N_PED_SEL() As String
        Get
            Return Me.NPED
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_PED_SEL() As String
        Get
            Return Me.TIPOPED
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property
    Private Property trasaccion As IDbTransaction
        Get
            Return _trasaccion
        End Get
        Set(value As IDbTransaction)
            _trasaccion = value
        End Set
    End Property
    'FIN PROPIEDADES

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim vParam As New BCb2b.CParametros()

        'HABILITAMOS LOS MENSAJES MODALES
        Dim vUti As New BCb2b.Utilities
        vUti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        vUti.CrearModalConfirm(Me, "PortesPagados", GetGlobalResourceObject("general", "MsgModalBtnConfirm"), GetLocalResourceObject("txtPortesCargados"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))
        vUti.CrearModalConfirmConValor(Me, "PedPrecioCero", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetLocalResourceObject("MsgPrecioCero"), hdn_con_precio_cero.ClientID, GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        Try
            'JCE. 16/09/2016. COMPROBAMOS QUE HAY CABECERA Y LINEAS, SINO REDIRIGIMOS.
            Dim vLineasPedido As New List(Of BCb2b.CLineaPedidoOff)
            vLineasPedido = Session("lineasPedido")
            If Session("cabeceraPed") Is Nothing Or vLineasPedido.Count = 0 Then
                Response.Redirect("PedidoConsulta.aspx")
            End If

            Dim vCabeceraPed As New CCabeceraPedido()
            vCabeceraPed = Session("cabeceraPed")

            Dim vGgclipr As New BCb2b.ggclipr(vCabeceraPed.prop_GGCLIPR_COD, vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_tip_vc, vConexion)
            If Not Page.IsPostBack Then
                hdn_con_precio_cero.Value = "N"

                ControlarQueCabYLinsNoNulo()

                div_lblerror.Visible = False
                txtRecargoPortes.Text = ""

                Dim vGvagente As New BCb2b.gvagente()
                Dim vGvagenteCod As String = ObtenerAgente(vEmpgrupoCod, vGgclipr, vGvagente)

                CargarListadoEmails(vEmpgrupoCod, vTipVc, vGvagenteCod, vGgclipr.prop_COD, vConexion)
                GestionarComisionesDescuentos(vCabeceraPed, vGvagente, vGgclipr, Session("perfil_usuario"), vConexion)
                CargarDocumentosTransporte(vEmpgrupoCod, vTipVc, vGgclipr.prop_COD, vConexion)

                If vGgclipr.prop_COD Then
                    Me.TIPVC = vTipVc
                    Dim vLineasPedAux As New List(Of BCb2b.CLineaPedidoOff)
                    Dim vGgcliprMor As New BCb2b.ggclipr()
                    Dim vParamMoroso As New BCb2b.empparam(ConfigurationManager.AppSettings("GGCLIPR_GGESTADO_MOROSO"), vEmpgrupoCod, vEmpCod, Session("USUARIOB2B").PROP_COD, vConexion)
                    Dim vEstadoMorosoCod As String = vParam.dame_param(ConfigurationManager.AppSettings("GGCLIPR_GGESTADO_MOROSO"), vConexion)
                    If (vGgcliprMor.cliente_moroso(vGgclipr.prop_COD, vEstadoMorosoCod)) Then
                        div_texto_moroso.Visible = True
                    Else
                        div_texto_moroso.Visible = False
                    End If

                    lblTotalPedido.Text = "0"
                    lblTotalPesoPedido.Text = "0"
                    For Each vLinea As BCb2b.CLineaPedidoOff In Session("lineasPedido")
                        If Not vLinea.prop_errorCosto And vLinea.prop_GAART_COD <> "" Then
                            If vLinea.prop_I_NETOEMP <> "" Then
                                lblTotalPedido.Text += CDbl(vLinea.prop_I_NETOEMP) 'PARA CALCULAR TOTAL PEDIDO.
                            End If

                            If vLinea.prop_PESO_LIN <> "" Then
                                lblTotalPesoPedido.Text = FormatNumber(CDbl(lblTotalPesoPedido.Text) + CDbl(vLinea.prop_PESO_LIN), 3) 'PARA CALCULAR TOTAL DEL PESO DEL PEDIDO.
                            End If
                            vLineasPedAux.Add(vLinea)

                            'AQUI MIRO SI LA LINEA TIENE PREC ESPECIAL PARA PINTARLA DE OTRO COLOR. SI ES EL ARTICULO ESP NO SE INSERTARA COMO PRECIO ESPECIAL.
                            Try
                                If vLinea.prop_GAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And Not EsPedidoPrecioCero(vLinea.prop_GGPEDTIP_COD, vConexion) And vLinea.prop_EQUI_UNPR = "" Then 'Cambiado: vLinea.prop_GGPEDTIP_COD <> ConfigurationManager.AppSettings("tipo_pedido_muestras") por cualquier pedido a precio 0
                                    Dim vPrecioEspecial As New BCb2b.crearPrecioEspecial(vCabeceraPed, vLinea)
                                    Dim vEsPrecNuevo As Boolean = vPrecioEspecial.dimeSiNuevoPrecEspecial(vCabeceraPed.prop_empgrupo_cod, vGgclipr.prop_COD, vLinea.prop_GAART_COD, vLinea.prop_C_UNI1, vLinea.prop_I_NETOEMP)
                                    vLinea.prop_ES_PRECIO_ESP = vEsPrecNuevo
                                Else
                                    vLinea.prop_ES_PRECIO_ESP = False
                                End If
                            Catch ex As Exception
                                MostrarError("dimeSiNuevoPrecEspecial", ex.Message)
                                Log.Error(ex, "[PedidoValidar.dimeSiNuevoPrecEspecial] cli = {@cli} lin = {@lin} ", vGgclipr, vLinea)
                            End Try
                        End If
                    Next
                    lblTotalPedido.Text = FormatNumber(lblTotalPedido.Text, 2)
                    Session("lineasPedido") = vLineasPedAux
                    Try
                        RDP.DataSource = Session("lineasPedido")
                        RDP.DataBind()
                    Catch ex As Exception
                        MostrarError("ERROR LOADING LINES", ex.Message.ToString)
                        Log.Error(ex, "[PedidoValidar. Error cargando lineas pedido.] lineas = {@lineas}", Session("lineasPedido"))
                    End Try

                    Dim vGgcliprCab As New BCb2b.ggclipr(vCabeceraPed.prop_GGCLIPR_COD, vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_tip_vc, vConexion)
                    CargarListadoPortes(vEmpgrupoCod, vGvagente, vCabeceraPed.prop_PORTPAG_SN, vConexion)
                    GestionarRecargoSegunPorte(vCabeceraPed, vGvagente.prop_GGCLIPR_PROV, vConexion)
                    GestionarTextoAlertaPortes(vCabeceraPed, vGvagente.prop_GGCLIPR_PROV, vConexion)
                    CargarListadoModosEnvio(vGgcliprCab.prop_GGMENVIO_COD, Session("idioma_spyro"), vConexion)
                    CargarDatosCabecera(vEmpgrupoCod, vTipVc, vGgcliprCab, vCabeceraPed, vConexion)

                    'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
                    GestionaSiSeriePrecCero(vConexion)

                    'Trazabilidad oferta
                    Dim vCabeceraOfe As New BCb2b.COferta_Cab()
                    If Not Session("cabecera") Is Nothing Then
                        vCabeceraOfe = Session("cabecera")
                    End If

                    If vCabeceraOfe.prop_ggofetip_cod <> "" And vCabeceraOfe.prop_N_OFE <> "" Then
                        'SI LA OFE ES UN ORDER INBOX CAMBIAMOS EL TEXTO DE LA ALERTA.
                        If vCabeceraOfe.prop_ggofetip_cod = vParam.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX"), vConexion) Then
                            lblatencion_confim_ofer.Text = GetLocalResourceObject("lblAtenConfirInbox")
                        Else
                            lblatencion_confim_ofer.Text = GetLocalResourceObject("lblAtenConfirOfe")
                        End If
                        lblatencion_confim_ofer.Text = lblatencion_confim_ofer.Text & " " & vCabeceraOfe.prop_ggofetip_cod & "-" & vCabeceraOfe.prop_N_OFE
                        If vCabeceraOfe.prop_su_ref_OFE <> "" Then
                            lblatencion_confim_ofer.Text = lblatencion_confim_ofer.Text & " (" & vCabeceraOfe.prop_su_ref_OFE & ")"
                        End If
                        div_lblatencion_confim_ofer.Visible = True
                    Else
                        div_lblatencion_confim_ofer.Visible = False
                    End If
                    'Dim obs As New BCb2b.CObs_pedido(origen_PROP_GRUPO, origen_PROP_EMPRESA, origen_PROP_TIPVC, origen_PROP_TIPO_PED_SEL, origen_PROP_N_PED_SEL, System.Configuration.ConfigurationManager.AppSettings("Obs_defecto_Ofertas"))
                Else
                    If (Not Session("agente") Is Nothing) Then
                        'Response.Redirect("SelCliente.aspx", False)
                        Response.Redirect("BusquedaClientes.aspx", False)
                    Else
                        'Response.Redirect("index.aspx", False)
                        Response.Redirect("~/Expirado.aspx", False)
                    End If
                End If

                CARGAR_TIPOS_CRE_CONTACTO(Session("idioma_spyro"), vConexion)
            End If
        Catch ex As Exception
            MostrarError("ERROR LOADING ORDER", ex.Message)
            Log.Error(ex, "[PedidoValidar.Load] cab = {@cab} lins = {@lins}", Session("cabeceraPed"), Session("lineasPedido"))
        End Try
    End Sub

    'OBTENER DATOS
    Private Sub CargarListadoEmails(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGvagenteCod As String, ByVal pGgcliprCod As String, ByVal pConexion As String)
        Dim vEmails As New BCb2b.CEnvio_Emails()
        Dim vListaEmailsCli, vListaEmailsCliTodos, vListaEmailsAge As New ArrayList

        If (Session("perfil_usuario") <> "CL") Then
            'JCE --> TIP VC = C PORQUE ES DEL PROVEEDOR
            vListaEmailsAge = vEmails.DameDestinatariosAgente(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), pGvagenteCod, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"), pConexion)
            If vListaEmailsAge.Count = 0 Then
                Dim vEmailContactNulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("MsgModalNoEmailAgen"), "", "")
                vListaEmailsAge.Add(vEmailContactNulo)
                GVEmailDis.Enabled = False
            Else
                GVEmailDis.Enabled = True
            End If
            'div_emails_agente.Visible = True
            GVEmailDis.Visible = True
            lblAsocAge.Visible = True

            observaciones_internas.Visible = True
            comboModosEnvio.Visible = True 'SI NO ES CLIENTE PUEDE CAMBIAR EL MODO DE ENVIO.
            lblAgencia.Visible = False
        Else
            observaciones_internas.Visible = False
            txtObservacion_interna.Text = ""
            'div_emails_agente.Visible = False
            GVEmailDis.Visible = False
            lblAsocAge.Visible = False

            observacione.Attributes.Add("class", "width_100 float_left")
            comboModosEnvio.Visible = False 'SI ES CLIENTE NO PUEDE CAMBIAR EL MODO DE ENVIO.
            lblAgencia.Visible = True
        End If

        'Dim emailsCli As New BCb2b.CEnvio_Emails()
        'JCE --> TIP VC = V PORQUE ES CLIENTE DE VENTAS
        vListaEmailsCli = vEmails.DameDestinatariosCliente(pEmpgrupoCod, pTipVc, pGgcliprCod, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"), pConexion)
        If vListaEmailsCli.Count = 0 Then
            Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("MsgModalNoEmailCli"), "", "")
            vListaEmailsCli.Add(emailcontactnulo)
            GVEmailCli.Enabled = False
        Else
            GVEmailCli.Enabled = True
        End If

        GVEmailCli.DataSource = vListaEmailsCli
        GVEmailCli.DataBind()
        GVEmailDis.DataSource = vListaEmailsAge
        GVEmailDis.DataBind()

        'AMC_NE255. Cargamos todos los contactos asociados al cliente.
        vListaEmailsCliTodos = vEmails.DameDestinatariosCliente(pEmpgrupoCod, pTipVc, pGgcliprCod, "", "", Session("idioma_spyro"), pConexion)
        If vListaEmailsCliTodos.Count = 0 Then
            Dim vEmailContactNulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("MsgModalNoEmailCli"), "", "")
            vListaEmailsCliTodos.Add(vEmailContactNulo)
            GVEmailCliT.Enabled = False
        Else
            GVEmailCliT.Enabled = True
        End If
        GVEmailCliT.DataSource = vListaEmailsCliTodos
        GVEmailCliT.DataBind()
    End Sub
    Protected Function ObtenerEmailsCliente() As String
        Dim correosCliSel As String = ""
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCli.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim name As String = row.Cells(3).Text
                    correosCliSel = correosCliSel & name & ","
                End If
            End If
        Next

        correosCliSel = correosCliSel & correosAdicionales.Text

        If correosCliSel <> "" Then
            If correosCliSel.Chars(correosCliSel.Length - 1) = "," Then
                correosCliSel = correosCliSel.Remove(correosCliSel.LastIndexOf(","))
            End If
        End If

        Return correosCliSel.ToLower
    End Function
    Protected Function ObtenerContactosCliCheckeados(ByVal pConexion As String) As ArrayList
        Dim correosCliSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCli.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then

                    Dim Pkey As DataKey = GVEmailCli.DataKeys(row.RowIndex)

                    Dim vRsocialCod As String = Pkey.Item("prop_rsocial_cod")
                    Dim vContactipCod As String = Pkey.Item("prop_tipocontacto")
                    Dim vNombre As String = Pkey.Item("prop_nombrecontacto")
                    Dim vCorreo As String = Pkey.Item("prop_destinatarios")

                    Dim cont As New BCb2b.CContactos(vRsocialCod, vContactipCod, vNombre, pConexion)
                    correosCliSel.Add(cont)
                End If
            End If
        Next
        Return correosCliSel
    End Function
    Protected Function ObtenerEmailsDisCheckeados() As String
        Dim correosDisSel As String = ""
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailDis.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim name As String = row.Cells(3).Text
                    correosDisSel = correosDisSel & name & ","
                End If
            End If
        Next
        If correosDisSel <> "" Then
            If correosDisSel.Chars(correosDisSel.Length - 1) = "," Then
                correosDisSel = correosDisSel.Remove(correosDisSel.LastIndexOf(","))
            End If
        End If
        Return correosDisSel.ToLower
    End Function
    Protected Function ObtenerContactosDisCheckeados(ByVal pGvagenteCod As String) As ArrayList
        Dim correosDisSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailDis.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim Pkey As DataKey = GVEmailDis.DataKeys(row.RowIndex)

                    Dim vRsocialCod As String = Pkey.Item("prop_rsocial_cod")
                    Dim vContactipCod As String = Pkey.Item("prop_tipocontacto")
                    Dim vNombre As String = Pkey.Item("prop_nombrecontacto")
                    Dim vCorreo As String = Pkey.Item("prop_destinatarios")


                    Dim cont As New BCb2b.CContactos()
                    cont.ContactosAgente(pGvagenteCod, vContactipCod, vNombre, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("CLASI_EMAIL_O"), "S")
                    correosDisSel.Add(cont)
                End If
            End If
        Next
        Return correosDisSel
    End Function
    Protected Function ObtenerContactosCliTodosCheckeados(ByVal pConexion As String) As ArrayList
        Dim correosCliSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCliT.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRowT"), CheckBox)
                If chkRow.Checked Then

                    Dim Pkey As DataKey = GVEmailCliT.DataKeys(row.RowIndex)

                    Dim vRsocialCod As String = Pkey.Item("prop_rsocial_cod")
                    Dim vContactipCod As String = Pkey.Item("prop_tipocontacto")
                    Dim vNombre As String = Pkey.Item("prop_nombrecontacto")
                    Dim vCorreo As String = Pkey.Item("prop_destinatarios")

                    Dim cont As New BCb2b.CContactos(vRsocialCod, vContactipCod, vNombre, pConexion)
                    correosCliSel.Add(cont)
                End If
            End If
        Next
        Return correosCliSel
    End Function
    Private Sub CargarDocumentosTransporte(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGgcliprCod As String, ByVal pConexion As String)
        Dim vRsocdir As New BCb2b.rsocdir()
        Dim vPaisCod As String = vRsocdir.pais_cliente(pEmpgrupoCod, pTipVc, pGgcliprCod, pConexion)
        Dim vRutaVirtual As String = ConfigurationManager.AppSettings("pathB2BAMCSADocs")

        'LOS FICHEROS ESTAN EN:
        '\\172.16.0.38\s$\Transporte

        Dim vNombreCarpeta As String = ConfigurationManager.AppSettings("DirecFichPedTrans")
        Dim vListaPdfs As ArrayList = New ArrayList

        Dim sArchivos() As String
        Dim vArchivoInfo As FileInfo
        Try
            sArchivos = Directory.GetFiles(vNombreCarpeta)
            Dim vNArchivos As Integer = sArchivos.Length
            If vNArchivos > 0 Then
                For Each archivo In sArchivos
                    vArchivoInfo = New FileInfo(archivo)
                    Dim vNomDoc As String = vArchivoInfo.Name.ToUpper
                    If vNomDoc.StartsWith(vPaisCod & "_") = True Then
                        vRutaVirtual = vNombreCarpeta & vNomDoc
                        If vNArchivos > 1 Then
                            vNomDoc = vNomDoc.Replace(vPaisCod & "_", "").ToUpper
                        Else
                            vNomDoc = GetLocalResourceObject("VerPrecTransport").ToString.ToUpper
                        End If
                        vRutaVirtual = vRutaVirtual.Replace(ConfigurationManager.AppSettings("rutaBaseFTPUpload"), ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
                        Dim pdf As New BCb2b.CDocumentos(vNomDoc, "", vRutaVirtual, "", "", "")
                        vListaPdfs.Add(pdf)
                    End If
                Next
                RepeaterPDFS.DataSource = vListaPdfs
                RepeaterPDFS.DataBind()
                RepeaterPDFS.Visible = True
            Else
                RepeaterPDFS.Visible = False
            End If
        Catch ex As Exception
            MostrarError("CARGA_DOCUMENTOS_TRANSPORTE", ex.Message)
            Log.Information(ex, "[PedidoValidar.ObtenerDocumentosPrecios] carpeta = {carpeta} ", vNombreCarpeta)
        End Try
    End Sub
    Private Sub CargarListadoComisiones(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGvagenteCod As String, ByVal pConexion As String)
        lblAplicComDesc.Text = GetLocalResourceObject("AplicarComiResource1.Text")
        Dim vListadoComisiones As New ArrayList()
        Dim vComi As New BCb2b.GGDTOESCAL()
        vListadoComisiones = vComi.LISTADO(pEmpgrupoCod, pTipVc, ConfigurationManager.AppSettings("CB2B"), pGvagenteCod, pConexion)
        GVComisionesDescu.DataSource = vListadoComisiones
        GVComisionesDescu.DataBind()
    End Sub
    Private Sub CargarListadoDescuentos(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGgcliprCod As String, ByVal pConexion As String)
        lblAplicComDesc.Text = GetLocalResourceObject("AplicarDescResource1.Text") 'Se aplicarn los siguientes descuentos
        Dim vListadoDescuentos As New ArrayList()
        Dim vDesc As New BCb2b.GGDTOESCAL()
        vListadoDescuentos = vDesc.LISTADO_CLI(pEmpgrupoCod, pTipVc, ConfigurationManager.AppSettings("DB2B"), pGgcliprCod, pConexion)
        GVComisionesDescu.DataSource = vListadoDescuentos
        GVComisionesDescu.DataBind()
    End Sub
    Private Sub CargarListadoPortes(ByVal pEmpgrupoCod As String, ByVal pGvagente As BCb2b.gvagente, ByVal pPortesSel As String, ByVal pConexion As String)
        Dim vClasiProve As New BCb2b.CGGCLICLASI()
        If pGvagente.prop_GGCLIPR_PROV <> "" Then
            vClasiProve = New BCb2b.CGGCLICLASI(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), pGvagente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"), pConexion)
        End If

        Dim vParam As New BCb2b.CParametros()
        Dim vCodPortes As String = vParam.dame_param(ConfigurationManager.AppSettings("PARAM_CODIGOS_PORTES"), pConexion)
        Dim vListadoPortes() As String = vCodPortes.Split(",")
        ddlPortes.Items.Clear()
        For Each vPorte As String In vListadoPortes
            Dim vPorteAux As New System.Web.UI.WebControls.ListItem(GetGlobalResourceObject("general", "PORTES" & vPorte), vPorte)
            ddlPortes.Items.Add(vPorteAux)
        Next

        If Not BCb2b.Listas.Existe(pPortesSel, vListadoPortes) Then 'Si los portes del cli no esta definido en el param, por defecto DEBIDOS
            pPortesSel = "N" 'Debidos
        End If
        hdn_portes_sel.Value = pPortesSel
        ddlPortes.SelectedValue = pPortesSel
        ddlPortes.DataBind()

        lblPortes.Text = GetGlobalResourceObject("general", "PORTES" & pPortesSel)

        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        If vClasiProve.PROP_VALOR <> "" And vPerfiles.prop_TIPO_PERFIL <> 2 Then
            lblPortes.Visible = False
        Else
            ddlPortes.Items.Clear()
            ddlPortes.DataBind()
            ddlPortes.Visible = False
            btnValidar.OnClientClick = ""
            btnValidar.CausesValidation = False
            btnValidar.DataBind()
        End If
    End Sub
    Private Sub CargarListadoModosEnvio(Optional ByVal menvio_def As String = "", Optional ByVal idioma As String = "", Optional ByVal pConexion As String = "")
        comboModosEnvio.Items.Clear()
        Dim listaModosEnvio As New ArrayList
        Dim arrayModosEnvio As Array

        'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)
        Dim cabeceraPed As New CCabeceraPedido()
        cabeceraPed = Session("cabeceraPed")

        Dim cli As New BCb2b.ggclipr(cabeceraPed.prop_GGCLIPR_COD, cabeceraPed.prop_empgrupo_cod, cabeceraPed.prop_tip_vc, pConexion)

        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            age = Session("agente")
        Else
            age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
        End If

        Dim valor As String = ""
        Dim obs As New BCb2b.GGCLIPROBS()
        valor = obs.DameObserAGEdeGGCLIPR(ConfigurationManager.AppSettings("grupo"), age, cli.prop_COD, ConfigurationManager.AppSettings("OBME"), pConexion)

        Dim tiene_el_ggmenvio_def As Boolean = False
        If valor <> "" Then
            arrayModosEnvio = Split(valor, ",")

            Dim i As Integer = 0
            For i = 0 To arrayModosEnvio.Length - 1

                Dim mEnvio As New BCb2b.CGGMenvio()
                If idioma <> "" Then
                    mEnvio.DameDatosModoEnvio(arrayModosEnvio(i), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                Else
                    mEnvio = New BCb2b.CGGMenvio(arrayModosEnvio(i))
                End If

                If mEnvio.PROP_cod = menvio_def Then
                    tiene_el_ggmenvio_def = True
                End If

                listaModosEnvio.Add(mEnvio)
            Next i
        Else
            '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
            Dim mEnvio As New BCb2b.CGGMenvio()
            If idioma <> "" Then
                mEnvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
            Else
                mEnvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
            End If
            listaModosEnvio.Add(mEnvio)
            '------FIN AMC_NE183-------
            If menvio_def <> "" Then
                Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                MEnvioDefecto.DameDatosModoEnvio(menvio_def, idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                listaModosEnvio.Add(MEnvioDefecto)
                tiene_el_ggmenvio_def = True
            End If
        End If

        If tiene_el_ggmenvio_def = False Then
            Dim modo_env_def As New BCb2b.CGGMenvio(menvio_def)
            listaModosEnvio.Add(modo_env_def)
        End If

        comboModosEnvio.DataSource = listaModosEnvio
        comboModosEnvio.DataTextField = "prop_descrip"
        comboModosEnvio.DataValueField = "prop_cod"
        comboModosEnvio.DataBind()
    End Sub
    Private Sub CARGAR_TIPOS_CRE_CONTACTO(Optional ByVal idioma As String = "", Optional ByVal pConexion As String = "")
        Try
            comboTipCont.Items.Clear()
            Dim listatipCont As New ArrayList
            Dim elem As New BCb2b.CTiposContacto
            listatipCont = elem.LISTA_TIPOS_CONTACTOS(idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_CONTACTIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_CONTACTIP"), pConexion)

            Dim tcontnulo As New BCb2b.CTiposContacto()
            listatipCont.Insert(0, tcontnulo)

            comboTipCont.DataSource = listatipCont
            comboTipCont.DataTextField = "prop_descrip"
            comboTipCont.DataValueField = "prop_cod"
            comboTipCont.DataBind()

            Dim cli As New BCb2b.ggclipr()
            cli = Session("cliente")
            Dim rsoc As New BCb2b.CRSOCIAL(cli.prop_RSOCIAL_COD, pConexion)

            'PREFIJOS CONTACTOS --> PONDREMOS EL PREFIJO DE LA DIR POR DEFECTO DE LA RAZON SOCIAL
            Dim dirDEF As New BCb2b.rsocdir(cli.prop_RSOCIAL_COD, rsoc.PROP_RSOCDIR_COD, pConexion)
            Dim paisCont As New BCb2b.CPaises()
            paisCont.nuevo(dirDEF.PROP_PAISES_COD, pConexion)

            Dim pretelcont, prefaxcont As String
            pretelcont = paisCont.prop_prefijo_tel
            prefaxcont = paisCont.prop_prefijo_tel

            Dim uti As New BCb2b.Utilities()
            uti.GestionarPrefijoTel(pretelcont, "")
            uti.GestionarPrefijoTel(prefaxcont, "")

            lblPrefijTelCont.Text = pretelcont
            lblPrefijFaxCont.Text = prefaxcont
        Catch ex As Exception
            Log.Error(ex, "[CrearCliente.cargarListadoTiposContacto]")
        End Try

    End Sub
    Private Function ObtenerAlmacenAsteasu(ByVal pConexion As String) As String
        Dim vParam As New BCb2b.CParametros()
        Return vParam.dame_param(ConfigurationManager.AppSettings("ALMACEN_POR_DEFECTO"), pConexion)
    End Function
    Private Sub CargarDatosCabecera(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGgclipr As BCb2b.ggclipr, ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pConexion As String)
        lblNombreCli.Text = pGgclipr.prop_NOMBRE
        'DOMICILIACION
        Dim datos_domic As New BCb2b.CCliente(pGgclipr.prop_COD, pEmpgrupoCod, pTipVc, pConexion)
        Dim dato As String = datos_domic.prop_domiciliacion.PROP_IBAN & " - " & datos_domic.prop_domiciliacion.prop_cuenta_bancaria
        lblDomiciliacion.Text = dato
        lblRSocial.Text = pGgclipr.prop_RSOCIAL_COD
        comboModosEnvio.SelectedValue = pCabeceraPed.prop_GGMENVIO_COD
        lblModosEnvio.Text = comboModosEnvio.SelectedItem.Text
        lblAgencia.Text = comboModosEnvio.SelectedItem.Text
        lblNPedido.Text = pCabeceraPed.prop_N_PEDIDO
        lblFPedido.Text = pCabeceraPed.prop_F_PED
        lblRefCli.Text = pCabeceraPed.prop_SU_REF_PED
        lblSerie.Text = pCabeceraPed.prop_GGPEDTIP_DESC()
        lblSerieCod.Text = pCabeceraPed.prop_GGPEDTIP_COD()
        lblatte.Text = pCabeceraPed.prop_ATTE()
        lblEstado.Text = pCabeceraPed.prop_GGESTADO_COD
        lblRefCli.Text = pCabeceraPed.prop_SU_REF_PED
        lblatte.Text = pCabeceraPed.prop_ATTE
        txtObservacion.Text = pCabeceraPed.prop_OBSERVACION_dEFECTO
        txtObservacion_interna.Text = pCabeceraPed.prop_OBSERVACION_interna

        Dim Direnvio As New BCb2b.CDirecciones()
        Direnvio = pCabeceraPed.prop_dir_envio()
        hfdirenvio.Value = Direnvio.PROP_COD
        lblNomDir.Text = Direnvio.PROP_nombre_dir
        lblDir.Text = Direnvio.PROP_DIR
        lblCP.Text = Direnvio.PROP_COD_POSTAL()
        lblProvi.Text = Direnvio.PROP_PROVI_NOM()
        lblPoblacion.Text = Direnvio.PROP_POBLAC_NOM()
        lblpais.Text = Direnvio.PROP_PAISES_nom()
        lblFax.Text = Direnvio.PROP_TELEFAX()
        lblTfono.Text = Direnvio.PROP_TELEFONOS()
        Dim uti As New BCb2b.Utilities()
        If uti.IsMobileBrowser() = True Then
            lblTfono.NavigateUrl = uti.DameMailtoTelefono(Direnvio.PROP_TELEFONOS())
            lblTfono.CssClass = ""
        Else
            lblTfono.NavigateUrl = ""
            lblTfono.CssClass = "HyperlinkSinStyles"
        End If

        'cargar forma de pago
        Dim forma_pago As New BCb2b.CFPago()
        forma_pago = pGgclipr.prop_forma_pago
        forma_pago.DameDatosFPago(forma_pago.PROP_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
        lblFormadepago.Text = forma_pago.PROP_DESCRIP
    End Sub
    'FIN OBTENER DATOS

    'CLICK BOTONES
    Protected Sub btnValidar_Click(sender As Object, e As EventArgs) Handles btnValidar.Click
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)

        Dim vCabeceraPed As New CCabeceraPedido()
        vCabeceraPed = Session("cabeceraPed")

        Dim vGgclipr As New BCb2b.ggclipr(vCabeceraPed.prop_GGCLIPR_COD, vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_tip_vc, vConexion)
        Dim vGvagente As New BCb2b.gvagente()
        Dim vGvagenteCod As String = ObtenerAgente(vEmpgrupoCod, vGgclipr, vGvagente)
        Dim vTieneQueSelecEmail As Boolean = ObligarASeleccionarEmail(vEmpgrupoCod, vGvagente, vConexion)
        Dim vRealizarPedido As Boolean = ComprobarSiRealizarPedido(vTieneQueSelecEmail)

        Dim vPedModificable As Boolean = False
        If vCabeceraPed.prop_empgrupo_cod <> "" And vCabeceraPed.prop_emp_cod <> "" And vCabeceraPed.prop_tip_vc <> "" And vCabeceraPed.prop_GGPEDTIP_COD <> "" And vCabeceraPed.prop_N_PEDIDO <> "" Then
            'ESTANDAR.
            vPedModificable = GGPEDCAB.PED_PERMITE_REV(vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_emp_cod, vCabeceraPed.prop_tip_vc, vCabeceraPed.prop_GGPEDTIP_COD, vCabeceraPed.prop_N_PEDIDO, vConexion)
            'AMC A MEDIDA.
            If vPedModificable Then
                vPedModificable = Not BCb2b_AMC.GGPEDCAB.PEDIDO_B2B_REVISADO_AMC(vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_emp_cod, vCabeceraPed.prop_tip_vc, vCabeceraPed.prop_GGPEDTIP_COD, vCabeceraPed.prop_N_PEDIDO, vConexion)
            End If
            If Not vPedModificable Then
                MostrarError(GetLocalResourceObject("error_no_modificable_etiqueta"), GetLocalResourceObject("error_no_modificable_descripcion"))
                vRealizarPedido = False
            End If
        End If
        'FIN COMPROBACION DE SI SE PUEDE HACER UNA REVISIN.

        If vRealizarPedido Then
            Dim vEsValido As Boolean = False
            vEsValido = ValidarUsuario(vEmpgrupoCod, txtLogin.Text, tboxClave.Text, vGvagente, vConexion)
            If vEsValido Then
                lblerrorLogin.Visible = False

                'CAMBIO EL MODO DE ENVIO POR DEFECTO DEL CLIENTE PARA QUE A LA HORA DE INSERTAR COJA EL QUE A SELECCIONADO DEL COMBO DE MODOS DE ENVIO
                vGgclipr.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue

                'PARA ARTICULO DE COMISION.
                Dim vMenorFechaPrevista As String = ""
                Dim vMenorFechaConfirmada As String = ""
                Dim vNLinComi As Integer = 0

                GestionarRecargoSegunPorte(vCabeceraPed, vGvagente.prop_GGCLIPR_PROV, vConexion) 'RECALCULAMOS PORTES SEGUN RECARGO Y PORTE SELECCINADO.
                Dim vTienePrecDebajoCuc As Boolean = False 'PARA NOTIFICAR EN EMAIL

                CREAR_PEDIDO(vCabeceraPed, Session("lineasPedido"), vMenorFechaPrevista, vMenorFechaConfirmada, vTienePrecDebajoCuc, vNLinComi, vConexion) 'CABECERA, LINEAS, CLASIS DE LINEA (TIRAS Y ROLLOS).

                'GESTIONAMOS COMISIONES.
                Dim vGaartComiDescrip As String = GestionarComisionesDescuentos(vCabeceraPed, Session("agente"), vGgclipr, Session("perfil_usuario"), vNLinComi, vMenorFechaPrevista, vMenorFechaConfirmada, "I")

                Dim vObsPedido As New BCb2b.CObs_pedido()
                Try
                    'INSERTAMOS OBSERVACIONES TRANSPORTE E INTERNA.
                    If Session("perfil_usuario") <> "CL" Then
                        vObsPedido.INSERTAR_OBSERVACION_PEDIDO(vCabeceraPed, ConfigurationManager.AppSettings("Obs_transporte_pedidos"), txtObservacion.Text, vConexion)
                    Else
                        vObsPedido.INSERTAR_OBSERVACION_PEDIDO(vCabeceraPed, ConfigurationManager.AppSettings("Obs_transporte_pedidos_cliente"), txtObservacion.Text, vConexion)
                    End If
                Catch ex As Exception
                    MostrarError("ERROR INSERTING OBSERVATION", ex.Message)
                    Log.Error(ex, "[PedidoValidar.INSERTAR_OBSERVACION_PEDIDO] cab = {@cab} obs = {obs} ", vCabeceraPed, txtObservacion.Text)
                End Try

                vCabeceraPed.prop_OBSERVACION_dEFECTO = txtObservacion.Text

                vObsPedido.INSERTAR_OBSERVACION_PEDIDO(vCabeceraPed, ConfigurationManager.AppSettings("Obs_interna_pedidos"), txtObservacion_interna.Text, vConexion)
                vCabeceraPed.prop_OBSERVACION_interna = txtObservacion_interna.Text

                'PARA QUE EN CASO DE PORTES PAGADOS CREANDO UNA REVISIN, NO COPIE EL DEL PEDIDO ORIGEN Y PONGA 0.
                Dim vPortesNum As Double = 0
                If txtRecargoPortes.Text <> "" Then
                    vPortesNum = CDbl(txtRecargoPortes.Text)
                End If
                InsertarPortesEnPedido(vCabeceraPed, ConfigurationManager.AppSettings("AMC_GS0865_V_GGDTOTIP_IMPORTE"), vPortesNum, vConexion)

                Try
                    'FINALIZAMOS PEDIDO (FUNC SPYRO) PARA RECALCULAR COMISIONES,BLOQUEO CIF, ETC.
                    Dim vCabeceraAux As New BCb2b_AMC.CCabeceraPedido()
                    vCabeceraAux.AmcFinalizarPedido(vCabeceraPed, vNLinComi, vGvagente.prop_COD, lblTotalPedido.Text, ConfigurationManager.AppSettings("CB2B"), vConexion)
                Catch ex As Exception
                    MostrarError("ERROR ENDING ORDER", ex.Message)
                    Log.Error(ex, "[PedidoValidar.AMC_FINALIZAR_PEDIDO] cab = {@cab} lin_comi = {lin_comi} ref = {ref} total = {total} conn = {conn} ", vCabeceraPed, vNLinComi, vGvagente.prop_COD, lblTotalPedido.Text, vConexion)
                End Try

                Me.TIPOPED = vCabeceraPed.prop_serie
                Me.NPED = vCabeceraPed.prop_N_PEDIDO
                Me.GRUPO = vCabeceraPed.prop_empgrupo_cod
                Me.EMPRESA = vCabeceraPed.prop_emp_cod
                Me.TIPVC = vCabeceraPed.prop_tip_vc

                'JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.
                Dim vEstadoAux As String = ConfigurationManager.AppSettings("ESTADO_INTERMEDIO")
                Dim vGgxxccab As New BCb2b.GGXXXCAB(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, vGgclipr.prop_COD, OracleNumber.Null, vEstadoAux, vCabeceraPed.prop_HIST_SN, Now.Date)
                vEstadoAux = vGgxxccab.GGXXXCAB_CALCULA_ESTADO_GGXXXCAB(ConfigurationManager.AppSettings("Pedido"), vConexion)
                vGgxxccab.GGXXXCAB_ACTUALIZA_ESTADO_CABECERA(vEstadoAux, ConfigurationManager.AppSettings("Pedido"), vConexion)
                'FIN JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.

                'AMC_NE255. JCE. 02/09/2016. ASOCIAR CONTACTOS CONFIRMACION AL PEDIDO.
                DesasociarContactosAPedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, vConexion) 'Primero desasociamos, por si es revisin
                AsociarContactosAPedido(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOPED, Me.NPED, vConexion) 'Segundo asociamos

                Dim vPlantilla As String = New PlantillaImpresion().DAME_PLANTILLA_IMPRESION_SEGUN_FPAGO_CLIENTE(vGgclipr, vCabeceraPed, ConfigurationManager.AppSettings("FORMAS_PAGO_PROFORMA"), vConexion)
                Dim vRutaFichero As String = ""
                Try
                    Dim vRep As New BCb2b.CGeneraReport()
                    vRutaFichero = vRep.B2B_GENERA_REPORT_PEDIDO(ConfigurationManager.AppSettings("ReportPedidos"), vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_emp_cod, vTipVc, vCabeceraPed.prop_N_PEDIDO, vCabeceraPed.prop_GGPEDTIP_COD, "S", vPlantilla, ConfigurationManager.AppSettings("Pedido"), "", True)
                Catch ex As Exception
                    MostrarError("ERROR GENERATING PDF", ex.Message.ToString)
                    Log.Error(ex, "[PedidoValidar. CB2B_GENERA_REPORT_PEDIDO] cab = {@cab} planti = {planti} ", vCabeceraPed, vPlantilla)
                End Try

                'Dim rutaFichero As String = ConfigurationManager.AppSettings("pathlocal") & Now.Year & Now.Month & Now.Day & "_" & cabeceraPed.prop_GGCLIPR_COD & "_" & cabeceraPed.prop_GGPEDTIP_COD & "_" & cabeceraPed.prop_N_PEDIDO & "_" & plantilla & ".pdf"

                If (Not String.IsNullOrEmpty(vRutaFichero)) Then
                    Dim vFtp As New BCb2b.ftp()
                    Dim vFichSubido As Boolean = vFtp.SUBIR_FICHERO_FTP_WAIT_X_SECS(ConfigurationManager.AppSettings("pathServFileDocs"), ConfigurationManager.AppSettings("Dir_Pedido"), ConfigurationManager.AppSettings("pathlocal"), vRutaFichero, ConfigurationManager.AppSettings("usuario_ftp"), ConfigurationManager.AppSettings("pass_ftp"), 10)
                    If vFichSubido = False Then 'SI NO LO HA SUBIDO QUE NO INTENTE ADJUNTARLO PORQUE IGUAL DA FALLO.
                        vRutaFichero = ""
                    End If
                End If

                'AMC_NE168 DESTINATARIOS CLI Y AGENTES SELECCIONADOS.
                Dim vDestinatariosCliente As String = ObtenerEmailsCliente()
                Dim vDestinatariosAgente As String = ObtenerEmailsDisCheckeados()
                Dim vDestinatariosInterno As String = ""

                Dim vTitulo As String = GetLocalResourceObject("pedidoRecibido") & ": " & vCabeceraPed.prop_GGPEDTIP_COD.ToUpper & " - " & vCabeceraPed.prop_N_PEDIDO
                Dim vTituloInterno As String = ""
                DAME_TITULO_Y_DESTINATARIOS_EMAIL_INTERNO(Session("perfil_usuario"), Session("agente"), Session("usuario"), vCabeceraPed.prop_serie, vGgclipr, vTituloInterno, vDestinatariosInterno, vConexion)

                Dim vCuerpo As String = DAME_CUERPO_EMAIL_SEGUN_PERFIL(vCabeceraPed, vGgclipr, vTienePrecDebajoCuc, vGaartComiDescrip, Session("perfil_usuario"), "CLI", vConexion)
                Dim vCuerpoAgente As String = DAME_CUERPO_EMAIL_SEGUN_PERFIL(vCabeceraPed, vGgclipr, vTienePrecDebajoCuc, vGaartComiDescrip, Session("perfil_usuario"), "AGE", vConexion)
                Dim vCuerpoInterno As String = DAME_CUERPO_EMAIL_SEGUN_PERFIL(vCabeceraPed, vGgclipr, vTienePrecDebajoCuc, vGaartComiDescrip, Session("perfil_usuario"), "INT", vConexion)

                Dim env As New BCb2b.EnviarMail()
                Try
                    '-------EMAIL CLI-------
                    env.ENVIAR_EMAIL(ConfigurationManager.AppSettings("EmailFrom"), vDestinatariosCliente, vTitulo, vCuerpo, vRutaFichero)
                Catch ex As Exception
                    MostrarError("ERROR SENDING EMAIL TO CUSTOMER", ex.Message)
                    Log.Error(ex, "[PedidoValidar.ENVIAR_EMAIL CLI] email_cli = {email_cli} titu = {titu} ruta = {ruta} ", vDestinatariosCliente, vTitulo, vRutaFichero)
                End Try

                Try
                    '-------EMAIL AGE-------
                    env.ENVIAR_EMAIL(ConfigurationManager.AppSettings("EmailFrom"), vDestinatariosAgente, vTitulo, vCuerpoAgente, vRutaFichero)
                Catch ex As Exception
                    MostrarError("ERROR SENDING EMAIL TO AGENT", ex.Message)
                    Log.Error(ex, "[PedidoValidar.ENVIAR_EMAIL AGE] email_age = {email_age} titu = {titu} ruta = {ruta} ", vDestinatariosAgente, vTitulo, vRutaFichero)
                End Try

                Try
                    '-------EMAIL INT-------
                    env.ENVIAR_EMAIL(ConfigurationManager.AppSettings("EmailFrom"), vDestinatariosInterno, vTituloInterno, vCuerpoInterno, vRutaFichero)
                Catch ex As Exception
                    MostrarError("ERROR SENDING EMAIL TO AMC. PLEASE CONTACT WITH AMC.", ex.Message)
                    Log.Error(ex, "[PedidoValidar.ENVIAR_EMAIL INT] email_int = {email_int} titu = {titu} ruta = {ruta} ", vDestinatariosInterno, vTitulo, vRutaFichero)
                End Try


                'MUESTRA UN LABEL EN LA PANTALLA DE PEDIDODETALLE PARA DECIR A QUIEN SE HA ENVIADO COPIA.
                MOSTRAR_EMAILS_ENVIADOS_DETALLE(vDestinatariosCliente, vDestinatariosAgente)

                Session("cabeceraPed") = Nothing
                Session("lineasPedido") = New List(Of BCb2b.CLineaPedidoOff)
                logeo.Visible = False

                Session("es_reaprovision") = "N"
                Server.Transfer("PedidoDetalle.aspx")
            Else
                lblerrorLogin.Visible = True
            End If
        End If
    End Sub
    Protected Sub btnModificar_Click(sender As Object, e As EventArgs) Handles btnModificar.Click

        Response.Redirect("crearPedido.aspx", True)
    End Sub
    Protected Sub btnCrearCont_Click(sender As Object, e As EventArgs) Handles btnCrearCont.Click
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim vGgclipr As New BCb2b.ggclipr()
        vGgclipr = Session("cliente")

        Dim vContacto As New BCb2b.CContactos()
        vContacto = CREAR_CONTACTO(vEmpgrupoCod, vTipVc, vGgclipr, vConexion)

        Dim vGvagente As New BCb2b.gvagente()
        Dim vGvagenteCod As String = ObtenerAgente(vEmpgrupoCod, vGgclipr, vGvagente)
        CargarListadoEmails(vEmpgrupoCod, vTipVc, vGvagenteCod, vGgclipr.prop_COD, vConexion)
        SeleccionarContactoCreado(vContacto)
    End Sub
    'FIN CLICK BOTONES

    'FUNCIONES
    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        'Session("lineasPedido") = Me.lineasPed
        RDP.DataSource = Session("lineasPedido")
        RDP.DataBind()
    End Sub
    Protected Sub RDP_ItemDataBound(sender As Object, e As RepeaterItemEventArgs) Handles RDP.ItemDataBound
        'ESTO PINTA LOS PRECIOS ESPECIALES EN ROJO
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim fila As BCb2b.CLineaPedidoOff = e.Item.DataItem
            Dim lbl_precio As Label = e.Item.FindControl("lblprecio")
            Dim lbl_dto As Label = e.Item.FindControl("lbldto")
            Dim lbl_total As Label = e.Item.FindControl("lbltotal")
            Dim lblUnidad As Label = e.Item.FindControl("lblUnidad")
            Dim lblcant As Label = e.Item.FindControl("lblcant")

            'PARA PINTAR LA FILA
            Dim td_fila2 As HtmlTableCell = e.Item.FindControl("td_fila2")
            Dim td_fila3 As HtmlTableCell = e.Item.FindControl("td_fila3")
            Dim td_fila4 As HtmlTableCell = e.Item.FindControl("td_fila4")
            Dim td_fila5 As HtmlTableCell = e.Item.FindControl("td_fila5")
            Dim td_fila6 As HtmlTableCell = e.Item.FindControl("td_fila6")
            Dim td_fila7 As HtmlTableCell = e.Item.FindControl("td_fila7")
            Dim td_fila8 As HtmlTableCell = e.Item.FindControl("td_fila8")
            Dim td_fila9 As HtmlTableCell = e.Item.FindControl("td_fila9")
            Dim td_fila10 As HtmlTableCell = e.Item.FindControl("td_fila10")
            Dim td_fila11 As HtmlTableCell = e.Item.FindControl("td_fila11")
            Dim td_fila12 As HtmlTableCell = e.Item.FindControl("td_fila12")

            lblUnidad.Text = fila.prop_GAUNITIP_UNI1
            If fila.prop_GAUNITIP_PR <> "" And fila.prop_C_UNIPR <> "" Then
                lblcant.Text = fila.prop_C_UNIPR
                lblUnidad.Text = fila.prop_GAUNITIP_PR
            End If

            lblcant.Text = CDbl(lblcant.Text).ToString ' para quitar los 4 decimales de la pag anterior.

            If fila.prop_ES_PRECIO_ESP = True Then
                lbl_total.ForeColor = Color.Red
            End If
            'PARA MOSTRAR PRECIO A CONFIRMAR SI PRECIO 0
            If CDbl(fila.prop_I_NETOEMP) = 0 Then
                'SI NO ES UN PEDIDO DE MUESTRA Y TIENE PRECIO 0 PONEMOS "PRECIO A CONFIRMAR"
                If fila.prop_GGPEDTIP_COD <> ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
                    lbl_precio.Attributes.Add("style", "display:none")
                    lbl_total.Attributes.Add("style", "display:none")
                    lbl_dto.Text = GetGlobalResourceObject("general", "lblConfPrecio")
                End If
            End If

            If fila.prop_atencionCosto = True Then
                td_fila2.Attributes.Add("style", "background:Orange")
                td_fila3.Attributes.Add("style", "background:Orange")
                td_fila4.Attributes.Add("style", "background:Orange")
                td_fila5.Attributes.Add("style", "background:Orange")
                td_fila6.Attributes.Add("style", "background:Orange")
                td_fila7.Attributes.Add("style", "background:Orange")
                td_fila8.Attributes.Add("style", "background:Orange")
                td_fila9.Attributes.Add("style", "background:Orange")
                td_fila10.Attributes.Add("style", "background:Orange")
                td_fila11.Attributes.Add("style", "background:Orange")
                td_fila12.Attributes.Add("style", "background:Orange")
            End If
        End If
    End Sub
    Public Overrides Sub VerifyRenderingInServerForm(ByVal control As Control)
    End Sub
    Protected Sub comboModosEnvio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboModosEnvio.SelectedIndexChanged
        lblModosEnvio.Text = comboModosEnvio.SelectedItem.Text
    End Sub
    Private Function DameCabeceraEmail(ByVal pCabeceraPed As CCabeceraPedido, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String) As String
        Dim cabecera_emails As String = ""
        cabecera_emails = cabecera_emails & "<A HREF='http://b2b.amcsa.es' TARGET='_BLANK'><IMG SRC='http://b2b.amcsa.es/images/logoemp.bmp' WIDTH=135 HEIGHT=70 ALT='AMC-MECANOCAUCHO' BORDER='0'></A>"
        'AMC_NE117
        Dim titulo_cabec As String = GetLocalResourceObject("pedidoTramite") 'TRADUCIR
        If (pCabeceraPed.prop_GGPEDTIP_COD = ConfigurationManager.AppSettings("tipo_pedido_muestras")) Then
            titulo_cabec = GetLocalResourceObject("tratamientoMuestras") 'TRADUCIR
        End If
        cabecera_emails = cabecera_emails & " <br/><br/><font color='#0081C6' size='3' face='Verdana, Arial, Helvetica, sans-serif'><strong>" & titulo_cabec & "</strong></font><br/>  "

        Dim el_ggclipr2 As New BCb2b.ggclipr()
        Dim PARAMETRO_moroso2 As New BCb2b.empparam(ConfigurationManager.AppSettings("GGCLIPR_GGESTADO_MOROSO"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD, pConexion)
        'Dim PARAM_MOROSO2 As String = PARAMETRO_moroso2.prop_VALOR
        Dim param2 As New BCb2b.CParametros()
        Dim PARAM_MOROSO2 As String = param2.dame_param("GGCLIPR_GGESTADO_MOROSO", pConexion)
        If (el_ggclipr2.cliente_moroso(pGgclipr.prop_COD, PARAM_MOROSO2, pConexion) And pCabeceraPed.prop_GGESTADO_COD = ConfigurationManager.AppSettings("ESTADO_BLOQUEADO")) Then
            cabecera_emails = cabecera_emails & "<br/><br/><div style='width:70%;margin:0 auto;' ><img src='../../images/alert.png'/> "
            cabecera_emails = cabecera_emails & " <span style='color:#990000;font-weight:bold;font-size:14px;top:-4px;left:5px;position:relative;'>" & GetLocalResourceObject("avisoMoroso")
            cabecera_emails = cabecera_emails & "</span></div><br/>"
        End If

        Return cabecera_emails
    End Function
    Private Function DameCabeceraPedido(ByVal pCabeceraPed As CCabeceraPedido, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String) As String
        Dim forma_pago As New BCb2b.CFPago
        forma_pago = pGgclipr.prop_forma_pago
        'TRADUCIR FORMA DE PAGO
        forma_pago.DameDatosFPago(forma_pago.PROP_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
        lblFormadepago.Text = forma_pago.PROP_DESCRIP

        Dim cabecera_pedido As String = "" '"<div style='float:left !important;width:100%;margin-bottom:10px;'><table width='100%' style='border:1px solid #000;float:left;'>"
        cabecera_pedido = cabecera_pedido & "<br/><div style='float:left !important;width:100% !important;margin-bottom:10px;'>"
        cabecera_pedido = cabecera_pedido & "<table width='100%' style='border:1px solid #000;float:left;'>"
        cabecera_pedido = cabecera_pedido & "<tr><th align='center' colspan='4' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;font-size: 8pt;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:70%;'>" & GetLocalResourceObject("titu1Resource1.Text").ToString.ToUpper & "</th><th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;font-size: 8pt;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:30%;'>" & GetLocalResourceObject("titu2Resource1.Text").ToString.ToUpper & "</th></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lbl1Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & pGgclipr.prop_NOMBRE & " (" & pGgclipr.prop_COD & ")" & "</td><td align='right' style='font-weight:bold;font-size: 8pt;color:gray;'>" & GetLocalResourceObject("Label9Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & lblRSocial.Text & "</td><td style='font-size: 8pt;' align='center'>" & lblDir.Text.ToUpper & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lbl3Resource1.Text").ToString.ToUpper & "</td><td style='font-size:8pt; font-weight:bold;'>" & pCabeceraPed.prop_GGPEDTIP_COD.ToUpper & " - " & pCabeceraPed.prop_N_PEDIDO & "</td><td align='right' style='font-weight:bold;font-size: 8pt;color:gray;'>" & GetLocalResourceObject("lbl4Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;font-weight:bold;'>" & pCabeceraPed.prop_F_PED & "</td><td style='font-size: 8pt;' align='center'>" & lblCP.Text.ToUpper & ", " & lblPoblacion.Text.ToUpper & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lbl5Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & lblRefCli.Text & "</td><td align='right' style='font-weight:bold;font-size: 8pt;color:gray;'>" & GetLocalResourceObject("lbl6Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & lblatte.Text & "</td><td style='font-size: 8pt;' align='center'>" & lblProvi.Text.ToUpper & ", " & lblpais.Text.ToUpper & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lbl7Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & lblPortes.Text & "</td><td align='right' style='font-weight:bold;font-size: 8pt;color:gray;'>" & GetLocalResourceObject("lbl8Resource1.Text").ToString.ToUpper & "</td><td style='font-size: 8pt;'>" & comboModosEnvio.SelectedItem.Text & "</td><td style='font-size: 8pt;' align='center'>" & GetLocalResourceObject("lbltituTel").ToString & ": " & lblTfono.Text & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lblFormaPago.Text").ToString.ToUpper & "</td><td colspan='3' style='font-size: 8pt;'>" & lblFormadepago.Text & "</td><td style='font-size: 8pt;' align='center'>Fax: " & lblFax.Text & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "<tr><td align='right' style='font-size: 8pt;padding: 5px;font-weight:bold;color:gray;'>" & GetLocalResourceObject("lblDomiciliacion.Text").ToString.ToUpper & "</td><td colspan='4' style='font-size: 8pt;'>" & lblDomiciliacion.Text & "</td></tr>"
        cabecera_pedido = cabecera_pedido & "</table>"
        cabecera_pedido = cabecera_pedido & "</div>"
        Return cabecera_pedido
    End Function
    Private Function DamePorDebajoCuc(ByVal tiene_prec_debajo_cuc As Boolean) As String
        'CONTROL PEDIDO CON PRECIO POR DEBAJO DE CUC
        Dim texto_cuc As String = ""
        If tiene_prec_debajo_cuc = True Then
            texto_cuc = texto_cuc & "<br/><font color='orange' size='2' face='Verdana, Arial, Helvetica, sans-serif'><strong>"
            texto_cuc = texto_cuc & GetLocalResourceObject("PrecDebaCuc").ToString.ToUpper
            texto_cuc = texto_cuc & "</strong></font><br/>"
        End If
        Return texto_cuc
    End Function
    Private Function DameListaImpuestos(ByVal cabeceraPed As CCabeceraPedido, ByVal total_impuestos As String, ByVal pConexion As String) As String
        'AMC_NE168 SRA DESCUENTOS RECARGOS
        Dim impRec As New BCb2b.impuestosRecargosPie()
        'IMPUESTOS
        Dim listaImp As ArrayList = impRec.impuestos_pie_pedido_b2b(cabeceraPed.prop_empgrupo_cod, cabeceraPed.prop_emp_cod, cabeceraPed.prop_tip_vc, cabeceraPed.prop_GGPEDTIP_COD, cabeceraPed.prop_N_PEDIDO, pConexion)
        Dim lineas_pedido As String = ""
        If (listaImp.Count > 0) And total_impuestos <> "0,00" Then
            lineas_pedido = lineas_pedido & "<tr valign='middle'><td colspan='4'></td><th align='center' colspan='2' height='23' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("impuestos").ToString.ToUpper
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("baseImp").ToString.ToUpper
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("porCientoValor").ToString.ToUpper
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("elImporte").ToString.ToUpper
            lineas_pedido = lineas_pedido & " 			</th><td>&nbsp;</td> </tr>"
            For k = 0 To listaImp.Count - 1
                lineas_pedido = lineas_pedido & " 		<tr align='center' valign='top' bgcolor='#FFFFFF'> "
                lineas_pedido = lineas_pedido & " 						<td colspan='4'>&nbsp;</td><td colspan='2' height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & listaImp(k).prop_DESCRIP & " </td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaImp(k).prop_I_BASEXT & "</td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaImp(k).prop_PJI_VALOR & "</td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaImp(k).prop_I_DTOREXT & "</td> <td>&nbsp;</td>"
                lineas_pedido = lineas_pedido & " 					</tr> "
            Next
        End If
        lineas_pedido = lineas_pedido & "<tr><td colspan='7'>&nbsp;</td><td colspan='2' style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'><b>" & GetLocalResourceObject("elTotalImpuestos") & ":" & " </b></td>" 'TRADUCIR
        lineas_pedido = lineas_pedido & "<td style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'>" & total_impuestos & "</td>"
        lineas_pedido = lineas_pedido & "</tr>"
        Return lineas_pedido
    End Function
    Private Function DameListaDescuentos(ByVal cabeceraPed As CCabeceraPedido, ByVal total_descuentos As String, ByVal pConexion As String) As String
        Dim impRec As New BCb2b.impuestosRecargosPie()
        'DESCUENTOS
        Dim listaDes As ArrayList = impRec.impuestos_pie_pedido(cabeceraPed.prop_empgrupo_cod, cabeceraPed.prop_emp_cod, cabeceraPed.prop_tip_vc, cabeceraPed.prop_GGPEDTIP_COD, cabeceraPed.prop_N_PEDIDO, pConexion)
        Dim lineas_pedido As String = ""
        If (listaDes.Count > 0) And total_descuentos <> "0,00" Then
            lineas_pedido = lineas_pedido & "<tr valign='middle'><td colspan='4'>&nbsp;</td><th align='center' colspan='2' height='23' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("descuentosRecargos").ToString.ToUpper 'TRADUCIR
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("baseImp").ToString.ToUpper 'TRADUCIR
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("porCientoValor").ToString.ToUpper 'TRADUCIR
            lineas_pedido = lineas_pedido & " 			</th> "
            lineas_pedido = lineas_pedido & " 		<th align='center' height='23' bgcolor='#0081C6' class='titu' style='border:1px solid black;padding: 5px;background-color:#0081C6;font-size: 8pt; font-family: Arial;width:50px !important;'> "
            lineas_pedido = lineas_pedido & GetLocalResourceObject("elImporte").ToString.ToUpper 'TRADUCIR
            lineas_pedido = lineas_pedido & " 			</th><td>&nbsp;</td></tr>"
            For m = 0 To listaDes.Count - 1
                lineas_pedido = lineas_pedido & " 		<tr align='center' valign='top' bgcolor='#FFFFFF'> "
                lineas_pedido = lineas_pedido & " 						<td colspan='4'></td><td colspan='2' height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & listaDes(m).prop_DESCRIP & " </td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaDes(m).prop_I_BASEXT & "</td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaDes(m).prop_PJI_VALOR & "</td> "
                lineas_pedido = lineas_pedido & " 						<td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;width:50px !important;'>" & listaDes(m).prop_I_DTOREXT & "</td><td>&nbsp;</td>"
                lineas_pedido = lineas_pedido & " 					</tr> "
            Next
        End If
        lineas_pedido = lineas_pedido & "<tr><td colspan='7'>&nbsp;</td><td colspan='2'style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'><b>" & GetLocalResourceObject("elTotalDescuentos") & ":" & " </b></td>"
        lineas_pedido = lineas_pedido & "<td style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'>" & total_descuentos & "</td>"
        lineas_pedido = lineas_pedido & "</tr>"
        Return lineas_pedido
    End Function
    Private Function DameObservacionesTrans() As String
        Dim observacion_trans As String = ""
        If txtObservacion.Text <> "" Then
            observacion_trans = observacion_trans & "<tr valign='middle'>"
            observacion_trans = observacion_trans & "<th align='center' colspan='10' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label10Resource1.Text").ToString.ToUpper & "</th>"
            observacion_trans = observacion_trans & "</tr>"
            observacion_trans = observacion_trans & "<tr>"
            observacion_trans = observacion_trans & "<td colspan='10' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & txtObservacion.Text & " </td> "
            observacion_trans = observacion_trans & "</tr>"
        End If
        Return observacion_trans
    End Function
    Private Function DameObservacionesInter() As String
        Dim observacion_inter As String = ""
        If txtObservacion_interna.Text <> "" Then
            observacion_inter = observacion_inter & "<tr valign='middle'> "
            observacion_inter = observacion_inter & "<th align='center' colspan='10' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("LabelObservacionesCabecera.Text").ToString.ToUpper & "</th>"
            observacion_inter = observacion_inter & "</tr>"
            observacion_inter = observacion_inter & "<tr>"
            observacion_inter = observacion_inter & "<td colspan='10' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & txtObservacion_interna.Text & " </td> "
            observacion_inter = observacion_inter & "</tr>"
        End If
        Return observacion_inter
    End Function
    Private Function DameObservacionesCliente(ByVal cabeceraPed As CCabeceraPedido, ByVal cliente As BCb2b.ggclipr, ByVal pConexion As String) As String
        'OBSERVACIONES DE CLIENTE
        Dim obser_cli As String = ""
        Dim param_GGOBSTIP_COD_ALERTA_GGCLIPR As New BCb2b.CParametros()
        obser_cli = param_GGOBSTIP_COD_ALERTA_GGCLIPR.dame_param("GGOBSTIP_COD_ALERTA_GGCLIPR", pConexion)
        Dim metido_titulo_para_cuerpo As Boolean = False
        Dim array_obser_cli As Array = Split(obser_cli, ",")
        Dim titulo_obser_cli As String = ""
        Dim cuerpo_obser_cli As String = ""
        titulo_obser_cli = titulo_obser_cli & " <tr valign='middle'> "
        titulo_obser_cli = titulo_obser_cli & " <th align='center' colspan='10' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'> "
        titulo_obser_cli = titulo_obser_cli & GetLocalResourceObject("observacionesCliente").ToString.ToUpper 'TRADUCIR
        titulo_obser_cli = titulo_obser_cli & " </th> "
        titulo_obser_cli = titulo_obser_cli & " </tr> "
        Dim comentario As String = ""
        For i = 0 To UBound(array_obser_cli)
            Dim ggcliprobs As New BCb2b.GGCLIPROBS(cabeceraPed.prop_empgrupo_cod, ConfigurationManager.AppSettings("venta"), cliente.prop_COD, array_obser_cli(i), pConexion)
            comentario = ggcliprobs.PROP_COMENTARIO
            If (Not comentario = "") Then
                If (metido_titulo_para_cuerpo = False) Then
                    cuerpo_obser_cli = titulo_obser_cli
                    metido_titulo_para_cuerpo = True
                End If
                cuerpo_obser_cli = cuerpo_obser_cli & " <tr align='center' valign='top' bgcolor='#FFFFFF'> "
                cuerpo_obser_cli = cuerpo_obser_cli & " <td colspan='1' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & array_obser_cli(i) & " </td> "
                cuerpo_obser_cli = cuerpo_obser_cli & " <td colspan='8' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & comentario & "</td> "
                cuerpo_obser_cli = cuerpo_obser_cli & " </tr> "
            End If
        Next
        Return cuerpo_obser_cli
    End Function
    Private Function DameObservacionesArticulo(ByVal cabeceraPed As CCabeceraPedido, ByVal pConexion As String) As String
        'OBSERVACIONES DE ARTICULOS POR LNEA
        Dim obser_art As String = ""
        Dim param_GS0880_V_GAARTDESCR_MOSTRAR As New BCb2b.CParametros()
        obser_art = param_GS0880_V_GAARTDESCR_MOSTRAR.dame_param("GS0880_V_GAARTDESCR_MOSTRAR", pConexion)
        Dim metido_titulo_para_cuerpo_art As Boolean = False
        Dim array_obser_art As Array = Split(obser_art, ",")
        Dim titulo_obser_art As String = ""
        Dim cuerpo_obser_art As String = ""
        Dim la_descrip As String = ""
        titulo_obser_art = titulo_obser_art & " <tr valign='middle'> "
        titulo_obser_art = titulo_obser_art & " <th align='center' colspan='10' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'> "
        titulo_obser_art = titulo_obser_art & GetLocalResourceObject("observacionesArticulos").ToString.ToUpper 'TRADUCIR
        titulo_obser_art = titulo_obser_art & " </th> "
        titulo_obser_art = titulo_obser_art & " </tr> "

        titulo_obser_art = titulo_obser_art & " 	<tr valign='middle'><td height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'> "
        titulo_obser_art = titulo_obser_art & GetLocalResourceObject("laLinea").ToString.ToUpper 'TRADUCIR
        titulo_obser_art = titulo_obser_art & " 			</td> "
        titulo_obser_art = titulo_obser_art & " 		<td colspan='2' height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'> "
        titulo_obser_art = titulo_obser_art & GetLocalResourceObject("elArticulo").ToString.ToUpper 'TRADUCIR
        titulo_obser_art = titulo_obser_art & " 			</td> "
        titulo_obser_art = titulo_obser_art & " 		<td colspan='3' height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'> "
        titulo_obser_art = titulo_obser_art & GetLocalResourceObject("laObservacion").ToString.ToUpper 'TRADUCIR
        titulo_obser_art = titulo_obser_art & " 			</td> "
        titulo_obser_art = titulo_obser_art & " 		<td colspan='4' height='23' bgcolor='#FFFFFF' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'> "
        titulo_obser_art = titulo_obser_art & GetLocalResourceObject("elValor").ToString.ToUpper 'TRADUCIR
        titulo_obser_art = titulo_obser_art & " 			</td> </tr>"

        For j = 0 To UBound(array_obser_art)
            'For lines = 0 To Session("lineasPedido")
            For Each lines As BCb2b.CLineaPedidoOff In Session("lineasPedido")
                If lines.prop_C_UNI1 <> "" And lines.prop_GAART_COD <> "" Then
                    Dim gaartdescr As New BCb2b.GAARTDESCR(cabeceraPed.prop_empgrupo_cod, lines.prop_GAART_COD, array_obser_art(j), pConexion)
                    la_descrip = gaartdescr.prop_DESCRIP
                    If (Not la_descrip = "") Then
                        If (metido_titulo_para_cuerpo_art = False) Then
                            cuerpo_obser_art = titulo_obser_art
                            metido_titulo_para_cuerpo_art = True
                        End If
                        cuerpo_obser_art = cuerpo_obser_art & " 		<tr align='center' valign='top' bgcolor='#FFFFFF'> "
                        cuerpo_obser_art = cuerpo_obser_art & " 						<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & lines.prop_N_LIN & " </td> "
                        cuerpo_obser_art = cuerpo_obser_art & " 						<td colspan='2' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & lines.prop_GAART_COD & "</td> "
                        cuerpo_obser_art = cuerpo_obser_art & " 						<td colspan='3' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & array_obser_art(j) & "</td> "
                        cuerpo_obser_art = cuerpo_obser_art & " 						<td colspan='4' height='23' bgcolor='#FFFFFF' style='border-right:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & la_descrip & "</td> "
                        cuerpo_obser_art = cuerpo_obser_art & " 		</tr> "
                    End If
                End If
            Next
        Next
        'If (Not la_descrip = "") Then
        'cuerpo_obser_art = cuerpo_obser_art & "</table></div><br/>"
        'End If
        Return cuerpo_obser_art
    End Function
    Private Function DameFirmaFinal() As String
        'AMC_NE168 FIRMA
        Dim firma_final As String = ""
        firma_final = firma_final & " <div style='clear:both !important;margin-bottom:10px;'><font size='1' face='Verdana, Arial, Helvetica, sans-serif'><strong><font color='#0081C6'>"
        firma_final = firma_final & " <br> "
        firma_final = firma_final & "        Aplicaciones Mecnicas del caucho<br> "
        firma_final = firma_final & "        Departamento de Ventas. AMC-MECANOCAUCHO </font></strong><br> "
        firma_final = firma_final & "        <font color='#0081C6'>Industrialdea Zona A Pab 35<br> "
        firma_final = firma_final & "        Asteasu E-20159 </font><br> "
        firma_final = firma_final & "        <span style='color:gray;'>Tel:</span> + 34 943 696102<br> "
        firma_final = firma_final & "        <span style='color:gray;'>Fax:</span> + 34 943 696219 <br> "
        firma_final = firma_final & "        <span style='color:gray;font-weight:bold'>E-mail:</span> <a href='mailto:sales@amcsa.es'>sales@amcsa.es</a><br> "
        firma_final = firma_final & "        <span style='color:gray;font-weight:bold'>Website:</span> <a href='http://www.amcsa.es'>www.amcsa.es</a><br>  "
        firma_final = firma_final & "        <span style='color:gray;font-weight:bold'>Website:</span> <a href='http://b2b.amcsa.es'>b2b.amcsa.es</a>  "
        firma_final = firma_final & "        </font></div>"
        Return firma_final
    End Function
    Private Function DameInicioTablaLineasPed() As String
        Return "<div style='float:left !important;width:100%;min-width:682px;margin-bottom:10px;'><table width='100%' style='border:1px solid #000;float:left;'>"
    End Function
    Private Function DameFinTablaLineasPed() As String
        Return "</table></div>"
    End Function
    Private Function DameLineasPedido_AGEINT(ByVal total_lineas As String, ByVal cadenaAgente As String, ByVal tipo_perfil As String, ByVal peso_total_pedido As String, ByVal pConexion As String) As String
        Dim lineas_pedido As String = ""
        lineas_pedido = lineas_pedido & "<tr valign='middle'>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:10% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label2Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:10% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("LabelSuRefResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label3Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:9% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("FechaPrevResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:9% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("FechaConfResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label6Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("LabelPesoResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label8Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label4Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label7Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "</tr>"

        For Each linea As BCb2b.CLineaPedidoOff In Session("lineasPedido")
            Dim cant_mostrar As String = linea.prop_C_UNI1
            Dim uni_mostrar As String = linea.prop_GAUNITIP_UNI1
            If linea.prop_GAUNITIP_PR <> "" And linea.prop_C_UNIPR <> "" Then
                cant_mostrar = linea.prop_C_UNIPR
                uni_mostrar = linea.prop_GAUNITIP_PR
            End If

            Dim param As New BCb2b.CParametros()
            Dim series_prec_cero As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_PEDIDO_PREC_CERO"), pConexion) 'series permitidas a precio cero.
            Dim prec_aux As String = linea.prop_PR_PRECIO
            Dim desc_aux As String = linea.prop_descuento_B2B
            Dim prec_tot_aux As String = linea.prop_I_NETOEMP
            If hdn_con_precio_cero.Value = "S" And BCb2b.Listas.Existe(lblSerieCod.Text, series_prec_cero.Split(",")) Then 'Que haya elegido pedido a precio cero y que el tipo pedido permita precio cero.
                prec_aux = "0,00"
                desc_aux = "0"
                prec_tot_aux = "0,00"
            End If

            lineas_pedido = lineas_pedido & "<tr align='center' valign='top' bgcolor='#FFFFFF'> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_GAART_COD & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_su_ref & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & linea.prop_DESCRIP & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_F_ENTRPREV & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_F_ENTRCONF & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & cant_mostrar & " " & uni_mostrar & "</td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & linea.prop_PESO_LIN & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & prec_aux & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & desc_aux & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & prec_tot_aux & " </td> "
            lineas_pedido = lineas_pedido & "</tr>"

            If linea.prop_atencionCosto = True And linea.prop_ObservacionCosto <> "" Then 'OBSERVACION COSTO EN NARANJA
                lineas_pedido = lineas_pedido & "<tr id='linea_atencion_costo' align='center' valign='top' bgcolor='#FFFFFF'> "
                lineas_pedido = lineas_pedido & "<td colspan='10' height='20' style='border:1px solid black;padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;background:Orange'>" & linea.prop_ObservacionCosto & " </td> "
                lineas_pedido = lineas_pedido & "</tr>"
            End If
        Next

        If tipo_perfil <> 2 Then 'cliente
            'linea comision
            lineas_pedido = lineas_pedido & "<tr align='center' valign='top' bgcolor='#FFFFFF'> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>ESPB2B</td><td>&nbsp;</td>"
            lineas_pedido = lineas_pedido & "<td colspan='8' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & cadenaAgente & " </td> "
            lineas_pedido = lineas_pedido & "</tr>"
        End If

        lineas_pedido = lineas_pedido & DameTotalLineasYPortes(total_lineas, peso_total_pedido, pConexion)

        Return lineas_pedido
    End Function
    Private Function DameLineasPedido_CLI(ByVal total_lineas As String, ByVal cadenaAgente As String, ByVal tipo_perfil As String, ByVal peso_total_pedido As String, ByVal pConexion As String) As String
        Dim lineas_pedido As String = ""
        lineas_pedido = lineas_pedido & "<tr valign='middle'>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:10% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label2Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:10% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("LabelSuRefResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label3Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:9% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("FechaPrevResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:9% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("FechaConfResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label6Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("LabelPesoResource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label8Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label4Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "<th align='center' bgcolor='#0081C6' height='23' class='titu' style='border:1px solid black;width:8% !important;background-color:#0081C6;font-size: 8pt; font-family: Arial;'>" & GetLocalResourceObject("Label7Resource1.Text").ToString.ToUpper & "</th>"
        lineas_pedido = lineas_pedido & "</tr>"

        For Each linea As BCb2b.CLineaPedidoOff In Session("lineasPedido")
            Dim cant_mostrar As String = linea.prop_C_UNI1
            Dim uni_mostrar As String = linea.prop_GAUNITIP_UNI1
            If linea.prop_GAUNITIP_PR <> "" And linea.prop_C_UNIPR <> "" Then
                cant_mostrar = linea.prop_C_UNIPR
                uni_mostrar = linea.prop_GAUNITIP_PR
            End If
            lineas_pedido = lineas_pedido & "<tr align='center' valign='top' bgcolor='#FFFFFF'> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_GAART_COD & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_su_ref & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & linea.prop_DESCRIP & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_F_ENTRPREV & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & linea.prop_F_ENTRCONF & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>" & cant_mostrar & " " & uni_mostrar & "</td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & linea.prop_PESO_LIN & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & linea.prop_PR_PRECIO & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & linea.prop_descuento_B2B & " </td> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:right;'>" & linea.prop_I_NETOEMP & " </td> "
            lineas_pedido = lineas_pedido & "</tr>"
        Next

        If tipo_perfil <> 2 Then 'cliente
            'linea comision
            lineas_pedido = lineas_pedido & "<tr align='center' valign='top' bgcolor='#FFFFFF'> "
            lineas_pedido = lineas_pedido & "<td height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:center;'>ESPB2B</td><td>&nbsp;</td> "
            lineas_pedido = lineas_pedido & "<td colspan='8' height='23' bgcolor='#FFFFFF' style='padding: 5px;font-size: 8pt; font-family: Arial;text-align:left;'>" & cadenaAgente & " </td> "
            lineas_pedido = lineas_pedido & "</tr>"
        End If

        lineas_pedido = lineas_pedido & DameTotalLineasYPortes(total_lineas, peso_total_pedido, pConexion)

        Return lineas_pedido
    End Function
    Private Function DameTotalLineasYPortes(ByVal total_lineas As String, ByVal portes_pedido As String, ByVal pConexion As String) As String
        Dim lineas_pedido As String = ""
        lineas_pedido = lineas_pedido & "<tr>"

        If portes_pedido <> "" Then
            lineas_pedido = lineas_pedido & "<td colspan='4'>&nbsp;</td>"
            lineas_pedido = lineas_pedido & "<td colspan='2' style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'><b>" & GetLocalResourceObject("lbltxtPesoTotalPedidoResource1.Text").ToString.ToUpper & " </b></td>"
            lineas_pedido = lineas_pedido & "<td style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'>" & portes_pedido & "</td>"
        Else
            lineas_pedido = lineas_pedido & "<td colspan='7'>&nbsp;</td>"
        End If

        lineas_pedido = lineas_pedido & "<td colspan='2' style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'><b>" & GetLocalResourceObject("lbltxtTotalPedidoResource1.Text").ToString.ToUpper & " </b></td>"

        Dim param As New BCb2b.CParametros()
        Dim series_prec_cero As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_PEDIDO_PREC_CERO"), pConexion) 'series permitidas a precio cero.
        Dim vtotal_lins As String = total_lineas
        If hdn_con_precio_cero.Value = "S" And BCb2b.Listas.Existe(lblSerieCod.Text, series_prec_cero.Split(",")) Then 'Que haya elegido pedido a precio cero y que el tipo pedido permita precio cero.
            vtotal_lins = "0,00"
        End If

        lineas_pedido = lineas_pedido & "<td style='padding: 5px;text-align:right;font-size: 8pt; font-family: Arial;'>" & vtotal_lins & "</td>"
        lineas_pedido = lineas_pedido & "</tr>"
        Return lineas_pedido
    End Function
    Private Function DameTotalPedido(ByVal total_pedido As String, ByVal peso_total As String, ByVal pConexion As String) As String
        Dim lineas_pedido As String = ""

        lineas_pedido = lineas_pedido & "<tr>"
        lineas_pedido = lineas_pedido & "<td colspan='9' style='padding: 5px;text-align:right;font-size: 11pt; font-family: Arial;'><b>" & GetLocalResourceObject("ImportePedidoTotal").ToString.ToUpper & ":" & " </b></td>"

        Dim param As New BCb2b.CParametros()
        Dim series_prec_cero As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_PEDIDO_PREC_CERO"), pConexion) 'series permitidas a precio cero.
        Dim vtotal As String = total_pedido
        If hdn_con_precio_cero.Value = "S" And BCb2b.Listas.Existe(lblSerieCod.Text, series_prec_cero.Split(",")) Then 'Que haya elegido pedido a precio cero y que el tipo pedido permita precio cero.
            vtotal = "0,00"
        End If

        lineas_pedido = lineas_pedido & "<td style='padding: 5px;text-align:right;font-size: 11pt; font-family: Arial;font-weight:bold;'>" & vtotal & "</td>"
        lineas_pedido = lineas_pedido & "</tr>"

        Return lineas_pedido
    End Function
    Private Function DameCuerpoCliente(ByVal contenido As String) As String
        Dim CUERPO As String = ""
        CUERPO = "<html><head><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/Content/Site.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/layout.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/general.css"" type=""text/css"" media=""all""/><style>@import url(""http://b2b.amcsa.es/Ofertas/Content/Site.css"");</style></head><body>"
        CUERPO = CUERPO & contenido
        CUERPO = CUERPO & "</body></html>"
        CUERPO = Replace(CUERPO, "Content/images/", "http://b2b.amcsa.es/Ofertas/Content/images/")
        CUERPO = Replace(CUERPO, "<table border=""0""", "<table border=""0"" align=""left"" style=""border:1px solid !important;margin-bottom:10px !important;width:100%;float:left;""")
        CUERPO = Replace(CUERPO, "<th", "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;""")
        CUERPO = Replace(CUERPO, "<th class=""titu2""", "<th class=""titu2"" colspan=""10""")
        CUERPO = Replace(CUERPO, "id=""leyendaEstado""", "id=""leyendaEstado"" style=""visibility:hidden !important;display:none !important;""")
        CUERPO = Replace(CUERPO, "<td class=""detalle oculto"" align=""left"">False</td>", "")
        CUERPO = Replace(CUERPO, "<td class=""detalle oculto"" align=""left"">True</td>", "")
        CUERPO = Replace(CUERPO, "width=""80""", "width=""100""")
        CUERPO = Replace(CUERPO, "1em", "0.7em")
        CUERPO = Replace(CUERPO, "9.75pt", "0.7em")
        CUERPO = Replace(CUERPO, "0.7em", "8pt")
        'CUERPO = Replace(CUERPO, "background:Orange", "")
        CUERPO = Replace(CUERPO, "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;"" colspan=""2"" class=""titu upper"">", "<th style=""color:#ffffff !important;background:#004F7A !important;padding:10px !important;"" colspan=""2"" class=""titu upper"" bgcolor=""#004F7A"">")

        ''ME CARGO EL COMBO.
        'Dim desde_combo, hasta_combo As Integer
        'desde_combo = CUERPO.IndexOf("<select")
        'hasta_combo = CUERPO.IndexOf("</select>")
        'CUERPO = CUERPO.Remove(desde_combo, hasta_combo - desde_combo)

        CUERPO = Replace(CUERPO, "colspan=""6""", "colspan=""10""")
        Return CUERPO
    End Function
    Private Function DameCuerpoAgente(ByVal contenido As String) As String
        Dim CUERPO_AGENTE As String = ""

        CUERPO_AGENTE = "<html><head><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/Content/Site.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/layout.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/general.css"" type=""text/css"" media=""all""/><style>@import url(""http://b2b.amcsa.es/Ofertas/Content/Site.css"");</style></head><body>"
        CUERPO_AGENTE = CUERPO_AGENTE & contenido
        CUERPO_AGENTE = CUERPO_AGENTE & "</body></html>"

        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "Content/images/", "http://b2b.amcsa.es/Ofertas/Content/images/")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "<table border=""0""", "<table border=""0"" align=""left"" style=""border:1px solid !important;margin-bottom:10px !important;width:100%;float:left;""")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "<th", "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;""")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "id=""leyendaEstado""", "id=""leyendaEstado"" style=""visibility:hidden !important;display:none !important;""")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "<td class=""detalle oculto"" align=""left"">False</td>", "")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "<td class=""detalle oculto"" align=""left"">True</td>", "")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "width=""80""", "width=""100""")
        'ME CARGO EL COMBO.
        'desde_combo = CUERPO_AGENTE.IndexOf("<select")
        'hasta_combo = CUERPO_AGENTE.IndexOf("</select>")
        'CUERPO_AGENTE = CUERPO_AGENTE.Remove(desde_combo, hasta_combo - desde_combo)

        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "textarea", "label style=""border:none !important;""")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "colspan=""6""", "colspan=""10""")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "1em", "0.7em")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "9.75pt", "0.7em")
        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "0.7em", "8pt")

        CUERPO_AGENTE = Replace(CUERPO_AGENTE, "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;"" colspan=""2"" class=""titu upper"">", "<th style=""color:#ffffff !important;background:#004F7A !important;padding:10px !important;"" colspan=""2"" class=""titu upper"" bgcolor=""#004F7A"">")
        Return CUERPO_AGENTE
    End Function
    Private Function DameCuerpoInterno(ByVal contenido As String) As String
        Dim CUERPO_INTERNO As String = ""
        CUERPO_INTERNO = "<html><head><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/Content/Site.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/layout.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/general.css"" type=""text/css"" media=""all""/><style>@import url(""http://b2b.amcsa.es/Ofertas/Content/Site.css"");</style></head><body style='font-size:8pt !important;font-family:Arial !important;'>"
        CUERPO_INTERNO = CUERPO_INTERNO & contenido
        CUERPO_INTERNO = CUERPO_INTERNO & "</body></html>"
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "Content/images/", "http://b2b.amcsa.es/Ofertas/Content/images/")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "<table border=""0""", "<table border=""0"" align=""left"" style=""border:1px solid !important;margin-bottom:10px !important;width:100%;float:left;""")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "<th", "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;""")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "id=""leyendaEstado""", "id=""leyendaEstado"" style=""visibility:hidden !important;display:none !important;""")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "<td class=""detalle oculto"" align=""left"">False</td>", "")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "<td class=""detalle oculto"" align=""left"">True</td>", "")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "width=""80""", "width=""100""")
        'ME CARGO EL COMBO.
        'desde_combo = CUERPO_INTERNO.IndexOf("<select")
        'hasta_combo = CUERPO_INTERNO.IndexOf("</select>")
        'CUERPO_INTERNO = CUERPO_INTERNO.Remove(desde_combo, hasta_combo - desde_combo)

        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "textarea", "label style=""border:none !important;""")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "colspan=""6""", "colspan=""10""")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "1em", "0.7em")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "9.75pt", "0.7em")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "0.7em", "8pt")
        CUERPO_INTERNO = Replace(CUERPO_INTERNO, "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;"" colspan=""2"" class=""titu upper"">", "<th style=""color:#ffffff !important;background:#004F7A !important;padding:10px !important;"" colspan=""2"" class=""titu upper"" bgcolor=""#004F7A"">")
        Return CUERPO_INTERNO
    End Function
    Private Function ObligarASeleccionarEmail(ByVal pEmpgrupoCod As String, ByVal pGvagente As gvagente, ByVal pConexion As String) As Boolean
        'AMC_NE156. OBLIGAMOS A SELECCIONAR ALGUN CHECKBOX DE CLIENTE O A ESCRIBIR EN CORREOS ADICIONALES ALGUNO.
        'AMC_NE173. PARAMETRIZAMOS QUIEN DEBE SELECCIONAR CONTACTO DE CLI O EMAIL (B2B_AVIS).

        'OBTENGO VALOR DE CLASI B2B_AVIS
        Dim vClasiProve As New BCb2b.CGGCLICLASI()
        If pGvagente.prop_GGCLIPR_PROV <> "" Then
            vClasiProve = New BCb2b.CGGCLICLASI(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), pGvagente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("B2B_AVIS"), pConexion)
        End If
        Return (vClasiProve.PROP_GGCLASIF_COD = "S")
    End Function
    Private Function ComprobarSiRealizarPedido(ByVal pObligarASeleccEmail As Boolean) As Boolean
        Dim vRealizarPedido As Boolean = True
        If ObtenerEmailsCliente() = "" And correosAdicionales.Text = "" And pObligarASeleccEmail Then
            vRealizarPedido = False
            If correosAdicionales.Text = "" Then
                correosAdicionales.Focus()
            End If
            RFVCorreosAdic.Visible = True
        End If
        Return vRealizarPedido
    End Function
    Private Function ValidarUsuario(ByVal pEmpgrupoCod As String, ByVal pUsuario As String, ByVal pPassword As String, ByRef pGvagente As BCb2b.gvagente, Optional ByVal pConexion As String = "") As Boolean
        Dim vEsValido As Boolean = False
        If Session("Usuario").prop_cod.ToString.ToUpper = txtLogin.Text.ToUpper Then
            Dim vPerfiles As New BCb2b.USUARIOS_B2B()
            vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            Dim vUsuario As New BCb2b.CUsrnom()
            Dim vUsuarioAux As New BCb2b.CUsuarios()
            If vPerfiles.prop_TIPO_PERFIL = 0 Then 'svt ind ing
                If Session("perfil_usuario") = "ING" Then
                    Dim RESULTADO As String = vUsuarioAux.es_ingeniero(pUsuario.ToUpper, pPassword.ToUpper, pConexion)
                    vEsValido = (RESULTADO <> "")
                ElseIf Session("perfil_usuario") = "IND" Then
                    Dim RESULTADO As String = vUsuarioAux.es_indoor(pUsuario.ToUpper, pPassword.ToUpper, pConexion)
                    vEsValido = (RESULTADO <> "")
                ElseIf Session("perfil_usuario") = "SVT" Then
                    vUsuario = New BCb2b.CUsrnom(Session("usuario").prop_cod)
                    pGvagente = New BCb2b.gvagente(vUsuario.PROP_COD, vUsuario.PROP_PASSWORD, pEmpgrupoCod, "S")
                    vEsValido = pGvagente.prop_validado And pGvagente.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            ElseIf vPerfiles.prop_TIPO_PERFIL = 1 Then 'dis y age
                If Session("perfil_usuario") = "DIS" Then
                    Dim RESULTADO As String = vUsuarioAux.es_agenteConDeposito(pUsuario.ToUpper, pPassword.ToUpper, Session("agente").prop_cod, pConexion)
                    vEsValido = (RESULTADO <> "")
                    pGvagente = Session("agente")
                Else
                    pGvagente = New BCb2b.gvagente(pUsuario.ToUpper, pPassword.ToUpper, pEmpgrupoCod, "N")
                    vEsValido = pGvagente.prop_validado And pGvagente.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            ElseIf vPerfiles.prop_TIPO_PERFIL = 2 Then 'cli
                Dim RESULTADO As String = vUsuarioAux.es_cliente(pUsuario.ToUpper, pPassword.ToUpper)
                vEsValido = (RESULTADO <> "")
            Else
                vEsValido = False
            End If
        End If

        Return vEsValido
    End Function
    Private Sub GestionaTrazabilidadOfe(ByVal pLinea As CLineaPedidoOff, ByRef pTrazaOfeTip As String, ByRef pTrazaOfeNum As String, ByRef pTrazaOfeLin As String)
        Dim vValidador As ITrazabilidadValidator = TrazabilidadValidatorFactory.ObtenerValidador(pLinea.prop_GGOFETIP_COD)
        If (vValidador.Valido(pLinea)) Then
            pTrazaOfeTip = pLinea.prop_GGOFETIP_COD
            pTrazaOfeNum = pLinea.prop_GGOFELIN_N_OFE
            pTrazaOfeLin = pLinea.prop_GGOFELIN_N_LIN
        Else
            pTrazaOfeTip = ""
            pTrazaOfeNum = ""
            pTrazaOfeLin = ""
        End If
    End Sub
    Private Sub GestionaFechasMinimas(ByVal pIndiceLineas As Integer, ByVal pLinea As CLineaPedidoOff, ByRef pFechaMinPrev As String, ByRef pFechaMinConf As String)
        If pFechaMinPrev = "" And pFechaMinConf = "" Then
            pFechaMinPrev = CDate(Now.ToShortDateString).ToString
            pFechaMinConf = CDate(Now.ToShortDateString).ToString
        End If

        If pIndiceLineas = 0 Then
            pFechaMinPrev = pLinea.prop_F_ENTRPREV
            pFechaMinConf = pLinea.prop_F_ENTRCONF
        End If

        If pLinea.prop_F_ENTRPREV <> "" Then
            If CDate(pLinea.prop_F_ENTRPREV) < CDate(pFechaMinPrev) Then
                pFechaMinPrev = CDate(pLinea.prop_F_ENTRPREV).ToString
            End If
        End If

        If pLinea.prop_F_ENTRCONF <> "" Then
            If CDate(pLinea.prop_F_ENTRCONF) < CDate(pFechaMinConf) Then
                pFechaMinConf = CDate(pLinea.prop_F_ENTRCONF).ToString
            End If
        End If
    End Sub
    Private Sub InsertarTirasYRollos(ByVal pLinea As CLineaPedidoOff, ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgxxxtipCod As String, ByVal pNDocum As String, ByVal pNLin As String, ByVal pTipoOfePedAlb As String, ByVal pConexion As String)
        Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
        Dim vTransaccion As IDbTransaction
        vTransaccion = vConexionOle.BeginTransaction

        Try
            'INSERTAMOS CLASIS DE TIRAS Y ROLLOS
            'ANCHO,LARGO,N_TIRAS,TIRAS,N_ROLLOS,ROLLOS,M2,EQUI_UNPR
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_ANCHO"), "", pLinea.prop_ANCHO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_LARGO"), "", pLinea.prop_LARGO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_M2"), "", pLinea.prop_M2, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_EQUI_UNPR"), "", pLinea.prop_EQUI_UNPR, "", False)

            'milian, 16/01/2017 En Spyro no tienen en cuenta el desperdicio. En b2b en la clasi m2 s, pero en la linea del pedido no lo teniamos en cuenta.
            'daba un error al entregar el pedido, ya que tenia en cuenta el valor de la clasi m2.
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_DESPERDICIO"), "", "0", "", True)

            'COMPROBAMOS PARAMETROS PARA INSERTAR CLASI UNMANUAL EN CASO DE QUE EL ARTICULO SEA TE TIRAS ROLLOS, NO ESTE EN
            'GACODBAR Y SEA DE UNIDAD UN
            Dim vGacodbar As New BCb2b.gacodbar()
            Dim vTieneRollos As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(pEmpgrupoCod, pLinea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("ROLL"), pConexion)
            Dim vTieneTiras As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(pEmpgrupoCod, pLinea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("TIRA"), pConexion)
            Dim vGaart As New BCb2b.gaart(pEmpgrupoCod, pLinea.prop_GAART_COD, pConexion)

            If Not vTieneRollos And Not vTieneTiras And vGaart.prop_GAUNITIP_UNI1 = "UN" Then
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_ROLLOS"), "", pLinea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_TIRAS"), "", pLinea.prop_TIRAS, "", False)
            Else
                'SI NO ES UN ARTICULO DE TIPO B (LOS RAROS, EJ: 26103) METEMOS N.TIRAS.
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_N_ROLLOS"), "", pLinea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, ConfigurationManager.AppSettings("TR_N_TIRAS"), "", pLinea.prop_TIRAS, "", False)
            End If

            vTransaccion.Commit()
        Catch ex As Exception
            vTransaccion.Rollback()
            vTransaccion.Dispose()
            MostrarError("ERROR ROLLS AND STRIPES", ex.Message.ToString)
            Log.Error(ex, "[PedidoValidar.INSERTAR_TIRAS_ROLLOS] empgrup = {empgrup} emp = {emp} tip = {tip} tip_ped = {tipped} nped = {nped} numlin = {numlin} tipdocPed = {tipdocPed} lin = {@lin} ", pEmpgrupoCod, pEmpCod, pTipVc, pGgxxxtipCod, pNDocum, pNLin, pTipoOfePedAlb, pLinea)
        Finally
            vConexionOle.Close()
            vConexionOle.Dispose()
        End Try
    End Sub
    Private Function DAME_CUERPO_EMAIL_SEGUN_PERFIL(ByVal pCabeceraPed As CCabeceraPedido, ByVal pGgclipr As ggclipr, ByVal pTienePrecDebajoCuc As Boolean, ByVal pGaartComiDescrip As String, ByVal pPerfil As String, ByVal pTipoEmail As String, ByVal pConexion As String) As String
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(pPerfil)

        'AMC_NE168 CABECERA EMAILS
        Dim vCabeceraEmails As String = DameCabeceraEmail(pCabeceraPed, pGgclipr, pConexion)
        Dim vTextoCuc As String = DamePorDebajoCuc(pTienePrecDebajoCuc)

        Dim vCabeceraPedido As String = DameCabeceraPedido(pCabeceraPed, pGgclipr, pConexion)

        Dim InicioTable As String = DameInicioTablaLineasPed()

        Dim vTotalLineas As String = lblTotalPedido.Text

        Dim vLineasPedidoAge As String = DameLineasPedido_AGEINT(vTotalLineas, pGaartComiDescrip, vPerfiles.prop_TIPO_PERFIL, lblTotalPesoPedido.Text, pConexion) 'aparecen lineas de obser naranja
        Dim vLineasPedidoCli As String = DameLineasPedido_CLI(vTotalLineas, pGaartComiDescrip, vPerfiles.prop_TIPO_PERFIL, lblTotalPesoPedido.Text, pConexion) 'no aparecen lineas de obser naranja

        Dim vTotalDescuentos As String = pCabeceraPed.LEE_DTOS_PIE()
        Dim vTablaDescuentos As String = DameListaDescuentos(pCabeceraPed, vTotalDescuentos, pConexion)

        Dim vTotalImpuestos As String = pCabeceraPed.LEE_IMPUESTOS_PIE()
        Dim vTablaImpuestos As String = DameListaImpuestos(pCabeceraPed, vTotalImpuestos, pConexion)

        Dim vTotalPedido As String = pCabeceraPed.prop_I_PEDEXT
        Dim vTxtTotalpedido As String = DameTotalPedido(vTotalPedido, lblTotalPesoPedido.Text, pConexion)

        Dim vObservacionTrans As String = DameObservacionesTrans()
        Dim vObservacionInter As String = DameObservacionesInter()
        Dim vObservacionClien As String = DameObservacionesCliente(pCabeceraPed, pGgclipr, pConexion)  'OBSERVACIONES DE CLIENTE
        Dim vObservacionArtic As String = DameObservacionesArticulo(pCabeceraPed, pConexion) 'OBSERVACIONES DE ARTICULOS POR LNEA

        Dim vFinTable As String = DameFinTablaLineasPed()

        'AMC_NE168 FIRMA
        Dim vFirmaFinal As String = DameFirmaFinal()

        Dim vContenidoCliente As String = vCabeceraEmails & vCabeceraPedido & InicioTable & vLineasPedidoCli & vTablaDescuentos & vTablaImpuestos & vTxtTotalpedido & vObservacionTrans & vFinTable & vFirmaFinal
        Dim vContenidoAgente As String = vCabeceraEmails & vTextoCuc & vCabeceraPedido & InicioTable & vLineasPedidoAge & vTablaDescuentos & vTablaImpuestos & vTxtTotalpedido & vObservacionTrans & vObservacionInter & vFinTable & vFirmaFinal
        Dim vContenidoInterno As String = vCabeceraEmails & vTextoCuc & vCabeceraPedido & InicioTable & vLineasPedidoAge & vTablaDescuentos & vTablaImpuestos & vTxtTotalpedido & vObservacionTrans & vObservacionInter & vObservacionClien & vObservacionArtic & vFinTable '& firma_final 'NO LES ENTRA CON UNA LINEA Y PREFIEREN QUITARLO.

        Dim CUERPO As String = DameCuerpoCliente(vContenidoCliente)
        Dim CUERPO_AGENTE As String = DameCuerpoAgente(vContenidoAgente)
        Dim CUERPO_INTERNO As String = DameCuerpoInterno(vContenidoInterno)

        If pTipoEmail = "CLI" Then
            Return CUERPO
        ElseIf pTipoEmail = "AGE" Then
            Return CUERPO_AGENTE
        ElseIf pTipoEmail = "INT" Then
            Return CUERPO_INTERNO
        Else
            Return CUERPO
        End If
    End Function
    Private Sub DAME_TITULO_Y_DESTINATARIOS_EMAIL_INTERNO(ByVal pPerfil As String, ByVal pGvagente As gvagente, ByVal pUsrnom As CUsrnom, ByVal pGgpedtipCod As String, ByVal pGgclipr As ggclipr, ByRef pTituloIntRef As String, ByRef pDestinatariosIntRef As String, ByVal pConexion As String)
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(pPerfil)

        Dim vNomagente As String = ""
        Dim vCodAgente As String = ""
        If vPerfiles.prop_TIPO_PERFIL = 1 Then 'age y dis
            vNomagente = pGvagente.prop_NOMBRE
            vCodAgente = pGvagente.prop_COD
        ElseIf vPerfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
            vNomagente = pUsrnom.PROP_COD
            vCodAgente = ""
        End If

        Dim vCadenaAgeMostrar As String = ""
        If vCodAgente <> "" Then
            vCadenaAgeMostrar = vNomagente & " (" & vCodAgente & ")"
        Else
            vCadenaAgeMostrar = vNomagente
        End If

        'TRADUCIR
        Dim vTituloInterno As String = GetLocalResourceObject("pedidoWeb") & " " & pGgclipr.prop_NOMBRE & " (" & pGgclipr.prop_COD & ") " & GetLocalResourceObject("yElAgente") & " " & vCadenaAgeMostrar
        If (pGgpedtipCod = ConfigurationManager.AppSettings("tipo_pedido_muestras")) Then
            vTituloInterno = GetLocalResourceObject("pedidoMuestra") & " " & pGgclipr.prop_NOMBRE & " (" & pGgclipr.prop_COD & ") " & GetLocalResourceObject("yElAgente") & " " & vCadenaAgeMostrar
        End If

        'AQUI OBTENEMOS LOS MAIL DE LA CLASIFICACION CONFIRMS PARA MANDAR A QUIEN CORRESPONDA.
        Dim Asunto_general As String = GetLocalResourceObject("noEmailInterno.Text")
        Dim vObtenerMailing As New CEnvio_Emails()
        vObtenerMailing.DameDestinatarios(Me.GRUPO, Me.TIPVC, ConfigurationManager.AppSettings("CLASI_NACION"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), pGgclipr.prop_COD, ConfigurationManager.AppSettings("TipoPed"), pConexion)
        Dim vDestinatariosInterno As String = vObtenerMailing.PROP_DESTINATARIOS
        If (vDestinatariosInterno = "") Then
            vDestinatariosInterno = vObtenerMailing.PROP_DESTINATARIOS_GENERAL
            vTituloInterno = vTituloInterno & " - " & Asunto_general
        End If

        pTituloIntRef = vTituloInterno
        pDestinatariosIntRef = vDestinatariosInterno
    End Sub
    Private Sub MOSTRAR_EMAILS_ENVIADOS_DETALLE(ByVal pDestinatariosCliente As String, ByVal pDestinatariosAgente As String)
        'ESTO ES PARA MOSTRAR EN PEDIDO DETALLE A QUIENES SE HAN ENVIADO MAIL.
        Dim vCadenaDestinat As String = pDestinatariosCliente & ", " & pDestinatariosAgente
        If pDestinatariosCliente = "" Then
            vCadenaDestinat = pDestinatariosAgente
        End If
        Session("DESTINATARIOS_EMAIL") = vCadenaDestinat
    End Sub
    Private Sub MostrarError(ByVal tipo_error As String, ByVal error_msg As String)
        lblerror.Text = "[" & tipo_error & "]: " & error_msg
        lblerror.Visible = True
        div_lblerror.Visible = True
        div_lblatencion_confim_ofer.Visible = False
    End Sub
    Private Sub CREAR_PEDIDO(ByRef pCabeceraPed As CCabeceraPedido, ByVal vLineasPedido As List(Of BCb2b.CLineaPedidoOff), ByRef pMenorFechaPrevista As String, ByRef pMenorFechaConfirmada As String, ByRef pTienePrecDebajoCuc As Boolean, ByRef pNLinComi As Integer, ByVal pConexion As String)
        Try
            Dim vPerfiles As New BCb2b.USUARIOS_B2B()
            vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

            Dim vGgclipr As New BCb2b.ggclipr(pCabeceraPed.prop_GGCLIPR_COD, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_tip_vc, pConexion)
            Dim vGvagente As New BCb2b.gvagente()
            Dim vGvagenteCod As String = ObtenerAgente(pCabeceraPed.prop_empgrupo_cod, vGgclipr, vGvagente)
            Dim vParam As New BCb2b.CParametros()

            Dim vIndiceLineas As Integer = 0
            Dim vEsPedidoInbox As Boolean = False
            Dim vEsPedidoPrevision As Boolean = False
            Dim vTrazaOfeTip As String = ""
            Dim vTrazaOfeNum As String = ""
            Dim vTrazaOfeLin As String = ""

            'JCE. AMC_NE275. 09/01/2017. Aviso de prevision consumida.
            Dim vListPrevsConsumidas As New ArrayList
            For Each vLinea As BCb2b.CLineaPedidoOff In vLineasPedido
                GestionaTrazabilidadOfe(vLinea, vTrazaOfeTip, vTrazaOfeNum, vTrazaOfeLin) 'SI ALGUNA DE LAS VARIABLES DE TRAZABILIDAD ES VACIA, BORRA TODAS PORQUE SINO DA FALLO.
                If vIndiceLineas = 0 Then
                    Try
                        If vTrazaOfeTip = vParam.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX"), pConexion) Then
                            vEsPedidoInbox = True
                        End If

                        If BCb2b.Listas.Existe(vTrazaOfeTip, vParam.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"), pConexion).Split(",")) Then
                            vEsPedidoPrevision = True
                        End If

                        If vEsPedidoInbox And pCabeceraPed.prop_N_PEDIDO = "" Then 'SI ES UN PEDIDO INBOX Y NO ES UNA REVISION DE PEDIDO INBOX.
                            Log.Information("[PEDIDO VALIDAR. OIBOX] oinb:" & vTrazaOfeTip & "-" & vTrazaOfeNum & " " & Now.ToString)
                            Dim vOfe As New BCb2b.COferta_Cab(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, vTrazaOfeTip, vTrazaOfeNum)
                            Dim vNPedido As Integer = vOfe.confirmar_cabecera_oferta(pCabeceraPed.prop_GGPEDTIP_COD, pConexion)
                            vTrazaOfeTip = ""
                            vTrazaOfeNum = ""
                            vTrazaOfeLin = ""

                            Dim vCab As New BCb2b.GGPEDCAB()
                            vCab.GGPEDCAB_MODIFICA(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, vNPedido, pCabeceraPed.prop_SU_REF_PED, pCabeceraPed.prop_ATTE, pCabeceraPed.prop_RSOCDIR_ENV, "", pCabeceraPed.prop_GGESTADO_COD, pCabeceraPed.prop_rsocial_opc, pCabeceraPed.prop_RSOCCONDI_COD, comboModosEnvio.SelectedValue, pConexion)

                            'Recargamos de nuevo por si ha cambiado algo (estado, etc..)
                            pCabeceraPed = New CCabeceraPedido(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, vNPedido, pConexion)
                        Else
                            'PEDIDO NORMAL
                            Log.Information("[PEDIDO VALIDAR. NORMAL] oinb:" & vTrazaOfeTip & "-" & vTrazaOfeNum & "-" & vTrazaOfeLin & " " & Now.ToString)
                            Dim vEsNueva As Boolean = (pCabeceraPed.prop_N_PEDIDO = "")
                            If (vEsNueva) Then
                                pCabeceraPed.insertar_cabecera_pedido("N", pConexion)
                            Else
                                Dim vConexionOle As String = BCb2b.cconexion_ole.Conexion(pConexion)
                                pCabeceraPed.crearRevisionPedido(vConexionOle, vLinea.prop_N_PEDIDO, lblRefCli.Text, lblatte.Text, lblRSocial.Text, hfdirenvio.Value, comboModosEnvio.SelectedValue)
                                ActualizarPortesPedido(pCabeceraPed, pConexion) 'JCE. 18/10/2016. Actualizamos los portes del pedido.
                            End If
                        End If
                        vLinea.prop_N_PEDIDO = pCabeceraPed.prop_N_PEDIDO 'asignamos el n_pedido a la linea, que fallaban un montn de propiedades de la lnea por faltarle.
                    Catch ex As Exception
                        MostrarError("ERROR CREATING ORDER", ex.Message)
                        Log.Error(ex, "[PedidoValidar.Crear Cabecera Pedido] cab = {@cab}", pCabeceraPed)
                    End Try
                End If
                Dim vNLin As String = ""
                Try
                    Dim vLineaAux As New BCb2b.CLineaPedido()

                    'AMC_NE252. JCE. 06/09/2016. Insertamos los precios segun lo que haya seleccionado en el mensaje, si con precio 0 o no.
                    Dim prec_aux As String = vLinea.prop_PR_PRECIO
                    Dim desc_aux As String = vLinea.prop_descuento_B2B
                    If hdn_con_precio_cero.Value = "S" And EsPedidoPrecioCero(lblSerieCod.Text, pConexion) Then 'Que haya elegido pedido a precio cero y que el tipo pedido permita precio cero.
                        prec_aux = "0"
                        desc_aux = "0"
                    End If
                    'FIN AMC_NE252. JCE. 06/09/2016. Insertamos los precios segun lo que haya seleccionado en el mensaje, si con precio 0 o no.

                    'AMC_NE199. JCE. 11/10/2016. En caso de que sea distribuidor y est haciendo un pedido reaprovisiona, obtenemos el almacn del distribuidor para ponerlo en la lnea.
                    Dim vGaalnomCod As String = ""
                    If pCabeceraPed.prop_GGPEDTIP_COD = ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona") And Session("es_reaprovision") = "S" And Session("perfil_usuario") = "DIS" Then
                        vGaalnomCod = ObtenerAlmacenAsteasu(pConexion)
                    End If
                    'FIN AMC_NE199. JCE. 11/10/2016. En caso de que sea distribuidor y est haciendo un pedido reaprovisiona, obtenemos el almacn del distribuidor para ponerlo en la lnea.

                    vNLin = vLineaAux.insertar_lineas_pedido_b2b(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, "", vTrazaOfeTip, vTrazaOfeNum, vTrazaOfeLin, vLinea.prop_GAART_COD, vLinea.prop_DESCRIP, vLinea.prop_C_UNI1, vLinea.prop_C_UNIPR, prec_aux, vLinea.prop_F_ENTRPREV, vLinea.prop_F_ENTRCONF, "", vLinea.prop_GAUNITIP_PR, vLinea.prop_GGCLIPR_COD, desc_aux, vGaalnomCod, pConexion)

                    'AMC_NE235. JCE. 24/05/2016. Controlar si viene de una prevision para restarle de dicha prevision.

                    If vEsPedidoPrevision Then
                        RestaUnidadesAPrevision(pCabeceraPed, vLineaAux, vTrazaOfeTip, vTrazaOfeNum, vTrazaOfeLin, pConexion)
                        'JCE. AMC_NE275. 09/01/2017. Aviso de prevision consumida.
                        CompruebaSiPrevisionConsumida(vListPrevsConsumidas, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, vTrazaOfeTip, vTrazaOfeNum, pConexion)
                    End If

                    Log.Information("[LINEA DE PEDIDO INSERTADA] lin = {@lin}", vLinea)
                Catch ex As Exception
                    MostrarError("ERROR INSERTING LINE", ex.Message.ToString)
                    Log.Error(ex, "[PedidoValidar.insertar_lineas_pedido_b2b] lin = {@lin}", vLinea)
                End Try

                'PONE LA FECHA MINIMA ENCONTRADA EN LAS LINEAS EN ESTAS VARIABLES
                GestionaFechasMinimas(vIndiceLineas, vLinea, pMenorFechaPrevista, pMenorFechaConfirmada)

                'SI TIENE UN PRECIO POR DEBAJO DEL CUC PERMITIDO LO MARCAMOS EN EL EMAIL INTERNO.
                If vLinea.prop_atencionCosto = True Then
                    pTienePrecDebajoCuc = True
                End If

                If (Not String.IsNullOrEmpty(vNLin)) Then 'INSERTAMOS CLASIFICACIONES DE TIRAS Y ROLLOS.
                    InsertarTirasYRollos(vLinea, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, vNLin, "PED", pConexion)
                End If
                vIndiceLineas = vIndiceLineas + 1
            Next

            EnviarAvisoPrevisionConsumida(pCabeceraPed, vGvagenteCod, vListPrevsConsumidas, pConexion)

            pNLinComi = vIndiceLineas + 1
        Catch ex As Exception
            MostrarError("ERROR CREATING ORDER", ex.Message.ToString)
            Log.Error(ex, "[PedidoValidar.CREAR_PEDIDO] cab = {@cab} lins = {@lins}", pCabeceraPed, vLineasPedido)
        End Try
    End Sub
    Private Sub RestaUnidadesAPrevision(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pLineaPed As BCb2b.CLineaPedido, ByVal pTrazaOfetip As String, ByVal pTrazaOfenum As String, ByVal pTrazaOfelin As String, ByVal pConexion As String)
        Dim vTransaccion As OracleTransaction
        Dim vConn As New OracleConnection()
        vConn.ConnectionString = pConexion
        vConn.Open()
        vTransaccion = vConn.BeginTransaction
        Try
            Dim vGgpedtipCodPrev As String = ""
            Dim vNPedidoPrev As OracleNumber = OracleNumber.Null
            BCb2b.GGOFEXXX_PKG.GGPREVPED_ACTUALIZA(vConn, vTransaccion, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pTrazaOfetip, pTrazaOfenum, pTrazaOfelin, vGgpedtipCodPrev, vNPedidoPrev)
            vTransaccion.Commit()
        Catch ex As Exception
            vTransaccion.Rollback()
            MostrarError("ERROR GGPREVPED_ACTUALIZA", ex.Message)
            Log.Error(ex, "[PedidoValidar.GGOFEXXX_PKG.GGPREVPED_ACTUALIZA] lin = {@lin}", pLineaPed)
        Finally
            vTransaccion.Dispose()
            vConn.Close()
            vConn.Dispose()
        End Try
    End Sub
    Private Sub ActualizarPortesPedido(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pConexion As String)
        Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
        Dim vTransaccion As IDbTransaction
        vTransaccion = vConexionOle.BeginTransaction
        Try
            'JCE. 18/10/2016. Actualizamos los portes del pedido.
            CS_B2B_PED_PKG.CS_B2B_PED_PKG.ACTUALIZAR_PORTES(vTransaccion, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, pCabeceraPed.prop_PORTPAG_SN)
            vTransaccion.Commit()
        Catch ex As Exception
            vTransaccion.Rollback()
            MostrarError("ERROR ACTUALIZANDO PORTES", ex.Message)
            Log.Error(ex, "[PedidoValidar.CS_B2B_PED_PKG.ACTUALIZAR_PORTES] cab = {@cab}", pCabeceraPed)
        Finally
            vConexionOle.Close()
            vConexionOle.Dispose()
            vTransaccion.Dispose()
        End Try
    End Sub
    Private Sub GestionarPortesPedido(ByRef pCabeceraPed As CCabeceraPedido, ByVal pConexion As String)
        'PREPARADO POR SI NO HAY AGENTE: INGENIEROS..
        Dim vGgclipr As New BCb2b.ggclipr(pCabeceraPed.prop_GGCLIPR_COD, pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_tip_vc, pConexion)
        Dim vGvagente As New BCb2b.gvagente()
        Dim vGvagenteCod As String = ObtenerAgente(pCabeceraPed.prop_empgrupo_cod, vGgclipr, vGvagente)

        Try
            Dim vPerfiles As New BCb2b.USUARIOS_B2B()
            vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            GestionarRecargoSegunPorte(pCabeceraPed, vGvagente.prop_GGCLIPR_PROV, pConexion)
            MostrarUOcultarPortes(pCabeceraPed.prop_empgrupo_cod, vGvagente.prop_GGCLIPR_PROV, vGgclipr.prop_forma_pago.PROP_COD, vPerfiles.prop_TIPO_PERFIL, pConexion)
            GestionarTextoAlertaPortes(pCabeceraPed, vGvagente.prop_GGCLIPR_PROV, pConexion)
            CompruebaSiPedidoSuperaPorteMinimo(pCabeceraPed, vGvagente.prop_GGCLIPR_PROV, pConexion)
        Catch ex As Exception
            MostrarError("ERROR GESTIONAR_PORTES_PEDIDO", ex.Message)
            Log.Error(ex, "[PedidoValidar.GESTIONAR_PORTES_PEDIDO] cab = {@cab} tperf = {tperf} paramprofor = {paramprofor} fpagoclie = {fpagoclie} ", pCabeceraPed, Session("perfil_usuario"), ConfigurationManager.AppSettings("FORMAS_PAGO_PROFORMA"), vGgclipr.prop_forma_pago.PROP_COD)
        End Try
    End Sub
    Private Sub CompruebaSiPedidoSuperaPorteMinimo(ByRef pCabeceraPed As CCabeceraPedido, ByVal pGgcliprProv As String, ByVal pConexion As String)
        If PedidoSuperaPorteMinimo(pCabeceraPed, pGgcliprProv, pConexion) Then
            btnValidar.OnClientClick = "javascript:return CrearConfirm(this.name,this.alt,'#PortesPagados');"
            pCabeceraPed.prop_PORTPAG_SN = "S"
            txtRecargoPortes.Text = ""
        Else
            btnValidar.OnClientClick = ""
        End If
        btnValidar.CausesValidation = False
        btnValidar.DataBind()
    End Sub
    Private Function PedidoSuperaPorteMinimo(ByRef pCabeceraPed As CCabeceraPedido, ByVal pGgcliprProv As String, ByVal pConexion As String) As Boolean
        Dim vSupera As Boolean = False
        Dim vClasiProve As New BCb2b.CGGCLICLASI()
        If pGgcliprProv <> "" Then
            vClasiProve = New BCb2b.CGGCLICLASI(pCabeceraPed.prop_empgrupo_cod, ConfigurationManager.AppSettings("compra"), pGgcliprProv, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"), pConexion)
        End If
        If vClasiProve.PROP_VALOR <> "" And hdn_portes_sel.Value <> "N" Then
            If CDbl(lblTotalPedido.Text) >= CDbl(vClasiProve.PROP_VALOR) Then
                vSupera = True
            End If
        End If
        Return vSupera
    End Function
    Private Sub GestionarRecargoSegunPorte(ByVal pCabeceraPed As CCabeceraPedido, ByVal pGgcliprProv As String, ByVal pConexion As String)
        hdn_portes_sel.Value = ddlPortes.SelectedValue
        txtRecargoPortes.Enabled = True
        txtRecargoPortes.BackColor = Color.White
        If hdn_portes_sel.Value = "S" Or hdn_portes_sel.Value = "N" Then
            txtRecargoPortes.Text = ""
            If hdn_portes_sel.Value = "S" And PedidoSuperaPorteMinimo(pCabeceraPed, pGgcliprProv, pConexion) Then 'Si es pagados y el pedido supera porteminimo, no puede introducir portes.
                txtRecargoPortes.Enabled = False
                txtRecargoPortes.BackColor = Color.LightGray
            End If
        ElseIf hdn_portes_sel.Value = "C" And txtRecargoPortes.Text = "" And pCabeceraPed.prop_N_PEDIDO <> "" Then
            Dim vParam As New BCb2b.CParametros()
            Dim vGgdtotipCod As String = vParam.dame_param(ConfigurationManager.AppSettings("AMC_GS0865_V_GGDTOTIP_IMPORTE"), pConexion)
            Dim vPortes As New BCb2b.impuestosRecargosPie(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, vGgdtotipCod, pConexion)
            txtRecargoPortes.Text = vPortes.prop_I_DTOREXT
        End If
    End Sub
    Private Sub GestionarTextoAlertaPortes(ByRef pCabeceraPed As CCabeceraPedido, ByVal pGgcliprProv As String, ByVal pConexion As String)
        Dim vTexto_alerta As String = GetLocalResourceObject("AvisoPortesCargadosResource1.Text")
        Dim vValor As String = ""
        If PermiteModificarPortes(pCabeceraPed.prop_empgrupo_cod, pGgcliprProv, vValor, pConexion) Then
            vTexto_alerta = vTexto_alerta.Replace("<valor>", vValor)
            pCabeceraPed.prop_PORTPAG_SN = ddlPortes.SelectedValue
            hdn_portes_sel.Value = ddlPortes.SelectedValue
        Else
            If pCabeceraPed.prop_direccion_envio.PROP_PAISES_COD = "ESP" Then
                vTexto_alerta = vTexto_alerta.Replace("<valor>", ConfigurationManager.AppSettings("AVISO_RECARGO_PORTES_ESP")) '450
            Else
                vTexto_alerta = vTexto_alerta.Replace("<valor>", ConfigurationManager.AppSettings("AVISO_RECARGO_PORTES_EXT")) '600
            End If
        End If
        lbl_alerta_recargo.Text = vTexto_alerta
    End Sub
    Private Sub MostrarUOcultarPortes(ByVal pEmpgrupoCod As String, ByVal pGgcliprProv As String, ByVal pFpagoCod As String, ByVal pPerfil As String, ByVal pConexion As String)
        Dim vClasiProve As New BCb2b.CGGCLICLASI(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), pGgcliprProv, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"), pConexion)
        Dim vMostrar As Boolean = False

        Dim vFPago As New BCb2b.CFPago()
        If vFPago.DIME_SI_FPAGO_ES_PROFORMA(ConfigurationManager.AppSettings("FORMAS_PAGO_PROFORMA"), pFpagoCod, pConexion) And pPerfil <> 2 Then '<> CLI
            If vClasiProve.PROP_VALOR <> "" Then
                If hdn_portes_sel.Value = "S" Or hdn_portes_sel.Value = "C" Then
                    vMostrar = True
                End If
            End If
        End If

        fila_introducir_portes.Visible = vMostrar
    End Sub
    Private Sub InsertarPortesEnPedido(ByVal pCabeceraPed As CCabeceraPedido, ByVal pParamGgdtotipCod As String, ByVal pPortePedido As String, ByVal pConexion As String)
        If pPortePedido <> "" And IsNumeric(pPortePedido) Then
            Try
                Dim vParam As New CParametros()
                Dim vGgdtotipCod As String = vParam.dame_param(pParamGgdtotipCod, pConexion)
                If vGgdtotipCod <> "" Then
                    pPortePedido = pPortePedido.Replace(",", ".")
                    Dim vGgxxxDtox As New BCb2b.GGXXXDTOX(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, Nothing, Nothing, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, Nothing, Nothing, Nothing, Nothing, vGgdtotipCod, Nothing, Nothing, pPortePedido, Nothing, Nothing, "N", Nothing, "S", Nothing, Nothing, Nothing, Nothing, "N", "N", "S")
                    vGgxxxDtox.Ggxxxdtox_Actualizar(Nothing, Nothing, pPortePedido, Nothing, "N", Nothing, "S", "C", "N", "S", pConexion)
                End If
            Catch ex As Exception
                MostrarError("INSERTAR_PORTES_EN_PEDIDO", ex.Message)
                Log.Error(ex, "[PedidoValidar.INSERTAR_PORTES_EN_PEDIDO] cab = {@cab} paramtipoDto = {paramtipoDto} porte = {porte} ", pCabeceraPed, pParamGgdtotipCod, pPortePedido)
            End Try
        Else
            CustomValidator1.IsValid = False
            CustomValidator1.Validate()
        End If
    End Sub
    Private Sub ControlarQueCabYLinsNoNulo()
        If Session("cabeceraPed") Is Nothing Or Session("lineasPedido") Is Nothing Then
            MostrarMensajeSesionPerdida()
        Else
            Dim vCabeceraPed As New CCabeceraPedido()
            vCabeceraPed = Session("cabeceraPed")

            Dim vListaLineasPed As New List(Of CLineaPedidoOff)
            vListaLineasPed = Session("lineasPedido")

            If vCabeceraPed.prop_GGPEDTIP_COD = "" Or vListaLineasPed.Count = 0 Then
                MostrarMensajeSesionPerdida()
            End If
        End If
    End Sub
    Private Sub MostrarMensajeSesionPerdida()
        Modal.Show(Me, GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "MsgSesionPerdida"), "ALERT", 300, "PedidoConsulta.aspx")
    End Sub
    Private Sub GestionaSiSeriePrecCero(ByVal pConexion As String)
        'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
        If EsPedidoPrecioCero(lblSerieCod.Text, pConexion) Then
            btnValidar.OnClientClick = "javascript:return CrearConfirmValor(this.name,this.alt,'#PedPrecioCero');"
            btnValidar.CausesValidation = False
        End If
    End Sub
    Private Function InsertarComisionAPedido(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgcliprCod As String, ByVal pGgpedtipCod As String, ByVal pNPedido As String, ByVal pNLin As String, ByVal pParamComision As String, ByVal pTextoComiInsert As String, ByVal pUnidad As String, ByVal pFechaPrevista As String, ByVal pFechaConfirmada As String, ByVal pGvagente As gvagente, ByVal pConexion As String) As String
        Dim vGaartComiDescrip As String = ""
        Dim vGaartComi As String = ""
        Dim vAlmacenDef As String = ""
        Try
            Dim vParam As New BCb2b.CParametros()
            vGaartComi = vParam.dame_param(pParamComision, pConexion)
            vGaartComiDescrip = pTextoComiInsert & "." 'ponemos un . para diferenciar de pedido tradicional.
            vGaartComiDescrip = vGaartComiDescrip.Replace("<cod_age>", pGvagente.prop_COD)
            vGaartComiDescrip = vGaartComiDescrip.Replace("<nom_age>", pGvagente.prop_NOMBRE)
            Dim vLineaPedido As New BCb2b.CLineaPedido()
            vLineaPedido.insertar_lineas_pedido_b2b(pEmpgrupoCod, pEmpCod, pTipVc, pGgpedtipCod, pNPedido, "", "", "", "", vGaartComi, vGaartComiDescrip, 1, "", "", pFechaPrevista, pFechaConfirmada, pUnidad, "", pGgcliprCod, "", vAlmacenDef, pConexion)
        Catch ex As Exception
            MostrarError("ERROR INSERTING COMISION", ex.Message.ToString)
            Log.Error(ex, "[PedidoValidar.INSERTAR_COMISION_PEDIDO] empgrup = {empgrup} emp = {emp} tip = {tip} tip_ped = {tip_ped} nped = {nped} lin = {lin} artcomi = {artcomi} artcomidesc = {artcomidesc} fprev = {fprev} fconf = {fconf} gauni = {gauni} cli = {cli} almacen_comi = {almacen_comi}", pEmpgrupoCod, pEmpCod, pTipVc, pGgpedtipCod, pNPedido, pNLin, vGaartComi, vGaartComiDescrip, pFechaPrevista, pFechaConfirmada, pUnidad, pGgcliprCod, vAlmacenDef)
        End Try
        Return vGaartComiDescrip
    End Function
    Private Function GestionarComisionesDescuentos(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pGvagente As BCb2b.gvagente, ByVal pGgclipr As BCb2b.ggclipr, ByVal pPerfil As String, ByVal pConexion As String, Optional ByVal pNLin As String = "", Optional ByVal pFPrev As String = "", Optional ByVal pFConf As String = "", Optional ByVal pOpcion As String = "C") As String
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(pPerfil)

        'POSIBLES VALORES DE pOpcion
        'C --> Consulta (Para leyenda de comisiones o descuentos)
        'I --> Insercin (Para clasi SPED, o SPEDAGEN y art ESPB2B)

        Dim vArtComision As String = ""
        If vPerfiles.prop_TIPO_PERFIL = 1 Then 'AGE O DIS
            Dim vParam As New BCb2b.CParametros()
            Dim vSeriesAplicComi As String = vParam.dame_param(ConfigurationManager.AppSettings("SERIES_APLIC_COMI"), pConexion)
            If BCb2b.Listas.Existe(pCabeceraPed.prop_GGPEDTIP_COD, vSeriesAplicComi.Split(",")) Then 'Comprobamos que la serie es una en la que se aplica comisin.
                vArtComision = GestionarComisiones(pCabeceraPed, pGvagente, pGgclipr, pNLin, pFPrev, pFConf, pOpcion, pConexion)
            End If
        ElseIf vPerfiles.prop_TIPO_PERFIL = 2 Then 'CL
            GestionarDescuentos(pCabeceraPed, pGgclipr, pOpcion, pConexion)
        End If

        comisiones_descuentos.Visible = False
        If GVComisionesDescu.Rows.Count > 0 Then
            comisiones_descuentos.Visible = True
        End If

        Return vArtComision
    End Function
    Private Function GestionarComisiones(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pGvagente As BCb2b.gvagente, ByVal pGgclipr As BCb2b.ggclipr, ByVal pNLin As String, ByVal pFPrev As String, ByVal pFConf As String, ByVal pOpcion As String, ByVal pConexion As String) As String
        Dim vArticuloComision As String = ""
        Select Case pOpcion
            Case "C"
                CargarListadoComisiones(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_tip_vc, pGvagente.prop_COD, pConexion)
            Case "I"
                'PARA LAS COMISIONES, HAY QUE INSERTAR LA SPEDAGEN Y EL ARTICULO ESPB2B AL PEDIDO.
                vArticuloComision = InsertarComisionAPedido(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pGgclipr.prop_COD, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, pNLin, ConfigurationManager.AppSettings("B2B_ART_COMI_AGENTES"), GetLocalResourceObject("TEXTARTCOMI"), "UN", pFPrev, pFConf, pGvagente, pConexion)
                InsertarClasiComiDesc(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, ConfigurationManager.AppSettings("SPEDAGEN"), pConexion)
        End Select
        Return vArticuloComision
    End Function
    Private Sub GestionarDescuentos(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pGgclipr As BCb2b.ggclipr, ByVal pOpcion As String, ByVal pConexion As String)
        Select Case pOpcion
            Case "C"
                CargarListadoDescuentos(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_tip_vc, pGgclipr.prop_COD, pConexion)
            Case "I"
                'PARA LOS DESCUENTOS, HAY QUE INSERTAR LA SPED AL PEDIDO.
                InsertarClasiComiDesc(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGPEDTIP_COD, pCabeceraPed.prop_N_PEDIDO, ConfigurationManager.AppSettings("SPED"), pConexion)
        End Select
    End Sub
    Private Sub InsertarClasiComiDesc(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTivVc As String, ByVal pGgpedtipCod As String, ByVal pNPedido As String, ByVal pGgclatipCod As String, ByVal pConexion As String)
        'INSERTAMOS CLASI SPEDAGEN EN PEDIDO.
        Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
        Dim vTransaccion As IDbTransaction
        vTransaccion = vConexionOle.BeginTransaction
        Try
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(vTransaccion, pEmpgrupoCod, pEmpCod, pTivVc, pGgpedtipCod, pNPedido, "", "PED", "", pGgclatipCod, "", pGgpedtipCod, False)
            vTransaccion.Commit()
        Catch ex As Exception
            vTransaccion.Rollback()
            MostrarError("ERROR INSERTING SPED/SPEDAGEN", ex.Message.ToString)
            Log.Error(ex, "[PedidoValidar.INSERTAR_CLASI_SPED_SPEDAGEN] grupo = {grupo} emp = {emp} tip = {tip} ggpedtip = {ggpedtip} nped = {nped} ", pEmpgrupoCod, pEmpCod, pTivVc, pGgpedtipCod, pNPedido)
        Finally
            vTransaccion.Dispose()
        End Try
    End Sub
    Protected Sub txtRecargoPortes_TextChanged(sender As Object, e As EventArgs) Handles txtRecargoPortes.TextChanged
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim vCabeceraPed As New BCb2b.CCabeceraPedido()
        vCabeceraPed = Session("cabeceraPed")

        'PREPARADO POR SI NO HAY AGENTE: INGENIEROS..
        Dim vGgclipr As New BCb2b.ggclipr(vCabeceraPed.prop_GGCLIPR_COD, vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_tip_vc, vConexion)
        Dim vGvagente As New BCb2b.gvagente()
        Dim vGvagenteCod As String = ObtenerAgente(vCabeceraPed.prop_empgrupo_cod, vGgclipr, vGvagente)

        'AMC_NE251. 
        'Si portes pagados / cargados => Se visualizar el recargo y si el usuario introduce recargo, los portes se cambiarn a cargados.
        'Si los portes son debidos => No saldr el recargo abajo, 
        Dim vPortes As String = hdn_portes_sel.Value
        If txtRecargoPortes.Text <> "" Then
            If hdn_portes_sel.Value = "S" And Not PedidoSuperaPorteMinimo(vCabeceraPed, vGvagente.prop_GGCLIPR_PROV, vConexion) Then 'Si portes son pagados y total pedido supera minimo portes no vamos a mostrar alerta de cargados, ya que se queda en pagados.
                ClientScript.RegisterClientScriptBlock(Me.GetType, "Alerta", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("MsgPortesCargados") & "','info','',300);", True)
                vPortes = "C"
            End If
        ElseIf ddlPortes.SelectedValue = "" Then 'Si no tiene valor asignado porque no tiene permisos para cambiar portes, el del cli.
            Select Case vGgclipr.prop_PORTES_PD
                Case "P"
                    vPortes = "S"
                Case "D"
                    vPortes = "N"
                Case Else
                    vPortes = vGgclipr.prop_PORTES_PD
            End Select
        ElseIf ddlPortes.SelectedValue = "S" Then 'Si est selccionado pagados no hay recargo.
            txtRecargoPortes.Text = ""
        End If
        ddlPortes.SelectedValue = vPortes
        hdn_portes_sel.Value = vPortes
        lblPortes.Text = GetGlobalResourceObject("general", "PORTES" & vPortes)
        vCabeceraPed.prop_PORTPAG_SN = vPortes
        Session("cabeceraPed") = vCabeceraPed
    End Sub
    Protected Sub ddlPortes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddlPortes.SelectedIndexChanged
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        GestionarPortesPedido(Session("cabeceraPed"), vConexion)
    End Sub
    Protected Sub GVEmailCliT_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVEmailCliT.RowDataBound
        'AMC_NE255. JCE. 02/09/2016. Obtenemos los contactos del cliente, y los que tienen clasi email_p checkeados.
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim vConexion As String = Conexion.GenerarStringConexion(me)
            Dim vIndice As Integer
            Integer.TryParse(e.Row.RowIndex, vIndice)
            Dim Pkey As DataKeyArray = GVEmailCliT.DataKeys

            Dim vRsocialCod As String = Pkey.Item(vIndice).Item("prop_rsocial_cod")
            Dim vContactipCod As String = Pkey.Item(vIndice).Item("prop_tipocontacto")
            Dim vNombre As String = Pkey.Item(vIndice).Item("prop_nombrecontacto")

            Dim vChk As New CheckBox
            vChk = e.Row.FindControl("chkRowT")

            Dim vValor As Boolean = False
            Dim vCabeceraPed As New BCb2b.CCabeceraPedido()
            vCabeceraPed = Session("cabeceraPed")
            If vCabeceraPed.prop_N_PEDIDO = "" Then 'Si no hay nmero de pedido es que est haciendo un nuevo pedido.
                'Seleccionamos los contactos de cliente con clasificacin EMAIL_P = S
                Dim vCla As New BCb2b.CRsoccontaCla()
                Dim vTieneEmailP As String = vCla.DameGGLASIFdeGGCLATIP(vRsocialCod, vContactipCod, vNombre, ConfigurationManager.AppSettings("RS"), ConfigurationManager.AppSettings("CLASI_EMAIL_P"), vConexion)
                vValor = (vTieneEmailP = "S")
            Else 'Si tiene nmero de pedido es que es para hacer una revisin.
                'Seleccionamos los contactos de cliente existentes en el pedido origen.
                Dim vCont As New BCb2b.GGPEDCONTDEF()
                vValor = vCont.ExisteContacto(vCabeceraPed.prop_empgrupo_cod, vCabeceraPed.prop_emp_cod, vCabeceraPed.prop_tip_vc, vCabeceraPed.prop_GGPEDTIP_COD, vCabeceraPed.prop_N_PEDIDO, vRsocialCod, vContactipCod, vNombre, "", vConexion)
            End If
            vChk.Checked = vValor
        End If
    End Sub
    Private Sub DesasociarContactosAPedido(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgpedtipCod As String, ByVal pNPedido As String, ByVal pConexion As String)
        Dim vListadoContactosPed As New ArrayList
        Dim vCont As New BCb2b.GGPEDCONTDEF()
        vListadoContactosPed = vCont.ObtenerContactos(pEmpgrupoCod, pEmpCod, pTipVc, pGgpedtipCod, pNPedido, "", pConexion)
        For Each vContac As BCb2b.GGPEDCONTDEF In vListadoContactosPed
            Try
                vCont.GGPEDCONTDEF_ACTUALIZA(pEmpgrupoCod, pEmpCod, pTipVc, pGgpedtipCod, pNPedido, ConfigurationManager.AppSettings("tipoEnv"), vContac.prop_rsocialCod, vContac.prop_contactipCod, vContac.prop_nombre, ConfigurationManager.AppSettings("opcionBorrar"), pConexion)
            Catch ex As Exception
                MostrarError("ASOCIAR_CONTACTOS_A_PEDIDO", ex.Message)
                Log.Error(ex, "[PedidoValidar.DesasignarODesasignarContPed]: Error asignando/desasignando contacto a ped. tipoped = {tipoped} nped = {nped} rsoc = {rsoc} contactip = {contactip} nombre = {nombre} ", pGgpedtipCod, pNPedido, vContac.prop_rsocialCod, vContac.prop_contactipCod, vContac.prop_nombre)
            End Try
        Next
    End Sub
    Private Sub AsociarContactosAPedido(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgpedtipCod As String, ByVal pNPedido As String, ByVal pConexion As String)
        Dim vListadoContactosSel As New ArrayList
        vListadoContactosSel = ObtenerContactosCliTodosCheckeados(pConexion)
        Dim vCont As New BCb2b.GGPEDCONTDEF()
        For Each vContacto As BCb2b.CContactos In vListadoContactosSel
            Try
                vCont.GGPEDCONTDEF_ACTUALIZA(pEmpgrupoCod, pEmpCod, pTipVc, pGgpedtipCod, pNPedido, ConfigurationManager.AppSettings("tipoEnv"), vContacto.PROP_RSOCIAL_COD, vContacto.PROP_CONTACTIP_COD, vContacto.PROP_NOMBRE, ConfigurationManager.AppSettings("opcionActualizar"), pConexion)
            Catch ex As Exception
                MostrarError("ASOCIAR_CONTACTOS_A_PEDIDO", ex.Message)
                Log.Error(ex, "[PedidoValidar.AsignarODesasignarContPed]: Error asignando/desasignando contacto a ped. tipoped = {tipoped} nped = {nped} rsoc = {rsoc} contactip = {contactip} nombre = {nombre} ", pGgpedtipCod, pNPedido, vContacto.PROP_RSOCIAL_COD, vContacto.PROP_CONTACTIP_COD, vContacto.PROP_NOMBRE)
            End Try
        Next
    End Sub
    Private Function PermiteModificarPortes(ByVal pEmpgrupoCod As String, ByVal pGgcliprProv As String, ByRef pValorRef As String, ByVal pConexion As String) As Boolean
        Dim vClasiProve As New BCb2b.CGGCLICLASI()
        If pGgcliprProv <> "" Then
            vClasiProve = New BCb2b.CGGCLICLASI(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), pGgcliprProv, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"), pConexion)
        End If
        pValorRef = vClasiProve.PROP_VALOR
        Return pValorRef <> ""
    End Function
    Private Function CREAR_CONTACTO(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String) As BCb2b.CContactos
        Dim vContacto As New BCb2b.CContactos()
        Try
            'COMPROBAMOS SI EXISTE CONT
            Dim vCompruebaCont As New BCb2b.CContactos()
            vCompruebaCont.Nuevo(pGgclipr.prop_RSOCIAL_COD, comboTipCont.SelectedValue, txtNomCont.Text, pConexion)

            If vCompruebaCont.PROP_RSOCIAL_COD <> "" Then
                'EXISTE CONT POR LO TANTO NO HACEMOS NADA.
                vContacto = vCompruebaCont
                div_lblerror.Visible = True
                lblerror.Text = GetLocalResourceObject("MsgExisteCont")
            Else
                'NO EXISTE CONT POR LO TANTO LO INSERTAMOS.
                Dim TELEFONO, FAX As String
                If txtTelCont.Text <> "" Then
                    TELEFONO = lblPrefijTelCont.Text & " " & txtTelCont.Text
                Else
                    TELEFONO = ""
                End If

                If txtFaxCont.Text <> "" Then
                    FAX = lblPrefijFaxCont.Text & " " & txtFaxCont.Text
                Else
                    FAX = ""
                End If

                Dim vConexionOle As IDbConnection = BCb2b.cconexion_ole.conectar_str(pConexion)
                Dim vTransaccion As IDbTransaction
                vTransaccion = vConexionOle.BeginTransaction
                Try
                    Dim vLlamadaCont As New BCb2b.CContactos(pGgclipr.prop_RSOCIAL_COD, comboTipCont.SelectedValue, txtNomCont.Text, Trim(TELEFONO), Trim(FAX), txtEmailCont.Text, txtComentCont.Text, txtMovilCont.Text)
                    vLlamadaCont.rsoccontact_insertar(pConexion)
                    GGCLICONTDEF_PKG.GGCLICONTDEF_PKG.GGCLICONTDEF_ACTUALIZA(vTransaccion, pEmpgrupoCod, pTipVc, pGgclipr.prop_COD, "*", pGgclipr.prop_RSOCIAL_COD, comboTipCont.SelectedValue, txtNomCont.Text, ConfigurationManager.AppSettings("opcionInsertar"))
                    vTransaccion.Commit()
                Catch ex As Exception
                    vTransaccion.Rollback()
                Finally
                    vTransaccion.Dispose()
                End Try

                vContacto = New BCb2b.CContactos(pGgclipr.prop_RSOCIAL_COD, comboTipCont.SelectedValue, txtNomCont.Text, pConexion)
            End If

            If chkMarcXDefecto.Checked Then
                Dim vLlamadaRSocContac As New BCb2b.CRsoccontaCla()
                vLlamadaRSocContac.InsertaClasiARSocContact(vContacto.PROP_RSOCIAL_COD, vContacto.PROP_CONTACTIP_COD, vContacto.PROP_NOMBRE, ConfigurationManager.AppSettings("RS"), "EMAIL_P", OracleNumber.Null, OracleDateTime.Null, OracleDateTime.Null, "", True, "", pConexion)
            End If

            txtNomCont.Text = ""
            txtMovilCont.Text = ""
            comboTipCont.SelectedIndex = 0
            txtTelCont.Text = ""
            txtFaxCont.Text = ""
            txtComentCont.Text = ""
            txtEmailCont.Text = ""
        Catch ex As Exception
            Log.Error(ex, "[PedidoValidar.btnInsertarCont] cli = {cli} rsocial = {rsocial} tipcont = {tipcont} nomcont = {nomcont} ", pGgclipr.prop_COD, pGgclipr.prop_RSOCIAL_COD, comboTipCont.SelectedValue, txtNomCont.Text)
        End Try
        Return vContacto
    End Function
    Private Sub SeleccionarContactoCreado(ByVal cont_cre As BCb2b.CContactos)
        Dim i As Integer = 0
        For Each row In GVEmailCliT.Rows
            Dim vRsocialCod As String = GVEmailCliT.DataKeys(i).Item("prop_rsocial_cod")
            Dim vContactipCod As String = GVEmailCliT.DataKeys(i).Item("prop_tipocontacto")
            Dim vNombre As String = GVEmailCliT.DataKeys(i).Item("prop_nombrecontacto")

            If vRsocialCod = cont_cre.PROP_RSOCIAL_COD And vContactipCod = cont_cre.PROP_CONTACTIP_COD And vNombre = cont_cre.PROP_NOMBRE Then
                Dim chk As CheckBox = GVEmailCliT.Rows(i).FindControl("chkRowT")
                chk.Checked = True
            End If
            i += 1
        Next
    End Sub
    Private Sub CompruebaSiPrevisionConsumida(ByRef pListPrevsConsu As ArrayList, ByVal pEmpgrupoCod As String, pEmpCod As String, pTipVc As String, ByVal pTrazaGgofetipCod As String, pTrazaNOfe As String, ByVal pConexion As String)
        'JCE. AMC_NE275. 09/01/2017. Aviso de prevision consumida
        If pTrazaNOfe <> "" Then
            Dim vOfe As New BCb2b.COferta_Cab(pEmpgrupoCod, pEmpCod, pTipVc, pTrazaGgofetipCod, CInt(pTrazaNOfe), pConexion)
            If vOfe.prop_ggestado_cod = ConfigurationManager.AppSettings("estado_historico") Then 'Si est historica es que se ha consumido.
                pListPrevsConsu.Add(vOfe)
            End If
        End If
    End Sub
    Private Sub EnviarAvisoPrevisionConsumida(ByVal pCabeceraPed As BCb2b.CCabeceraPedido, ByVal pGvagenteCod As String, ByVal pListPrevsConsu As ArrayList, ByVal pConexion As String)
        If pListPrevsConsu.Count > 0 Then
            Dim vTitulo As String = "Consumed Previsions"
            Dim vContenido As String = "<h3>The order " & pCabeceraPed.prop_GGPEDTIP_COD & "/" & pCabeceraPed.prop_N_PEDIDO & ": " & pCabeceraPed.prop_SU_REF_PED & " has consumed the following previsions:</h3><ul>"
            Dim vDestinatarios As String = ""

            'Obtenemos el mail del responsable de previsiones del cliente con la clasi PRVRESPONS del cliente.
            Dim vClicla As New BCb2b.CGGCLICLASI(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_tip_vc, pCabeceraPed.prop_GGCLIPR_COD, ConfigurationManager.AppSettings("CLASI_PRVRESPONS"), pConexion)
            Dim vUsuario As New BCb2b.USRNOM(vClicla.PROP_VALOR, pConexion)
            AadeEmail(vDestinatarios, vUsuario.prop_E_MAIL)

            For Each vOfe As BCb2b.COferta_Cab In pListPrevsConsu
                vContenido = vContenido & "<li>" & vOfe.prop_ggofetip_cod & "/" & vOfe.prop_N_OFE & ": " & vOfe.prop_su_ref_OFE & "</li>"

                'Obtenemos el mail del responsable de la oferta con clasi PRVRESPONS de la oferta:
                Dim vOfecla As New BCb2b.CGGOFECLASI(pCabeceraPed.prop_empgrupo_cod, pCabeceraPed.prop_emp_cod, pCabeceraPed.prop_tip_vc, vOfe.prop_ggofetip_cod, vOfe.prop_N_OFE, ConfigurationManager.AppSettings("CLASI_PRVRESPONS"), "", pConexion)
                Dim vUsuarioOfe As New BCb2b.USRNOM(vOfecla.PROP_VALOR, pConexion)
                AadeEmail(vDestinatarios, vUsuarioOfe.prop_E_MAIL)
            Next
            vContenido = vContenido & "</ul>"

            'Obtenemos los emails del agente con clasi EMAIL_P de contactos:
            Dim vEmails As New BCb2b.CEnvio_Emails()
            Dim vListaEmailsAge As New ArrayList
            vListaEmailsAge = vEmails.DameDestinatariosAgente(pCabeceraPed.prop_empgrupo_cod, ConfigurationManager.AppSettings("compra"), pGvagenteCod, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"), pConexion)
            For Each vEmail As BCb2b.CEnvio_Emails In vListaEmailsAge
                AadeEmail(vDestinatarios, vEmail.PROP_DESTINATARIOS)
            Next

            'Obtenemos el mail del parmetro para previsiones consumidas:
            Dim vParam As New BCb2b.CParametros()
            AadeEmail(vDestinatarios, vParam.dame_param(ConfigurationManager.AppSettings("PARAM_EMAIL_PREVISION_CONSUMIDA"), pConexion))

            vDestinatarios = vDestinatarios.Remove(vDestinatarios.LastIndexOf(","))

            If vDestinatarios <> "" Then
                Dim env As New BCb2b.EnviarMail()
                env.ENVIAR_EMAIL(ConfigurationManager.AppSettings("EmailFrom"), vDestinatarios, vTitulo, vContenido, "")
            End If
        End If
    End Sub
    Private Sub AadeEmail(ByRef pDestinatariosEmail As String, ByVal pEmail As String)
        If pEmail <> "" Then
            pDestinatariosEmail = pDestinatariosEmail & pEmail & ","
        End If
    End Sub
    Private Function EsPedidoPrecioCero(ByVal pGgpedtipCod As String, ByVal pConexion As String) As Boolean
        'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
        Return (EsPedidoPrecioCeroSN(pGgpedtipCod, pConexion) = "S")
    End Function
    Public Function EsPedidoPrecioCeroSN(ByVal pGgpedtip_cod As String, ByVal pConexion As String) As String
        'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
        Dim vParam As New BCb2b.CParametros()
        Dim vSeriesPrecCero As String = vParam.dame_param(ConfigurationManager.AppSettings("SERIES_PEDIDO_PREC_CERO"), pConexion)
        Dim vValor As String = "N"
        If BCb2b.Listas.Existe(pGgpedtip_cod, vSeriesPrecCero.Split(",")) Then
            vValor = "S"
        End If
        Return vValor
    End Function
    Private Function ObtenerAgente(ByVal pEmpgrupoCod As String, ByVal pGgclipr As BCb2b.ggclipr, ByRef pGvagente As BCb2b.gvagente) As String
        'Devuelve el cod del agente y recarga la variable pGvagente
        Dim vGvagenteCod As String = ""
        If Session("perfil_usuario") <> "CL" Then
            If Not Session("agente") Is Nothing Then
                vGvagenteCod = Session("agente").prop_COD
            Else
                If pGgclipr.prop_GVAGENTE_COD <> "" Then
                    vGvagenteCod = pGgclipr.prop_GVAGENTE_COD
                End If
            End If
        End If
        If vGvagenteCod <> "" Then
            pGvagente = New gvagente(vGvagenteCod, pEmpgrupoCod, 0)
        End If
        Return pGvagente.prop_COD
    End Function
    'FIN FUNCIONES
End Class
