﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb
Partial Class LOV_Tiras_Rollos
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_Tiras_Rollos))
        Me.Form.Attributes.Add("autocomplete", "off")

        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)

        'gaart_cod
        Try
            ctl_gaart.Value = Request.QueryString("textbox").ToString()
        Catch ex As Exception
            ctl_gaart.Value = ""
        End Try

        Dim vGaartCod As String = ctl_gaart.Value
        Dim vClasiTira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
        Dim vClasi As New BCb2b.gaartclasi(vEmpgrupoCod, vGaartCod, vClasiTira, vConexion)
        Dim vEsTiraRollo As String = vClasi.prop_GACLASIF_COD
        If vEsTiraRollo = "" Then
            vEsTiraRollo = "N"
        End If

        If vEsTiraRollo = "N" Then
            RBTNTiras.Checked = False
            RBTNTiras.Enabled = False
            RBTNRollos.Checked = False
            RBTNRollos.Enabled = False
            RBTNAux.Checked = True 'no hay ni tiras ni rollos, articulo sin alguna clasi de ancho o largo.
            lblinfoclasis.Text = GetLocalResourceObject("ArtNoTieneTirasRoll")
            lblinfoclasis.Visible = True
            txtAncho.Enabled = False
            txtLargo.Enabled = False
            txtCantidad.Enabled = False
            btnInsTiraORollo.Visible = False
        End If

        If Not Page.IsPostBack And vEsTiraRollo = "S" Then
            'tboxcantidad
            Try
                ctl_cant.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                ctl_cant.Value = ""
            End Try

            'tboxdescripcion
            Try
                ctl_descrip.Value = Request.QueryString("textbox3").ToString()
            Catch ex As Exception
                ctl_descrip.Value = ""
            End Try

            'lblAncho
            Try
                ctl_ancho.Value = Request.QueryString("textbox4").ToString()
            Catch ex As Exception
                ctl_ancho.Value = ""
            End Try

            'lbllargo
            Try
                ctl_largo.Value = Request.QueryString("textbox5").ToString()
            Catch ex As Exception
                ctl_largo.Value = ""
            End Try

            'lblTiras
            Try
                ctl_ntiras.Value = Request.QueryString("textbox6").ToString()
            Catch ex As Exception
                ctl_ntiras.Value = ""
            End Try

            'lblRollos
            Try
                ctl_nrollos.Value = Request.QueryString("textbox7").ToString()
            Catch ex As Exception
                ctl_nrollos.Value = ""
            End Try

            'lblM2
            Try
                ctl_m2.Value = Request.QueryString("textbox8").ToString()
            Catch ex As Exception
                ctl_m2.Value = ""
            End Try

            'lblEquiUnPr
            Try
                ctl_unpr.Value = Request.QueryString("textbox9").ToString()
            Catch ex As Exception
                ctl_unpr.Value = ""
            End Try

            'lblDesperdicio
            Try
                ctl_desper.Value = Request.QueryString("textbox10").ToString()
            Catch ex As Exception
                ctl_desper.Value = ""
            End Try

            'VALORES AL EDITAR

            'valor cant
            Try
                val_cant.Value = Request.QueryString("textbox11").ToString()
            Catch ex As Exception
                val_cant.Value = ""
            End Try
            txtCantidad.Text = val_cant.Value
            'valor ancho
            Try
                val_ancho.Value = Request.QueryString("textbox12").ToString()
            Catch ex As Exception
                val_ancho.Value = ""
            End Try
            txtAncho.Text = val_ancho.Value
            'valor largo
            Try
                val_largo.Value = Request.QueryString("textbox13").ToString()
            Catch ex As Exception
                val_largo.Value = ""
            End Try
            txtLargo.Text = val_largo.Value

            Try
                son_T_R_M2.Value = Request.QueryString("textbox14").ToString()
            Catch ex As Exception
                son_T_R_M2.Value = ""
            End Try

            'valor desperdicio
            Try
                val_desper.Value = Request.QueryString("textbox15").ToString()
            Catch ex As Exception
                val_desper.Value = ""
            End Try
            If txtCantidad.Text = "" Then
                txtm2.Text = val_desper.Value
            Else
                txtm2.Text = ""
            End If


            lblDesperdicio.Text = ""
            lblCorteIdeal.Text = ""
            lblPlanchas.Text = ""
            lblunim21.Text = ""
            lblunim22.Text = ""
            lblunim23.Text = ""
            lblAreaTotal.Text = ""
            lblAreaUtilizada.Text = ""
            IMGCorte.ImageUrl = "~\App_Themes\general\images\spacer.gif"

            txtAncho.Attributes.Add("onkeydown", "javascript:KeyDownCod();")
            txtAncho.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")
            txtLargo.Attributes.Add("onkeydown", "javascript:KeyDownCod();")
            txtLargo.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")
            txtCantidad.Attributes.Add("onkeydown", "javascript:KeyDownCod();")
            txtCantidad.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")


            If txtAncho.Text = "" Then
                Dim vAncho As New BCb2b.gaartclasi(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("TR_ANCHO"), vConexion)
                txtAncho.Text = vAncho.prop_VALOR
            End If

            If txtLargo.Text = "" Then
                Dim vLargo As New BCb2b.gaartclasi(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("TR_LARGO"), vConexion)
                txtLargo.Text = vLargo.prop_VALOR
            End If


            If txtAncho.Text = "" Or txtLargo.Text = "" Then
                lblinfoLongi.Visible = True
                lblinfoLongi.Text = GetLocalResourceObject("NoAnchoLargo")
                txtAncho.Enabled = False
                txtLargo.Enabled = False
                txtCantidad.Enabled = False
                btnInsTiraORollo.Visible = False
            End If

            control_multi_unipr.Value = "S"
            control_es_art_tipo_B.Value = "N"

            'ESTO LUEGO QUITAR --> COMPROBAR SI TIENE EQUIVALENCIAS Y SI SU UNIDAD ES UN
            Dim vGacodbar As New BCb2b.gacodbar()
            Dim vTieneRollos As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("ROLL"), vConexion)
            Dim vTieneTiras As Boolean = vGacodbar.ExisteGaartEnGacodbarPorGacodtip(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("TIRA"), vConexion)
            Dim vGaart As New BCb2b.gaart(vEmpgrupoCod, vGaartCod, vConexion)

            RBTNRollos.Enabled = vTieneRollos
            RBTNTiras.Enabled = vTieneTiras

            If Not vTieneRollos And Not vTieneTiras And vGaart.prop_GAUNITIP_UNI1 = "UN" Then
                RBTNTiras.Enabled = True
                control_multi_unipr.Value = "N"
                control_es_art_tipo_B.Value = "S"
            End If

            If son_T_R_M2.Value = "T" Then
                RBTNTiras.Checked = True
                Panel_tiras_o_rollos.Visible = True
                Panel_m2.Visible = False
                Panel_resumen.Visible = True
            ElseIf son_T_R_M2.Value = "R" Then
                RBTNRollos.Checked = True
                Panel_tiras_o_rollos.Visible = True
                Panel_m2.Visible = False
                Panel_resumen.Visible = True
            ElseIf son_T_R_M2.Value = "M2" Then
                'RBTNM2.Checked = True
                Panel_tiras_o_rollos.Visible = False
                Panel_m2.Visible = True
                Panel_resumen.Visible = False
            Else
                Panel_tiras_o_rollos.Visible = False
                Panel_m2.Visible = False
                Panel_resumen.Visible = False
            End If

            GestionaLogintudes()

            'JCE. 03/02/2017. He creado una funcion para ver que diferentes casos usamos para deshabilitar las longitudes.
            Dim vDeshabilitamos As Boolean = GestionaSiDeshabilitamosLongitudes(vEmpgrupoCod, vGaartCod, vConexion)
            DeshabilitarLongitudes(vEmpgrupoCod, vDeshabilitamos, vConexion)

            txtAncho.Focus()
        End If
    End Sub
    Private Function GestionaSiDeshabilitamosLongitudes(ByVal pEmpgrupoCod As String, ByVal pGaartCod As String, ByVal pConexion As String) As Boolean
        'Si el articulo es de tipo B.
        If control_es_art_tipo_B.Value = "S" Then
            Return True
        End If

        'Si el artículo es de la familia de Akustikabsorver (03)
        If EsFamiliaAkustikAbsorver(pEmpgrupoCod, pGaartCod, pConexion) Then
            Return True
        End If

        Return False
    End Function
    Private Function EsFamiliaAkustikAbsorver(ByVal pEmpgrupoCod As String, ByVal pGaartCod As String, ByVal pConexion As String) As Boolean
        Dim vGaartClasi As New BCb2b.gaartclasi(pEmpgrupoCod, pGaartCod, ConfigurationManager.AppSettings("CLA_FAMILIA"), pConexion)
        Dim vFamilia As String = vGaartClasi.prop_GACLASIF_COD
        Dim vEsFamilia03 As Boolean = (vFamilia = "03") 'Akustikabsorver
        Return vEsFamilia03
    End Function
    Private Sub DeshabilitarLongitudes(ByVal pEmpgrupoCod As String, ByVal pDeshabilitarCampos As Boolean, ByVal pConexion As String)
        txtAncho.Enabled = Not pDeshabilitarCampos
        txtLargo.Enabled = Not pDeshabilitarCampos
        If pDeshabilitarCampos Then 'Ya que no pueden editar, dejamos las cajas con los valores originales.
            Dim ancho As New BCb2b.gaartclasi(pEmpgrupoCod, ctl_gaart.Value, ConfigurationManager.AppSettings("TR_ANCHO"), pConexion)
            txtAncho.Text = ancho.prop_VALOR
            Dim largo As New BCb2b.gaartclasi(pEmpgrupoCod, ctl_gaart.Value, ConfigurationManager.AppSettings("TR_LARGO"), pConexion)
            txtLargo.Text = largo.prop_VALOR
        End If
    End Sub
    Private Function AsignarATextboxPadre(ByVal tbox_id As String, ByVal valor As String, Optional ByVal n_decim As String = "") As String
        Dim cadena As String = ""
        'cadena = cadena & "window.opener.document.forms[0]." + tbox_id + ".value ='" 'cantidad.
        cadena = cadena & "window.opener.document.getElementById('" & tbox_id & "').value ='" 'cantidad.
        If n_decim = "" Then
            cadena = cadena & valor
        Else
            cadena = cadena & FormatNumber(valor, CInt(n_decim))
        End If
        cadena = cadena & "';"
        Return cadena
    End Function
    Private Function AsignarALabelPadre(ByVal lbel_id As String, ByVal valor As String, Optional ByVal n_decim As String = "") As String
        Dim cadena As String = ""
        'cadena = cadena & "window.opener.document.forms[0]." + lbel_id + ".innerHTML ='" 'cantidad.
        cadena = cadena & "window.opener.document.getElementById('" & lbel_id & "').innerHTML ='"
        If n_decim = "" Then
            cadena = cadena & Trim(valor)
        Else
            cadena = cadena & FormatNumber(valor, CInt(n_decim))
        End If
        cadena = cadena & "';"
        Return cadena
    End Function
    Public Function GestionaNumero(ByVal numero As String, ByVal v_culture As String) As String
        Dim cnum As New BCb2b.Utilities()
        numero = cnum.ConvierteNumSegunCulture(numero, v_culture)
        Return numero
    End Function
    Protected Sub btnInsTiraORollo_Click(sender As Object, e As EventArgs) Handles btnInsTiraORollo.Click
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim vGaartCod As String = ctl_gaart.Value
        Dim vAncho As String = GestionaNumero(txtAncho.Text, Session("cultura"))
        Dim vLargo As String = GestionaNumero(txtLargo.Text, Session("cultura"))

        If RBTNRollos.Checked Then
            son_T_R_M2.Value = "R"
        ElseIf RBTNTiras.Checked Then
            son_T_R_M2.Value = "T"
        End If

        If RBTNRollos.Checked Or RBTNTiras.Checked Then
            If txtAncho.Text <> "" And txtLargo.Text <> "" And txtCantidad.Text <> "" And lblDesperdicio.Text <> "" And RBTNAux.Checked = False Then
                Dim vCantidad As String = GestionaNumero(txtCantidad.Text, Session("cultura"))
                Dim vGaart As New BCb2b.gaart()
                Dim vDescripIdiomaGaart As String = vGaart.AMC_DAME_DESCRIPCION_GAART(vEmpgrupoCod, vGaartCod, Session("idioma_spyro"), vAncho, vLargo, vCantidad, son_T_R_M2.Value, vConexion)

                'CALCULAR UNIDADES M2
                Dim vFm As New BCb2b.MetodosNumericos()
                Dim vM2 As Double = vFm.DameMetrosCuadrados(vAncho, vLargo, vCantidad)

                'CALCULAR EQUI_UNPR --> 1 / (N_TIRAS + R_ROLLOS) --> COMO ES UNO Y OTRO: 1 / N_TIRAS o 1 / N_ROLLOS
                Dim vEquiUnipr As Double = 0
                vEquiUnipr = 1 / CDbl(vCantidad)

                Dim script(10) As String
                script(0) = "<script>"
                script(1) = AsignarATextboxPadre(ctl_cant.Value, vM2, 4) 'CANT
                script(2) = AsignarATextboxPadre(ctl_descrip.Value, vDescripIdiomaGaart) 'DESCRIP
                script(3) = AsignarALabelPadre(ctl_ancho.Value, vAncho) 'ANCHO
                script(4) = AsignarALabelPadre(ctl_largo.Value, vLargo) 'LARGO

                If RBTNTiras.Checked = True Then 'CANT TIRAS
                    script(5) = AsignarALabelPadre(ctl_ntiras.Value, vCantidad)
                Else
                    script(5) = AsignarALabelPadre(ctl_ntiras.Value, "")
                End If

                If RBTNRollos.Checked = True Then 'CANT ROLLOS
                    script(6) = AsignarALabelPadre(ctl_nrollos.Value, vCantidad)
                Else
                    script(6) = AsignarALabelPadre(ctl_nrollos.Value, "")
                End If

                script(7) = AsignarALabelPadre(ctl_m2.Value, vM2, 4) 'M2

                If control_multi_unipr.Value = "S" Then
                    script(8) = AsignarALabelPadre(ctl_unpr.Value, vEquiUnipr.ToString, 4) 'EQUI_UNPR
                End If

                Dim desperdicio_aux As String = ""
                If CDbl(lblDesperdicio.Text) > 0 Then
                    desperdicio_aux = lblDesperdicio.Text
                End If

                script(9) = AsignarALabelPadre(ctl_desper.Value, desperdicio_aux) 'DESPERDICIO
                script(10) = "</" + "script>"

                Dim KK As String = Join(script, "")
                RegisterClientScriptBlock("test", Join(script, ""))
            End If
        End If

        'ESTO ES PARA LANZAR EL ONCHANGE DE LA CAJA DE CANTIDAD PARA QUE CALCULE PRECIOS Y HAGA GUARDAR_LINEA.
        Dim script_act(5) As String
        script_act(0) = "<script>"
        script_act(1) = "opener.changeMyElement('#" + ctl_cant.Value + "');"
        script_act(2) = "self.close();"
        script_act(3) = "</" + "script>"
        Dim KK2 As String = Join(script_act, "")
        RegisterClientScriptBlock("test_act", Join(script_act, ""))
    End Sub
    Protected Sub txtAncho_TextChanged(sender As Object, e As EventArgs) Handles txtAncho.TextChanged
        GestionaLogintudes()
        ScriptManager.GetCurrent(Me.Page).SetFocus(txtAncho)
    End Sub
    Protected Sub txtLargo_TextChanged(sender As Object, e As EventArgs) Handles txtLargo.TextChanged
        GestionaLogintudes()
        ScriptManager.GetCurrent(Me.Page).SetFocus(txtLargo)
    End Sub
    Protected Sub txtCantidad_TextChanged(sender As Object, e As EventArgs) Handles txtCantidad.TextChanged
        GestionaLogintudes()
        ScriptManager.GetCurrent(Me.Page).SetFocus(txtCantidad)
    End Sub
    Private Sub GestionaLogintudes()
        If txtAncho.Text <> "" And txtLargo.Text <> "" And txtCantidad.Text <> "" Then
            If IsNumeric(txtAncho.Text) And IsNumeric(txtLargo.Text) And IsNumeric(txtCantidad.Text) Then
                'AQUI GESTIONAMOS LOS DATOS QUE INTRODUCEN Y CALCULAREMOS EL DESPERDICIO.
                'Ancho y largo original
                Dim vConexion As String = Conexion.GenerarStringConexion(Me)
                Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
                Dim vGaartCod As String = ctl_gaart.Value

                Dim vAncho As New BCb2b.gaartclasi(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("TR_ANCHO"), vConexion)
                Dim vLargo As New BCb2b.gaartclasi(vEmpgrupoCod, vGaartCod, ConfigurationManager.AppSettings("TR_LARGO"), vConexion)
                Dim vAnchoOri, vLargoOri As String
                vAnchoOri = vAncho.prop_VALOR
                vLargoOri = vLargo.prop_VALOR

                Dim vMensajeInfo As String = ""
                Dim vMostrarAviso As Boolean = False
                If CDbl(txtAncho.Text) > CDbl(vAnchoOri) Then
                    txtAncho.Text = vAnchoOri
                    vMostrarAviso = True
                    vMensajeInfo = GetLocalResourceObject("AnchoLargoPermi") & " (" & vAnchoOri & "mm x " & vLargoOri & "mm)."
                End If

                If CDbl(txtLargo.Text) > CDbl(vLargoOri) Then
                    txtLargo.Text = vLargoOri
                    vMostrarAviso = True
                    vMensajeInfo = GetLocalResourceObject("AnchoLargoPermi") & " (" & vAnchoOri & "mm x " & vLargoOri & "mm)."
                End If

                lblinfoLongi.Visible = vMostrarAviso
                If vMostrarAviso Then
                    lblinfoLongi.Text = vMensajeInfo
                Else
                    lblinfoLongi.Text = ""
                End If

                If Not vMostrarAviso Then 'si va todo bien
                    'Calculamos desperdicio
                    Dim vCorteDesper As New BCb2b.CCorte_Desperdicio(vAnchoOri, vLargoOri, txtAncho.Text, txtLargo.Text, txtCantidad.Text, Session("cultura"))
                    vCorteDesper.CALCULAR_DESPERDICIO()
                    lblDesperdicio.Text = FormatNumber(vCorteDesper.prop_DESPERDICIO, 4)
                    lblAreaTotal.Text = FormatNumber(vCorteDesper.prop_AREA_TOTAL, 4)
                    lblAreaUtilizada.Text = FormatNumber(vCorteDesper.prop_AREA_UTILIZADA, 4)

                    If vCorteDesper.prop_CORTE_HORI Then
                        lblCorteIdeal.Text = GetLocalResourceObject("Horizontal")
                        IMGCorte.ImageUrl = "~\Content\images\horizontal.jpg"
                    Else
                        lblCorteIdeal.Text = GetLocalResourceObject("Vertical")
                        IMGCorte.ImageUrl = "~\Content\images\vertical.jpg"
                    End If
                    lblPlanchas.Text = vCorteDesper.prop_N_PLANCHAS_GASTADAS
                    lblunim21.Text = "m²"
                    lblunim22.Text = "m²"
                    lblunim23.Text = "m²"
                End If
            End If
        Else
            lblAreaTotal.Text = ""
            lblAreaUtilizada.Text = ""
            lblDesperdicio.Text = ""
            lblCorteIdeal.Text = ""
            lblPlanchas.Text = ""
            lblunim21.Text = ""
            lblunim22.Text = ""
            lblunim23.Text = ""
            IMGCorte.ImageUrl = "~\App_Themes\general\images\spacer.gif"
        End If
    End Sub
    Protected Sub RBTNTiras_CheckedChanged(sender As Object, e As EventArgs) Handles RBTNTiras.CheckedChanged
        If RBTNTiras.Checked Or RBTNRollos.Checked Then
            Panel_tiras_o_rollos.Visible = True
            Panel_m2.Visible = False
            Panel_resumen.Visible = True
            son_T_R_M2.Value = "T"
        End If
        UpLongitudes.Update()
    End Sub
    Protected Sub RBTNRollos_CheckedChanged(sender As Object, e As EventArgs) Handles RBTNRollos.CheckedChanged
        If RBTNRollos.Checked Or RBTNTiras.Checked Then
            Panel_tiras_o_rollos.Visible = True
            Panel_m2.Visible = False
            Panel_resumen.Visible = True
            son_T_R_M2.Value = "R"
        End If
        UpLongitudes.Update()
    End Sub
End Class
